;@#$t0 c m10 l0;margin=10
page	60,128
title	Tall Tree Systems JBOOT (64k and 256k chips)

;************************************************
;*             JBOOT  2.90 (runs on AT)		*
;*     Copyright(c)1984,85 Tall Tree Systems  	*
;************************************************

; written for Tall Tree Systems by Hugh Macdonald
;				and John Henderson

; Jan 20,1985
.radix 16 
;------NON-LOCAL SEGMENTS--------------
abs0	segment at 0
zero	=	0	;for jram turn-on
jbflag =	158h	;loc of external jbootflag
dossize	=	413h	;size of DOS in Kbytes
keybdreset=	472h	;=1234 if keyboard contrl alt del
	org	0
zeroaddr label	byte	;for self mod code jumps
abs0	ends

;---------------------------------------------------;
; JBOOT SEGMENT,  LOADABLE DEVICE DRIVER, ORG at 0  ;
;---------------------------------------------------;
cseg group mainseg;,stackseg,testseg,subseg,initseg
mainseg	segment para public 'code'
jboot	proc	far
assume	cs:cseg,ds:cseg,es:abs0
start	equ	$
begin:

;--Misc Equates
bit0 = 1	;for bit setting and clearing
bit1 = 2
bit2 = 4
bit3 = 8
bit4 = 10
bit5 = 20
bit6 = 40
bit7 = 80
;.....................................................

;==============beginning of CODE======================
; device header dintr gives entry address
nxtdev	dd	-1	;dw ptr to next dev, filled by DOS
attrib	dw	0C000h	;w  char device/ioctl supported
dstrat	dw	strat	;w  ptr to device strategy
dintr	dw	intr	;w  ptr to device interrupt handler
pname	db	'$JBOOT  ' ;8 byte string=device name
serno	db	'000001',0
copyw	db	'Copyright(c)1984,85 Tall Tree Systems',0
verno	db	' Ver 2.90 Ser.#',0
	db	0
;----------END of DEVICE HEADER-----------------------------

;--PAGE ZERO and INIT values
;-- Flags ,Data and Counters (Input and Output)--
memtestopt=bit0
zerointopt=bit1
div0opt=bit2
parityopt=bit3
cadopt=bit4
flushopt=bit5
batchopt=bit6
jramopt=bit7

quietopt=bit0
timeopt=bit1

initflag1 db	0	;see defaultstr for defaults
initflag2 db	0
initflag3 db	0
jbootvec db	68	;int 68 = partition vector (???)

;copy of [158+] flag,ram-jram,swap-maxtonmem,jdrbeg-size
; do not alter order of variables below
jbflagtab:
origdosk dw	0040	;copy of [413] upon entry
doskwanted dw	0040	;#k wanted in dos (default=entry vals)

jbcopsize=$
jbflagcop dw	0000	;158 copy of [158]=1111 if reboot
memtestf  db	1	;15A 1=fill only (see defaultstr)
nbadbanks  db	0	;15B #bad banks found
datelow	dw	070A	;15C dh=month (1,2,etc.),dl=day
datehi	dw	07C0	;15E cx= has year 1980-2099
nines	dw	9999	;160 jboot int 58 default (i.e. no int 58)
nineshi dw	0000	;162 int 58
jdr1bank dw	0FFF	;164 bank# of 1st jdrive
jdr2bank dw	0FFF	;166 bank# of 2nd jdrive
jdr3bank dw	0FFF	;168 3rd
jdr4bank dw	0FFF	;16A 4th
jbcopsize=($-jbcopsize+1)/2  ;#words in region
	 dw	0FFFF	;0= end of jdrive list

;--Table of offsets sent as cs:offset (double words) by iocontrol
accessbanktab:
	dw	offset cseg:membanks		;(0)
	dw	offset cseg:accessbank		;(+2)
	dw	offset cseg:setbankfree		;(+4)
	dw	offset cseg:turnoffbank		;(+6)
	dw	offset cseg:testbankinuse	;(+8)
	dw	offset cseg:accessbankswap	;(+A)
	dw	offset cseg:turnoffbankswap	;(+C)
bankinuse	db	0			;(+E)
miscflag	db	0			;(+F)
	dw	offset cseg:porttab		;(+10)

;--Request Header Info & Stack
;rhoff	dw	0	;req hdr ptr set by strat
;rhseg	dw	0	;(see setesbx subroutine)
savdx	dw	0	;calling prog ds:dx
savds	dw	0	;calling data seg
savsp	dw	0	;system stack ptr save
savss	dw	0	;system stack segment save

;================CHECKSUM AREA===================
beginchecksum=$		;used to calc checksumsize
;---INTERRUPT VECTOR STORAGE (vec 0-1f, addr 0-7F)---
intvectable:		;see p 3-3 of tech manual
intvec00	dd	0	;div0 err
intvec01	dd	0	;single step
intvec02	dd	0	;nmi (parity)
intvec03	dd	0	;int 3 breakpt
intvec04	dd	0	;overflow
intvec05	dd	0	;print screen
intvec06	dd	0	;
intvec07	dd	0	;
;---below are restored by proms----
intvec08	dd	0	;timer int
intvec09	dd	0	;keybd int
intvec0A	dd	0	;
intvec0B	dd	0	;
intvec0C	dd	0	;serial irq (irq4)
intvec0D	dd	0	;
intvec0E	dd	0	;diskette int
intvec0F	dd	0	;parallel irq (irq7)
intvec10	dd	0	;video io
intvec11	dd	0	;equip code
intvec12	dd	0	;memsize determine
intvec13	dd	0	;diskette io
intvec14	dd	0	;serial com port
intvec15	dd	0	;cassette
intvec16	dd	0	;keyboard io
intvec17	dd	0	;parallel printer
intvec18	dd	0	;rom basic
intvec19	dd	0	;bootstrap
intvec1A	dd	0	;time of day
intvec1B	dd	0	;keyboard loop (break)
intvec1C	dd	0	;tick loop 18/sec
intvec1D	dd	0	;ptr video init table
intvec1E	dd	0	;ptr diskette param table
intvec1F	dd	0	;ptr graphics table
;...............end of interrupt table.................

;Serial/Parallel port addresses (from 0:400-407 and 408-40F)
;8 COM ports, 4 PARRALLEL ports

porttab	db	10 dup(0)	;8 COM ports (filled in by init)
	dw	0,0,0,0		;4 PARALLEL ports
;...............end of port table......................

;--------------JBOOT MAIN PROCEDURES--------------------
assume cs:cseg,ds:cseg,es:cseg,ss:cseg

;======== DOS COMMAND PROCESSING ============

;--- STRATEGY ENTRY  (to be used by DOS 3.0?)
;  generally save ES:BX as pointer to Req Hdr
strat:	call	setesbx		;store rhoff,rhseg
;	mov	cs:rhoff,bx    ;es:bx has req hdr ptr
;	mov	cs:rhseg,es
	ret	; note es:bx remains at intr entry

;--- DEVICE INTERRUPT ENTRY (Main entry,executes command code)
intr:	cld
	push	ax
	push	cx
	push	dx
	push	di
	push	si
	push	bp
	push	ds

	mov	ax,cs
	mov	ds,ax		;ds=cs (local addressing)
	mov	[savsp],sp
	mov	[savss],ss	;(pg 14-10 use internal stack)
	cli			;no irq while stack half changed
	mov	ss,ax
	mov	sp,offset cseg:begsp; internal stack
	sti
	lds	bx,dword ptr [rhoff]	;obtain req hdr ptrs
; get command and jump to routine
	mov	al,[bx+2]	;rhcmd get command code
	cmp	al,1		;ioctl?
	jae	iocontrol	;yes
	jmp	init		;no,init

;---IOCONTROL processing ---
; calling prog sets ds:dx=buffer, cx=count of chrs, al=operation (in/out)
; ah=44 (iocontrol) and calls int21
; "in"  (orig al=2) sends addr of table and routines to calling prog
; "out" (orig al=3) transfers control to jboot for reboot (see new58)
iocontrol:
	mov	cx,[bx+12]	;cx from calling prog
	les	di,dword ptr[bx+0E] ;es:di=ds:dx from calling prog
	cmp	al,3		;ioctl in (orig al=2 "in")?
	jne	ioct40		;no

;cx=count of transfers (double words),  es:di=buffer to fill (was ds:dx)
	mov	si,offset cseg:accessbanktab
	push	cs
	pop	ds		;ds:si=table of info, es:di=buffer
	mov	ax,cs		;send segment also
	jcxz	ioct30		;only send loc of accessbanktab
ioct20:	movsw			;transfer offset
	stosw
	loop	ioct20		;do all offsets
	jmp	short ioct90
ioct30:	mov	es:[di],si	;accessbanktab addr
	inc	di
	inc	di
	stosw			;cs (seg)
	jmp	short ioct90

;iocontrol output routine (Makedos reboot, ds:bx=rq hdr,es:di=user prog)
ioct40:	cmp	al,0C		;ioctl out (al=3 "out")
	jne	ioct90		;no
	jmp	makedos		;yes, do reboot
ioct90:

;---CMD EXIT  (all DOS calls return here.)------
cmdexit:
	les	bx,dword ptr [rhoff]	;obtain req hdr ptrs
	or	es:word ptr[bx+3],100h   ;status set done,bit 9
	cli
	mov	ss,cs:[savss]
	mov	sp,cs:[savsp]  ;restore DOS stack
	sti
	pop	ds
	pop	bp
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	ax
	ret
checksumsize =	($-offset beginchecksum) ;#byte summed
checksum	dw	0
;....... END OF CHECKSUM AREA ...............
messages:
msgnmi		db	'<< NMI PARITY ERROR >>',24
msgdiv0		db	'DIV OVERFLOW  **',24
msgcautious	db	' User takes RISK!',0Dh,0ah,24
msgwarmboot	db	0C,'< Warm Boot >'
msgwarm1	db	6,20,0Dh,0Ah,24	; (6 changed by init)
msgromreset	db	0C,'==ROM RESET== ',7,1,7,5,24
msgcoldboot	db	0C,'** <COLD Boot> **',5,24
msgregs		db	'++ CS:IP, SS:SP,DS:SI,ES:DI = ',24
;.............................................

;====== MAIN JBOOT INT ENTRIES ==============

nmiproc proc near
;---NMI HANDLER ----------------
; sets local stack for protection (needs 70h bytes)
new02:	cli			;no irq while fooling with stack
	mov	cs:[nmisavds],ds
	mov	cs:[nmisavax],ax
	mov	ax,cs
	mov	ds,ax		;ds=local
	pop	ax		;(ip at error time)
	mov	[nmisavip],ax
	pop	ax		;(cs at error)
	mov	[nmisavcs],ax
	sub	sp,4		;return stack to orig
	mov	[nmisavsp],sp	;present vals of stack
	mov	[nmisavss],ss
	mov	ax,cs
	mov	ss,ax		;ss=cs (local stack)
	mov	sp,offset cseg:begsp
	push	es
	push	si
;mask timer, disk, etc,  all but keyboard
;(if pending then may cause probs during return???)
	in	al,21		;get irq mask
	mov	[byte ptr nmitemp],al ;save
	mov 	al,not bit1	;allow only keyboard
	out	21,al
;test if nmi is non-parity error ( like numeric processor)
	call	readparity	;set z=no parity err
	jnz	nw11a		;error
	jmp	nw12		;no err,exit
nw11a:	mov	[nmisavsi],si
	mov	[nmisavdi],di
	mov	si,offset msgregs
	call	crlftvprompt
	mov	al,07h		;about .7 sec delay
	call	delayal		;(for reset sw to open)
;attempt to clear nmi by reading from each seg reg
	mov	di,[nmisavip]
	mov	ax,[nmisavcs]	;display cs:ip
	call	clearparity	;(shows * if parity clears)
	call	binhexax	;cs
	mov	al,':'
	call	tvbyte
	xchg	ax,di		;ax=ip, di=cs
	call	binhexaxsp	;ip with , space after
	mov	ax,[nmisavss]
	call	clearandshow	;ss
	mov	al,':'
	call	tvbyte
	mov	ax,[nmisavsp]
	call	binhexaxsp	;sp
	mov	ax,[nmisavds]
	call	clearandshow	;ds
	mov	al,':'
	call	tvbyte
	mov	ax,[nmisavsi]
	call	binhexaxsp	;si
	mov	ax,es
	call	clearandshow	;es
	mov	al,':'
	call	tvbyte
	mov	di,[nmisavdi]	;di
	mov	ax,di
	call	binhexax
	mov	si,offset cseg:msgnmi
	call	errormsg

;--If two reset buttons in a row, exit to cold boot (warm?)
	test	byte ptr[nmiactive],0FF	;non zero means two in a row
	jnz	nw5		;do warm boot, rom reset???
	inc	byte ptr[nmiactive]	;flag that nmi being handled
	call	qignore		;Q exits to coldboot
	jnc	nw10		;ignore, ok to continue
nw5:	jmp	warmreset	;restart system
; should elim key just struck???? regs mod???
nw10:	dec	byte ptr[nmiactive]	;reset to 0
	mov	si,offset cseg:msgcautious
	call	tvshow
	call	resetnmi	;reset ff and port 62 info
	cli
nw12:	mov	al,[byte ptr nmitemp] ;recover irqmask
	out	21,al		;allow pending irqs after exit
nw14:	pop	si
	pop	es
	mov	ax,[nmisavax]	;restore orig regs
	mov	ss,[nmisavss]
	mov	sp,[nmisavsp]	;restore orig stack
	mov	ds,[nmisavds]
	iret

;--Try to clear parity then show AX
clearandshow:
	call	clearparity
	jmp	binhexax
	jmp	binhexaxsp	;show num with , and sp
clearparity:
	call	readparity
	jnz	clpa10		;not clear
	ret			;z=clear already
clpa10:	push	ax		;try to clr parity (seg = ax)
	push	ds
	mov	ds,ax
	not	[di]
	not	[di]		;last write should clr parity
	pop	ds
	call	resetnmi	;clr port 62 ff
	call	readparity
	jnz	clpa20		;no
	pushf
	mov	al,'*'		;*=this seg cleared parity
	call	tvbyte
	popf			;z=clear, nz=not cleared
clpa20:	pop	ax
	ret

;--Read parity
readparity:
	push	ax
	call	ifat
	jz	rdatp
	in	al,62		;port c
	and	al,0C0h		;bits7(pchk)+6(iochk)
	pop	ax
	ret			;sign=pchk, nz,ns=iochk
rdatp:	in	al,61
	and	al,0c0h		;parity error
	pop	ax
	ret

ifat:	push	ds
	mov	ax,0ffff
	mov	ds,ax
	cmp	byte ptr cseg:[0e],0fc ;pc at if equal
	pop	ds
	ret

nmiactive	db	0	;flag
nmisavax	dw	0000
nmisavds	dw	0000
nmisavip	dw	0000
nmisavcs	dw	0000
nmisavsp	dw	0000
nmisavss	dw	0000
nmisavsi	dw	0000
nmisavdi	dw	0000
nmitemp		dw	0000
nmiflag		db	00

nmiproc endp

div0proc proc near
;----DIV by ZERO HANDLER-------
;puts 70h bytes on users stack
new00:	push	ds
	push	es
	push	si
	push	cs		;ds=cs
	pop	ds
	mov	si,offset cseg:msgdiv0
	call	errormsg
	call	qignore		;Q exits to coldboot
	jnc	ndiv10		;yes, ok to continue
	jmp	warmreset	;restart system
ndiv10:	mov	si,offset cseg:msgcautious
	call	tvshow
	pop	si
	pop	es
	pop	ds
	iret
div0proc endp

rebootp proc near
;=============== MAKEDOS REBOOT ==============
;ax=#k wanted in dos (called by makedos.com)
;batchint:
;ds:bx=req hdr, es:di=calling prog's ds:dx (dx=#k wanted)
makedos:
	push	cs
	pop	ds
	xor	ax,ax
	xchg	ax,di		;get ax=#K wanted (di=0)
	or	ax,ax		;0=use present val?
	jz	new58a		;yes
	cmp	ax,2C0		;too big? (704k max allowed)
	ja	new58a		;yes, use cur val
	cmp	ax,40		;too small?
	jb	new58a		;yes, use cur val
	mov	di,0011		;no mem sizing, just display
	mov	[doskwanted],ax	;new dos size
new58a:	mov	[jbflagcop],di	;force/no force mem sizing
	jmp	warmreset
rebootp endp
;.................................................

cadmod proc near
public jmp09
;CON ALT DEL inteceptor
; gives control over warm boot keyin
; called by int 9 at loc 24hex (puts 1 word on user stack (???flush)
; when pressed alt=38, release=B8
;              del=53, release=D3
;	     cntrl=1D, release=9D
;	       -  =0C, release=8C
kbdata equ 60		;keyboard port
contemp	db	0
conbyte db	0
cadflag	db	0
new09:
controlaltdel:
	push	ax
	in	al,60		;kbdata	;get scan code
	mov	ah,al		;ah=orig code (bit7=release of key)
	and	al,07Fh		;elim release key info
	cmp	al,1dh		; contrl key?
	jz	cona20		;yes
	cmp	al,38h		; alt key?
	jz	cona20		;yes
	cmp	byte ptr cs:[cadflag],3Dh ;both contrl+alt been pressed?
	jz	cona26		;yes
cona18:	pop	ax
jmp09:	jmp	far ptr zeroaddr ;filled by init (typ=f000:e987)


;--SET CADFLAG (con=1d,alt=38,20=-alt,5=-contrl,3d=both)
cona20:	or	cs:[cadflag],al
	cmp	al,ah		;set z=make, nz=release of key
	jz	cona24		;not release
	xor	cs:[cadflag],al	;reset
cona24:	jmp	cona18		;done

;Control-ALT Sequence Decode
cona26:	cmp	al,53h		;DEL key?
	jz	cona26d		;yes
	cmp	al,0Ch		;MINUS key? (replaces c a del)
	jz	cona26c		;yes
	cmp	al,25h		;K key (cold boot)
	jz	cona26b		;yes
flush1:	cmp	al,53h		;21= F key (flush spooler,set by init)
	jnz	cona18		;no legal chr, exit
	push	dx
	push	ax
	mov	ah,83		;jspool flush
	int	17		;(puts ??? on stack!!!)
	pop	ax
	pop	dx
	jmp	cona18		;normal exit

;KILL = Cold Boot, elec disk killed, resize memory
cona26b:
	jmp	coldboot

;MINUS Semi-cold boot, i.e. rom reset, no kill elec disk
cona26c:
	jmp	romreset

;DELETE (warm boot, reload dos, int 19)
; reset keyboard flag at [417] to elim double reset
cona26d:
	cli		   ; no irq while stack half changed
	mov	ax,cs
	mov	ss,ax
	mov	sp,offset cseg:begsp; internal stack

;WARM RESET (replace vectors, reload DOS)
;previous dos k remains until reboot, leave mem on, saves date
;stores vals in 158+,
warmreset:
	cli
	cld
	push	cs		;ds=cs
	pop	ds
	mov	al,not bit1
	out	21,al		;allow only keyboard for now
	mov	ah,2a		;get date in cx:dx
datept:	jmp	short wr10	;int	21 (if "Y", see init)
	mov	[datelow],dx
	mov	[datehi],cx	;save for stuff
wr10:	call	stuff158	;put in [158+] vals, sets es=0
	and	byte ptr es:[417],0F3h ;reset keybd ctrl-alt flag
	mov	si,offset msgwarmboot
	call	tvshow
	mov	si,offset intvectable ;compute checksum
	mov	cx,checksumsize
	call	getchecksum
	cmp	ax,[checksum]	;same?
	jnz	romreset	;no, corrupted, rom boot
;reinit vector and ports table, reset keybd, reset irq
	mov	si,offset intvectable ;vectors to restore
	mov	cx,40h		;32 vectors * 2words=64words
	mov	di,es		;es:di=0:0
	rep	movsw		;move es:di=ds:si
	mov	si,offset porttab ;ports to restore
	mov	di,400		;port location 0:400
	mov	cl,4		;4 COM ports (1 word each)
	rep	movsw
	mov	cl,4		;4 PARALLEL ports
	add	si,8		;skip com5-com8
	rep	movsw
	xor	ax,ax
	int	13h		;reset disk NEC chip
	call	resetkeyboard
	call	disableirqs	;reset/disable poss irqs
	int	19		;load in bootstrap (1st sec on disk)

;--COLD BOOT and ROM RESET (JUMP TO POWER ON RESTART)
; same as control,alt,del, if [472]=0, then same as cold boot
; because dma turned off for a while, memory will be corrupted
terminate:
coldboot:
	cli		   ; no irq while stack half changed
	mov	ax,cs
	mov	ds,ax		;ds=cs
	mov	ss,ax		;stack=cs:begsp
	mov	sp,offset cseg:begsp; internal stack
; allow abort of cold boot
	xor	ax,ax
	mov	es,ax
	and	byte ptr es:[417],0F3h ;reset keybd ctrl-alt flag
	call	resetkeyboard
	call	disableirqs	;elim pending irqs
pat10:	mov	al,0FFh		;allow no irqs (mod by init)
;	mov 	al,not bit1	;allow only keyboard
	out	21,al
pat11:	nop			;mod by init to a sti
;	sti			;allow change of mind
	mov	si,offset msgcoldboot
	call	tvshow
	call	coldsweep

	cli			;time's up, cold boot
	xor	si,si
	mov	es,si
	mov	es:[472],si	;force cold boot
;Kill flag in previous jetdrive so it will not be restored
	call	killjdrivelock

;--ROM RESET (turns off jram but does not kill elec. disk )
romreset:
	cli		   ; no irq while stack half changed
	mov	ax,cs
	mov	ds,ax		;ds=cs
	mov	ss,ax		;stack=cs:begsp
	mov	sp,offset cseg:begsp; internal stack
	xor	ax,ax
	mov	es,ax		;es=0
	mov	es:[158],al	;kill jbootflag (force mem sizing)
	call	turnoffjram	;turn off all jram boards
	mov	si,offset msgromreset
	call	tvshow
	cli
	mov	al,0Ah		;delay to show message
	call	delayal
	call	disableirqs	;reset irq0-7, keybds, etc.
;	jmp	far ptr ffff:0
	db	0EAh,0,0,0FF,0FF ;far jump to ROM reset

;--RESET NMI  (reset ff and port 62 info)
resetnmi:
	push	ax
	call	ifat
	mov	ah,30		;bit4+bit5=RAM+IO parity chk clear
	jne	rkbd10
	jmp	atpon		;enable at parity

;--RESET KEYBOARD (reset port and chip)
resetkeyboard:
	push	ax
	call	ifat
	mov	ah,80		;bit7=clear keybd
	jz	rkbd20		;pc at hardware different
rkbd10:	in	al,61		;get port bits
	mov	al,4Dh		;force this value
	or	al,ah		;bits hi
	out	61,al		;pulse bits to reset port
	jmp	short $+2
	xor	al,ah		;bits lo
	out	61,al
rkbd20:	pop	ax
	ret

;DISABLE/RESET IRQS (serial or parallel port irqs)
disableirqs:
	cli
	mov	al,0BCh		;enable time,keybd,and disk only
	out	21,al		;update mask (bit hi=disabled)
;reset all pending irqs (if any)
resetirq:
	cli
	mov	al,67		;specific reset of irq7 thru irq0
	mov	cx,8
rsiq10:	out	20,al		;specific reset
	dec	al
	loop	rsiq10		;till done
	ret
CADMOD endp

localtv proc	near
;--LOCAL TV ROUTINES, call directly to roms
; si=ptr str, mods no other regs
;0F= freq, 07 = beep, 06 =sweep beep, 01=.1sec delay
tvshow:	push	ax
	push	bx
	mov	ah,0Fh		;get page of tv screen in bh (0=typ)
	int	10
	mov	bl,07		;get bl=fill val (al=mode (7=bw))
	cld
tvsh10:	lodsb			;al=[si],si+1 (get chr)
	cmp	al,'$'		;end of text?
	jz	tvsh90		;yes
	or	al,al		;0=end of text?
	jz	tvsh90		;yes
	cmp	al,06		;sweep beep?
	jnz	tvsh12		;no
	call	sweepbeep	;(used by warm boot)
	jmp	short tvsh10
tvsh12:	ja	tvsh17		;not a delay
	call	delayal		;al=tenths of seconds delay
	jmp	short tvsh10
tvsh17:	cmp	al,07		;beep?
	jnz	tvsh20		;no
	call	beep
	jmp	short tvsh10
tvsh20:	cmp	al,0F		;freq?
	jnz	tvsh30		;no
	lodsb			;next chr = freq
	xor	ah,ah
	shl	ax,1
	shl	ax,1		;*4 to get freq
	mov	[beepfreq],ax
	jmp	short tvsh10
tvsh30:	cmp	al,0C		;bottom screen?
	jnz	tvsh40		;no
	push	dx		;bx set above
	mov	dx,1800		;row 25,col 1
	mov	ah,2		;set cursor at bottom
	int	10
	pop	dx
	push	cx
	mov	ax,0920h	;write chr/attrib, chr=space
	mov	bl,07		;set attribute, reset by tvchr below
	mov 	cx,20		;write 32 spaces
	int	10		;cursor position not changed
	pop	cx
	mov	al,0Dh		;cr
tvsh40:	call	tvchr		;"TTY output"
	jmp	short tvsh10	;loop till done
tvsh90:	pop	bx
	pop	ax
	ret

;--UPPER converts al into uppercase
;public upper
upper	proc	near		;upper:
	cmp	al,7a		;chr > z?
	ja	upp99		;yes
	cmp	al,61		;chr < a?
	jb	upp99		;yes
	and	al,5Fh		;bit 5=0
upp99:	ret
upper	endp

;--KEYBOARD INPUT (waits,gets al=chr,echos to tv)
;public inbyt
keyin:	mov	ah,0		;get next chr from keyboard
	pushf			;simulate int16
	call	cs:[intvec16] ;keyboard i/o
	ret

;--CRLFTV (crlf,msg,crlf)
crlftv:	call	crlf
;--TV (with  crlf)--
tv:	call	tvprompt	;si=message
;--CR Carriage return and lf--
crlf:	push	si
	mov	si,offset cseg:msgcrlf
	call	tvprompt
	pop	si
	ret
msgcrlf:
	db	0dh,0ah,24
;--CRLFTVPROMPT (crlf,message, no crlf)
crlftvprompt:
	call	crlf
;--TVPROMPT (no crlf, msg,no crlf)
;(tv out till null or "$")
; si=ptr message
;public tvprompt
tvprompt:
	jmp	tvshow

;--ERROR message to TV (crlf,"ERROR",no crlf)
errortv:
	push	si
	mov	si,offset cseg:msgerror
	call	crlftvprompt
	pop	si
	ret
msgerror: db	7,7,"*ERROR*  ",1,0F,0C,7,7,0F,6,24
;--ERRORMSG (si=message to follow "ERROR")
errormsg:
	call	errortv		;"error"
	jmp short tvprompt	; actual message

;--BLANK
;public blank
blank:	push	ax
	mov	al,' '
	call	tvbyte
	pop	ax
	ret

;--TVBYTE (al=chr to tv)
; al=chr,   no mod all other regs
;public tvbyte
tvbyte:	push	bx
	call	tvchr
	pop	bx
	ret

;TVCHR  (al=chr to tv, sets bx)
;bp save,initial set mode required for early IBM rom
;mods ah,sets bh=page,bl=mode
tvchr:	push	ax
	mov	ah,0Fh		;get page of tv screen in bh (0=typ)
	int	10
	mov	bl,7		;get bl=mode (7=normal)
	pop	ax
	push	bp		;bp mod by old IBM rom
	mov	ah,0Eh		;"TTY output"
	int	10
	pop	bp
	ret
	
;BEEP (simple beep with freq = beepfreq)
beepc0	dw	200		;total time of beep
beepfreq dw	18		;hi pitch (220 = 250 hz (3.6us/count)
;mods al
beep:	push	cx
	push	bx
	in	al,61		;get spkr port data
	push	ax		;save for off
	and	al,0FCh		;turn off spkr and timer gate
	mov	bx,[beepc0]	;#cycles to do
	mov	cx,[beepfreq]	;freq (period)
	call	beeptone	;invert spkr and delay cx
	pop	ax		;get orig bits
	out	61,al
	pop	bx
	pop	cx
	ret
; BEEP OUT al=spkr data, cx=count held for
; updates al
beepout:
	xor	al,2		;invert spkr data
	out	61,al
	push	cx
bepo10:	loop	bepo10
	pop	cx
	ret
; BEEP TONE al=spkr data, cx=freq (delay), bx=tone duration
beeptone:
	push	bx
bptn10:	call	beepout
	dec	bx
	jnz	bptn10
	pop	bx
	ret

;SWEEP BEEP (sends sweeping beep to console)
beepfreq2 dw	300		;starting freq

sweepbeep:
	push	cx
	push	bx
	in	al,61		;get spkr port data
	push	ax		;save for off
	and	al,0FCh		;turn off spkr and timer gate
	mov	cx,[beepfreq2]	;freq (delay)
	mov	bx,1
swbp7:	call	beeptone	;invert spkr data and delay cx
	sub	cx,3		;reduce the delay (sweep)
	or	ch,ch		;till FF
	jnz	swbp7
	mov	bx,1
swbp10:	call	beeptone
	loop	swbp10
	pop	ax		;get orig bits
	out	61,al
	pop	bx
	pop	cx
	ret

;COLD SWEEP
; no values needed, mods no regs
beeptab:
beepf1	dw	0A00	;note 1
beepn1	dw	58
beepd1	dw	0FFFF
beepf2	dw	0A00	;note 2
beepn2	dw	30
beepd2	dw	1000
beepf3	dw	076c	;note 3
beepn3	dw	0F0
beepd3	dw	6000
	dw	0000	;end of list

coldsweep:
	nop			;ret put here by init if quiet
	push	bx
	push	cx
	push	si
	in	al,61		;get spkr port data
	and	al,0FCh		;turn off spkr and timer gate
	mov	si,offset cseg:beeptab
cdsp7:	mov	cx,[si]
	jcxz	cdsp90		;0=end of list
	mov	bx,[si+2]	;#cycles to do
	call	beeptone	;spkr invert, delay cx
	mov	cx,[si+4]	;inter-note pause
cdsp10:	loop	cdsp10		;pause
	add	si,6		;next table entry
	jmp	short cdsp7
cdsp90:	pop	si
	pop	cx
	pop	bx
	ret
localtv endp

;................................................
;..............END OF MAIN SEGMENT................

;========STACK SEGMENT============================
assume cs:cseg,ds:cseg
if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif
begstack = $
defaultstr:	db	'CDJMPZYX11B X12B X14B X15B ;Default options are '
		db	'cntl-alt-del,div0,find jram,memtest,paritytrap,'
		db	'zero ints,restore year'
		db	0Dh,0Ah,0

	org	offset begstack+140h   ;DOS man recommends 100
begsp	equ	$
;...............END OF STACK SEGMENT..............

;==========Begin SUB MODULES=================
subroutinesp proc near
assume cs:cseg,ds:cseg
if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif

;--STUFF [158+] VALUES (move internal table to page 0)
;ds=cs, sets [413] and [472] also, sets es=0
;mods si,es=0,di
stuff158:
	push	ax
	xor	si,si			;get es=0, ds=cs already
	mov	es,si
	mov	si,offset cseg:jbflagtab+2 ;ds:si=table of vals (source)
	lodsw				;[doskwanted]
	mov	es:[413],ax		;size in k
	mov	word ptr es:[472],1234	;[keybdreset],simulate c-alt-del
	mov	[nines],9999h		;nines mean no int58 yet
	mov	di,158			;[jbflag];es:di = 0:158 (dest)
	mov	cx,jbcopsize		;includes date
	rep	movsw			;fill 158+
	pop	ax
	ret

;--JDRIVE LOCK  (check and perhaps kill lock in jdrive)
;al=0 check, al=1 check and kill, sets cy=no lock found
;mods es,si,di
;called by init
jdrivelock:
	push	dx
	mov	dl,2			;use tempbanks, check only
	mov	si,offset cseg:freebank
	mov	di,offset cseg:tempbanks1
	jmp	short lock5
;called if cold boot
killjdrivelock:
	push	dx
	mov	dl,1			;1=kill lock
	mov	si,offset cseg:jdr1bank ;loc of jdrive(s)
	mov	di,offset cseg:membanks
lock5:	push	bx
	push	ax
lock6:	cld
	lodsw				;first bank of jdrive
	inc	ax			;FFFF=end of list?
	jz	lock86			;done
	dec	ax
	cmp	ah,0F			;no jdr? (FFF)
	jz	lock6			;skip it
	xchg	ax,bx			;bx=bank#
	push	ds
	call	accessbank1		;bl=bank#, sets es=CREG,al=TON
	pushf				;cy=no turnon,(ds = data seg)
	mov	bx,3			;location of mfg name
	cmp	word ptr [bx],'TT'	;TTS=tall tree name?
	jnz	lock79			;no
	cmp	word ptr [bx+2],' S'	;lock there?
	jnz	lock79			;no
	or	dl,bit7			;bit7=1 if lock there
	test	dl,bit0			;bit0=0 if no kill
	jz	lock79			;no kill
	inc	byte ptr [bx]		;kill lock
lock79:	popf				;cy=no turnon
	pop	ds
	jc	lock85			;no turn off needed
	mov	es:[0],al		;turn-off jram
lock85:	test	dl,2			;check only?
	jz	lock6			;no, kill all jdrs
lock86:	rol	dl,1			;set cy
	cmc				;cy=lock not there
	pop	ax
	pop	bx
	pop	dx
	ret

accessbankfar proc far
;--ACCESS BANK (bx=bank# 0-266 (16Mb max))
; bx=bank# (0-FF)
; sets al=TON, es=CREG (like E810)
; sets ds= loc of data (like 3000 or D000 if swap)
; mods ah, sets cy=no turnon needed
; sets bx=bank#, ds=mem space

;--ACCESS BANK 1 (bx=bank#, di=ptr membanks)
accessbank1:
	pop	ax		;ip from near call
	push	cs		;allows far return
	push	ax		;replace ip
	push	cx
	shl	bx,1		;bx=bank# index
	mov	cx,[bx+di]	;di=ptr membanks
	mov	ah,cs:[swapbank]
	jmp	short acbk7
;--ACCESS BANK (bx=bank#)
accessbank:
	mov	ah,cs:[swapbank]
;--ACCESS BANK SWAP (bx=bank#, ah=swap bank# 1-E)
accessbankswap:
	mov	byte ptr cs:[bankinuse],0FFh ;in use
acbk5:	push	cx
	shl	bx,1		;word ptr bank#
	mov	cx,cs:[bx+offset cseg:membanks] ;get bank info
acbk7:	shr	bx,1		;recover bx
	cmp	ch,0E1h		;JRAM board? (E or F000?)
	jb	acbk90		;no ,cy (0-E000=reg mem)
	mov	al,cl
	and	al,86		;elim bit0,keep bit7="on"
	add	al,cl		;al=0,1,4,5,8,9,C,D
	jc	acbk40		;already turned on
	and	cl,70		;elim "on" and boardbank#
	mov	es,cx		;es=CREG (like E810)
	mov	cl,4
	shl	al,cl		;get top 4 bits=bank code
	or	al,ah		;al=TON=bank + swapbank (window)
	mov	ch,al
	shl	ch,cl		;convert to seg (D0)
	xor	cl,cl		;cx=segment (D000)
	mov	ds,cx		;ds=opened bank
	pop	cx
	mov	es:[0],al	;turn-on jram board
	or	al,20		;setup for turnoff
	ret			;nc = needs turnoff
;compute already-on segment (bx=0 - F)
acbk40:	mov	cl,4
	mov	ch,bl		;convert to seg
	shl	ch,cl		;convert to seg (30)
	xor	cl,cl		;cx=segment (3000)
	xor	al,al		;al=0=no turnon needed
	stc			;cy=turned on
acbk90:	mov	ds,cx		;ds points to opened bank
	pop	cx
	ret			;cy=no turnon needed

;--SET BANK FREE (mods no regs)
setbankfree:
	mov	byte ptr cs:[bankinuse],0 ;not in use
	ret
;--TEST BANK IN USE  (set z=not in use)
testbankinuse:
	test	byte ptr cs:[bankinuse],0FF ;in use?
	ret
;--TURN OFF BANK (bx=bank#)
turnoffbank:
	mov	ah,cs:[swapbank]	;0Dh
turnoffbankswap:
	or	ah,20h			;2Dh=turnoff
	mov	byte ptr cs:[bankinuse],0 ;not in use
	jmp	short acbk5		;force turnoff
accessbankfar endp

;--JRAM BANK ON (cli must be set) ----------
; bl=window, ah=board 0,1,2,3,4,5,6,7 (E8 thru E1,F8 thru F1)
; al=quadrant + board bank# (top 4 bits=quad 0,1,2,3, low 4=bank 0-7)
; turns on board, sets al=TURN ON val, es=CREG (like E820),
; mods ah

boardcode	db	0E8,0E4,0E2,0E1,0F8,0F4,0F2,0F1 ;(0-7)
jrambankoff:
	push	cx
	mov	cl,1		;turn-off board
	jmp	short jrbo10
jrambankon:
	push	cx
	xor	cl,cl		;cl=0=turn-on board
jrbo10:	push	bx		;bl=window
	xor	bx,bx
	mov	bl,ah		;bx=board# 0-7
	mov	bh,[bx+offset cseg:boardcode] ;get E8 thru F1
	mov	bl,al		;add in quad code
	and	bl,0F0h		;bl=quad # (0,10,20,30)
	xor	al,bl		;al=board bank# (0-7)
	or	bl,cl		;add in turnon/off info (E800 or E801)
	mov	es,bx		;es=CREG
	pop	bx		;bank#
	pop	cx
; es=CREG, bl=window, al=bank# (0-7)
jrambankon1:
	push	cx
	mov	ch,al		;convert 0-7 to 0-0D code
	and	al,06h		;elim bit0
	add	al,ch		;ch=0,1,4,5,8,9,c,d
	mov	cl,4
	shl	al,cl		;get banksel in hi nibble
	or	al,bl		;al=TURN ON=banksel:window
	pop	cx
	mov	es:[0],al	;turn on JRAM (es:0=CREG)
	or	al,20		;setup for disable
	ret

;--TURN OFF JRAM (turns off all possible boards)
;mods ax,bx,es
turnoffjram:
	xor	ax,ax		;ah=board, al=quad+bank
	mov	bl,00h		;16 windows, 0-F
tofj20:	push	ax
	call	jrambankoff	;turn off board,set es=CREG
	mov	es:[0],al	;turn off window
	pop	ax		;ah=board#
	inc	bl		;next window
	and	bl,0Fh		;board done?
	jnz	tofj20		;no
	inc	ah		;next board
	cmp	ah,8		;8 boards done?
	jb	tofj20		;no
	ret


;--DELAY TIME al=time, (1=about 0.1 second)
delayal:
	push	cx
dely5:	mov	cx,28011d	;28011 x 17 clocks = .1sec
dely10:	loop	dely10		;(6D6B or so)
	dec	al
	jnz	dely5
	pop	cx
	ret

;--BANK to SEGMENT (bl=bank#, gets es=segment)
banktoseg:
	push	bx
	push	cx
	mov	cl,0Ch		;shift left
	shl	bx,cl
	mov	es,bx
	pop	cx
	pop	bx
	ret


chksump proc near
;--GET CHECKSUM
; si=starting loc (ds:si), cx=#bytes to sum
; sets ax=sum
getchecksum:
	push	bx
	push	cx
	push	si
	cld
	xor	bx,bx		;init checksum
gcks10:	lodsb			;al=[si]
	add	bl,al		;bx=checksum
	rol	bx,1		;pseudo crcc
	loop	gcks10		;till #bytes done
	xchg	ax,bx		;ax=checksum
	pop	si
	pop	cx
	pop	bx
	ret
chksump endp

QYESNOMOD proc near
;--Quest IGNORE (I=ignore (nc), W=warm boot (cy), Q=cold boot)
; mods no regs, returns nc=yes, cy=no
qignore:
	push	ax
	push	si
qig10:	mov	si,offset msgokignore
	call	tvshow
	call	keyin		;get al=chr
	call	tvbyte		;echo
	call	crlf
	call	upper
	cmp	al,"I"		;ignore?
	jz	qig50		;nc=yes
	cmp	al,"W"		;warm boot?
	stc			;cy if no
	jz	qig50
	cmp	al,'D'		;enter DOS?
	jz	qig47	;90	;yes
qig47:				;testing????
	cmp	al,"Q"		;quit?, cold boot?
	jnz	qig10		;no legal answer
	jmp	terminate	;q=exit prog
qig50:	pop	si
	pop	ax
	ret			;cy=no, nc=yes
qig90:	mov	al,0BCh		;setup interrupts
	out	21,al
	xor	ax,ax		;this causes probs???????
	int	21		;enter DOS

msgokignore	db	'  (I=ignore,'
	;	db	'D=enter DOS,'
		db	'W=warm,Q=coldboot)',24
QYESNOMOD endp

SETENDMOD proc near
;----ENDING (return) ADDRESS SUBS for device driver---
;--SET ES BX POINTER (called to set addr of BPB
rhoff	dw	0	;req hdr ptr set by strat entry
rhoffseg dw	0	;es:bx put here
setesbx:
	mov	cs:[rhoff],bx
	mov	cs:[rhoffseg],es
	ret

;--SET END ADDR (dx:ax=ret addr)
; es:bx ptr to req hdr obtained and updated
; dx:ax=addr to set
; sets cx:bx=req hdr ptr
setendaddr:
	push	ds
	lds	bx,[dword ptr rhoff]	;ds:bx=req hdr ptr
	mov	word ptr [bx+0Eh],ax ;endaddr
	mov	word ptr [bx+10h],dx  ;endaddrseg
	mov	cx,ds		;cx:bx=req hdr ptr
	pop	ds			;ds=cs
	ret
SETENDMOD endp

BINASCMOD proc near
;--BINASCAXSP (number followed by ,space)
binhexaxsp:
	call	binhexax	;number
	push	si
	mov	si,offset cseg:msgcommasp
	jmp	short bab10
msgcommasp db	', ',24

;--BIN HEX Convert  (ax=#)
binhexax:
	push	ax
	push	cx
	mov	cx,4		;4 nibs
bihx10:	rol	ax,1
	rol	ax,1
	rol	ax,1
	rol	ax,1	;get left most nibble
	call	tvhexnib
	loop	bihx10
	pop	cx
	pop	ax
	ret

tvhexnib:
	push	ax
	and	al,0F	;get lowest nib
	add	al,30	;0-9+
	cmp	al,39	;over 9?
	jbe	tvhn20	;no
	add	al,7	;convert to A-F
tvhn20:	call	tvbyte	;show on tv
	pop	ax
	ret

;--BINASCAXK (Print #k)
; ax=#, not modified
binascaxk:
	call	binascax	;show number
	push	si
	mov	si,offset cseg:msgk
	jmp	short bab10
msgk	db	' Kilobytes  ',24

;--BINARY to ASCII printout routine
;BABYTES (binary to ascii convert with "bytes" added)
babytes:
	call	ba8digit	;convert and show
	push	si
	mov	si,offset cseg:msgbytes
bab10:	call	tvprompt
	pop	si
	ret
msgbytes	db	" bytes.",24
;BINASC AX (ax=number, 6 digits max)
binascax:
	push	cx
	push	dx
	xor	dx,dx
	mov	cx,106h		;6 digits max
	call	binasc
	pop	dx
	pop	cx
	ret
;BA512 (dx=number, multiplied times 512)
; mods ax
ba512:	mov	ax,512d
	mul	dx
;BA8DIGIT (dx:ax=number, cx set for 1 zero,8 digits)
;mods no other regs
ba8digit:
	push	cx
	mov	cx,108h
	call	binasc
	pop	cx
	ret
;BINASC (dx:ax=number, ch=#leading zeros,cl=#digits max)
;mods cx
binasc:	push	ax
	push	dx		;save number
	push	di
	push	bp
	xchg	ax,bp		;bp=low16 of number
	mov	al,09h		;9 digits max allowed
	cmp	al,cl		;reqsted below limit?
	jae	ba5		;yes,ok
	mov	cl,al		;force limit
ba5:	mov	al,cl		;#digits max (#tens)
	cbw
	add	ax,ax		;get index to max tens
	add	ax,ax
	add	ax,offset cseg:tens-4
	xchg	ax,di
	xor	ah,ah		;flag for leading zero
ba10:	xor	al,al
ba15:	cmp	dx,cs:[di+2]	;dx=hi16 of number
	jb	ba30
	ja	ba20
	cmp	bp,cs:[di]	;bp=lo16 of number
	jb	ba30
ba20:	sub	bp,cs:[di]
	sbb	dx,cs:[di+2]
	inc	ax		;# subtractions (dividend)
	or	ah,al		;non-zero found
	jmp	short ba15
ba30:	cmp	ch,cl		;show zeros in last ch digits
	jb	ba40
	or	ah,cl		;flag=show zeros
ba40:	or	al,'0'
	or	ah,ah		;z=leading zero?
	jne	ba50		;no
	mov	al,' '		;yes, print space
	;following line optional,gives no leading spaces
	jmp	short ba51		;if no leading spaces
ba50:	call	tvbyte		;tv out
ba51:	sub	di,4		;next table entry
	dec	cl		;#tens left to do-1
	jnz	ba10
	pop	bp
	pop	di
	pop	dx
	pop	ax		;dx:ax=number
	ret
tens:	dw	1,0,0A,0,64,0,3E8,0,2710,0	;1-5
	dw	86a0h,1		;100,000	;6
	dw	4240h,0fh	;1,000,000	;7
	dw	9680h,98h	;10,000,000	;8
	dw	0e100h,5f5h	;100,000,000	;9 digits
;	dw	0ffffh,7fffh	;max, too big	;
BINASCMOD endp

;copy temp table to inside and return from driver init
; (table can wipe out init code)
copytemp:
	rep	movsw		;(0's at end sig end of table)
	jmp	cmdexit

if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif

; BANKSINFO and MEMBANKS  (256+ words max -- 16 Mb)
banksinfo:		;(loc = membanks - 10h)
rambanks dw	0000	;0 hi=#banks tot, lo=#contig banks
jrambanks dw	0000	;2 #banks of JRAM avail
userk	dw	0000	;4 #k reserved for user (default 0k)
maxregmem db	0Dh	;6 limit of reg mem (9=640k)
maxtonmem db	00	;7 last bank turned-on mem (0=autosize)
swapbank db	0Dh	;8 JRAM swap area (0D typ)

dosbank	db	00	;9 last bank of dos
jdriveptr dw	offset cseg:jdr1bank ;A loc of ram disk list
freebank dw	0000	;C first unused bank
nbanks	dw	0000	;E #banks
regmembanks:
membanks=offset cseg:regmembanks + 20  ;allow 20 for orig mem config

;...................................................
;---END OF RESIDENT DRIVER -------------------------
; all code below eliminated after init finish

;--BL:AX TO K (ax=bl:ax/1024) (rounds up)
; bl:ax less than 2**24-1k (about 16 meg)
blaxtok:
	add	ax,3FF		;round up to next k
	jnc	bltk10		;no overflow
	inc	bl
bltk10:	push	cx
	mov	cl,-0Ah		;-10bits, div by 1k
	call	shift24		;get ax=#K
	pop	cx		;ax=3fff max
	ret

;--DL:AX TO K (ax=dl:ax/1024)(rounds up)
dlaxtok:
	push	bx
	mov	bl,dl		;get bl:ax=#
	call	blaxtok
	pop	bx
	ret

;--K TO BANK (convert ax=#K to bl=bank#)
; cy = 100 (256) or more banks
ktobank1:
	xor	bx,bx		;allow 10 bit result
ktobank:
	push	ax
	push	cx
	mov	cl,6		;convert to 64Kb blocks
	dec	ax		;round up to nearest blk#
	shr	ax,cl		;0=0-64K, 1=64-128K, etc.
	mov	bl,al
	or	ah,ah		;overflow?
	jz	ktbk45		;no
	mov	bh,ah		;set bx=#banks
	stc
ktbk45:	pop	cx
	pop	ax
	ret

;--BANK TO K (bl=bank 0-nn, gets ax=#k (40-nn))
nbanktok1:
	mov	ax,bx		;bx=#banks
	dec	ax
	jmp	short bktk7
banktok1:
	mov	ax,bx		;bx=bank#
	jmp	short bktk7
nbanktok:
	mov	al,bl		;bl=#banks
	dec	ax
	jmp	short bktk6
banktok:
	mov	al,bl		;bl=bank#
bktk6:	xor	ah,ah
bktk7:	push	cx
	mov	cl,6		;convert to #k
	inc	ax		;bank#0=40,#1=80,etc
	shl	ax,cl
	pop	cx
	ret

;----GET/SET INT VECTOR SUBS-------------------------
getvectorp proc near
;--GET VECTOR (al=vec #, gets dx:bx=addr)
getvector:
	push	es
	mov	ah,35		;get vector
	int	21		;es:bx=vec addr
	mov	dx,es		;dx:bx=vec
	pop	es
	ret
;--SET VECTOR (al=vec #, bx= offset to plug in (seg=cs)
setvectorcs:
	push	dx
	call	xchgvectorcs
	pop	dx
	ret
;--XCHGVECTORCS  (stuffs cs:bx, returns dx:bx=old vec)
xchgvectorcs:
	mov	dx,cs
;--XCHGVECTOR (al=vec #, dx:bx exchanged with vec)
; plugs in dx:bx, returns dx:bx=unplugged addr
xchgvector:
	push	es
	push	ds
	mov	ds,dx
	xchg	dx,bx		;ds:dx=new val
	mov	ah,35		;func 35, al=vect#
	int	21		;es:bx=old vec
	mov	ah,25		;set new vec=ds:dx
	int	21
	mov	dx,es		;now dx:bx=old vec
	pop	ds
	pop	es
	ret
getvectorp endp

LOGIC24MOD proc near
;--TEST ZERO 24 bit (bl:ax=24bit number)
testz24	proc	near
	push	ax
	or	ah,bl
	or	ax,ax	;bl:ax=0?
	pop	ax	;recover orig val
	ret		;z set if zero
testz24 endp

;---SHIFT LEFT/RIGHT 24 bit (cl=+ or - #bits)
; bl:ax=orig number, cl=#bits, -=shift right
; bl:ax=result, cy correct on last loop only
shift24p proc near	;shift24p:
;--Shift left AX only, bl:ax=result
shift24ax:
	xor	bl,bl	;bl=top 8 bits
shift24:
	push	cx
	xor	ch,ch	;cx=#bits to shift
	test	cl,80h	;neg #bits to shift?
	jnz	shr24	;yes,shift right
shl24a:	shl	ax,1	;cy=bit7
	rcl	bl,1	;cy here=overflow,ignored
	loop	shl24a
	pop	cx
	ret
shr24:	neg	cl	;cl=#bits to shift
shr24a:	shr	bl,1	;cy=bit0
	rcr	ax,1
	loop	shr24a
	pop	cx
	ret
shift24p endp
LOGIC24MOD endp

GTABOPTMOD proc near
;============new GTABOPT ==================
;--TABLE SYNTAX
;table= letter,flag code,if neg poss/invert, other optional codes
; (min 3 bytes each entry) di=ptr table, update flag in ah
;flagbyte1	db	0		;si points to these
;flagbyte2	db	0		;(one per 8 letters)
;delimtable:
;	db	5			;#bytes in each entry (127 max)
;	db	'^',oneg,40,0,0		;neg symbol (like -)
;	db	'D',delopt,0,0,0	;neg not poss
;	db	'U',delopt,81		;U=-D
;	dw	offset doprint		;subroutine ptr
;	db	0			;end of table
; Syntax: letter, bit-pattern, control byte, call-address, other.
;   The first three bytes are required
;		bit-pattern bits or'ed to flag
;		control byte bit0=negating this letter ok
;			bit3=use offset as ptr to flag
;			bit4=go to next flag (si+1)
;			bit5=use offset to call sub
;			bit6=this letter means negate
;			bit7=invert meaning of bit-pattern
;		(i.e. if p=-w, both have oprint, but w has negposs=81)
;	two negs cancel each other

;--GET TABLE OPTIONS
; al=chr, bx=chr ptr (in case more chrs to be read)
; di=ptr table of opt letters, si= ptr flag bytes
; sets ah=flag [si+nn], al=entry # in table
;	(note, nz =negated letter when call [di] is done)
;	(dx is passed to [di], nz=neg, can mod dx,cx,al)
; sets	al=chr if not in table else undefined
;	ah=flag [si+nn] changed
;	si=ptr flag that changed
;	cy=not found or illegal use of neg (al=chr)
;	nc,z=done, nz=negate chr found
gtopneg 	db	0	
gtaboptn:
	push	di
	push	cx
	push	bp
	push	dx		;dx info passed to sub
	call	upper		;al=upper
	mov	cx,ax		;cl=al=chr,ah=flag
	mov	ch,[gtopneg]	;ch=neg flag
	xor	dx,dx
	mov	dl,[di]		;#bytes per entry
	inc	di		;point to letter
gtop10:	test	byte ptr[di+2],bit4 ;use next flag?
	jz	gtop11		;no
	inc	si		;yes, point next flag
gtop11:	mov	al,[di]		;get table letter
	cmp	cl,al		;chr=option?
	jz	gtop20		;yes,got chr
	or	al,al		;end of list?
	jz	gtop15		;yes
	test	byte ptr[di+2],bit3+bit5 ;offset specd?
	jz	gtop12		;no
	inc	di		;yes, move past offset
	inc	di
gtop12:	add	di,dx		;next entry
	jmp	short gtop10
;not in table, check for neg
gtop15:	cmp	cl,'-'		;negate ?
	jnz	gtop99		;no, illegal letter
gtop17:	xor	ch,0FFh		;set nc,nz (2 negs = +)
	jmp	short gtop98	;store negflag
;got chr, process
gtop20:	test	byte ptr[di+2],bit3 ;use diff flag?
	jz	gtop22		;no
	mov	si,word ptr[di+3] ;yes, new flag
gtop22:	mov	ah,[si]		;flag to change
	inc	di
	mov	al,[di]		;(+1)=bits to set/reset
	inc	di
	test	byte ptr [di],40 ;(+2) a negate symbol?
	jnz	gtop17		;yes
	or	ch,ch		;previous negate symbol?
	jz	gtop40		;no
	test	byte ptr [di],1 ;(+2)=neg possible for this option?
	jz	gtop99		;no, error exit
	or	ah,al		;set,then reset flag
	xor	ah,al		;reset
	jmp	short gtop80
gtop40:	or	ah,al		;set flag
gtop80:	test	byte ptr [di],80 ;(+2) invert meaning of bit code?
	jz	gtop86		;no
	xor	ah,al		;invert flag
gtop86:	test	byte ptr [di],20 ;(+2) call wanted?
	jz	gtop90		;no
	test	byte ptr [di],bit3 ;new flag also?
	jz	gtop87		;no
	inc	di		;yes, use 2nd offset
	inc	di
gtop87:	pop	dx		;recov dx=info passed
	mov	bp,ax		;temp place for flag
	or	ch,ch		;set nz if neg
	call	word ptr[di+1]	;sub can mod ax,cx,dx
				;(bx=str ptr, bp=flag, di=[+2])
	mov	ax,bp		;restore ah=flag
	push	dx
gtop90:	xor	ch,ch		;reset neg, set nc,z
gtop97:	mov	[si],ah		;update flag
gtop98:	mov	[gtopneg],ch	;update
	mov	al,cl		;recov chr (perhaps)
	pop	dx		;(dx may be changed by sub)
	pop	bp
	pop	cx		;(al=chr,ah=flag)
	pop	di		;restore table loc
	ret			;nc,z=done  nc,nz=neg
gtop99:	xor	ch,ch		;reset neg
	stc			;cy,z=wrong option or use of neg
	jmp	short gtop98
GTABOPTMOD endp

GETNEXTCMOD proc near
;--GETNEXTCHR get [bx+1], test for end
;0 or 0D set cy = end, "/" sets z,nc, other chrs=nc,nz
;0 or cr or "/" do not inc bx
getnextchr:
	mov	al,[bx+1]	;get chr
	cmp	al,0Dh		;cr? (end?)
	jz	gnext99		;yes
	cmp	al,";"		;semicoln=end of line
	jz	gnext99		;yes
	or	al,al		;0?  (end?)
	jz	gnext99		;yes
	cmp	al,"/"		;slash?
	jz	gnext98		;yes
	inc	bx		;point to this chr
	clc			;nc,nz
gnext98:ret			;nc, (z="/")
gnext99:push	ax		;(bx points to last valid chr)
	inc	ax		;set nz
	pop	ax
	stc			;cy,nz=end of str
	ret

;--SPACE COMMA EQUAL (nc, cr=nc,z, else=cy)
;--CHECKDELIM al=space or comma or control code are ok=nc
; z=cr,nz=space or comma or control code
; cy=invalid delim (not sp or ,)
spcomequal:
	cmp	al,"="		;equal?
	jz	chkd98		;yes (nc)
checkdelim:
	cmp	al,","		;comma?
	jz	chkd98		;ok (nc)
	cmp	al," "		;space? (or control code?)
	jbe	chkd98		;ok (nc)	
	stc			;cy=no valid delim
	ret
chkd98:	cmp	al,0Dh		;cr?
	clc
	ret			;nc=delim, z=cr
GETNEXTCMOD endp

SETNZNCMOD proc near
;--SET NZ,NC---------
;mods flags only
setnznc:
	push	ax
	or	al,01h		;nz,nc
	pop	ax
	ret
SETNZNCMOD endp

;--GETNUM24  (get dl:ax=24 bit num)
; bx=ptr chr-1, cx=#chrs (see getnum)
; sets cy=number over 24 bits (mods dh)
getnum24:
	call	getnum		;get dx:ax=32 bit num
	jbe	gtnm90		;done (z=no,cy=bad num)
	or	dh,dh		;over 24 bits?
	jz	gtnm95		;no, ok
	stc			;cy=too big
gtnm90:	ret
gtnm95:	push	ax
	or	al,01
	pop	ax		;nc,nz
	ret

GETNUMMOD proc near
;--GETNUM --get number (+ or - integer)----
;ax=default number,reads console, number put in ax
;cy=overflow or error or quit if al="Q"
;mods ax only
;--Local storage for getnum
number	dw	0	;temp use
negflag db	0	;bit0=1 if negative number
;GETNUM1  (decode decimal number from buffer)
; bx=ptr buffer (max byte) (buff= #max,#chrs, ascii,0d)
; decode number till first illegal chr
; returns dx:ax=number (32 bit), cl=#chrs left
; 	  bx=ptr last good chr
; z=no entry, cy=bad entry
getnum1:
	inc	bx		;point to #chrs
;GETNUM2  (bx=buffer #chrs,ascii,0d), return dx:ax=number
; bx=ptr buffer (size byte)
; buffer org= #chrs, ascii chrs, 0d
getnum2:
;GETNUM (cx=#chrs left, bx=first chr-1)
; as above, but bx=ptr buff first chr-1
; dx:ax=32 bit num
getnum:	push	si
	push	di
	push	cx
	xor	si,si		;si:di=number=0
	xor	di,di
; Get Begin Number (non delim)
gnum10:	call	skipdelim	;bx=ptr last delim
	jnc	gnum12
gnum11:	jmp	gnum95		;cy=end line (no number)
gnum12:	call	getnextchr	;check if valid number begin
	call	alphanum	;z if number or "-"
	jnz	gnum95a		;not number
	cmp	al,"-"		;negative number?
	jnz	gnum21		;no, process digit
	or	[negflag],1	;yes,set flag
	jmp	short gnum70	;continue scan	
; Decode into binary
gnum20:	call	getnextchr	;incs bx before get
	jbe	gnum97		;number done (cy=eol,z="/")
gnum21:	call	upper		;check for quit
	cmp	al,"Q"		;quit?
	jz	gnum89		;yes, exit
	cmp	al,","		;comma?
	jz	gnum70		;ignore
	cmp	al,"K"		;kilo?
	jz	gnum90		;yes,mult by 1k
	cmp	al,"B"		;bank?
	jz	gnum92		;yes,mult by 64k
	cmp	al,"9"		;above 9?
	ja	gnum96		;yes,end number
	cmp	al,"0"		;below 0?
	jb	gnum96		;yes,end number
; valid chr, convert to binary
	sub	al,30		;make 0-9
	xor	ah,ah		;ax=digit
	xor	dx,dx		;dx:ax=digit
	add	di,di		;si:di=total*2
	adc	si,si
	mov	cx,5		;loop chr+2+4+6+8+10
gnum33:	jc	gnum34		;overflow
	add	ax,di		;add 2*n each loop
	adc	dx,si		;top16
	loop	gnum33
	xchg	di,ax		;si:di=32 bit total
	xchg	si,dx
gnum34:	jc	gnum81		;cy=overflow msg
gnum70:	jmp	short gnum20	;do next chr
gnum81:	mov	si,offset cseg:msgover; inform user
	call	errormsg
;illegal chrs, display message
gnum88:	mov	al,[bx]		;al=bad chr
	call	badentrymsg
gnum89:	dec	bx		;point last good chr
	xor	ax,ax
	xor	dx,dx		;dx:ax=0
	stc			;cy=bad number
	jmp	short gnum99	;exit	
;Kilo: mult number by 1024
gnum90:	mov	ax,400		;1024
	mul	di		;dx:ax=low16*1K
	xchg	di,ax		;get si:di=#
gnum91:	or	si,si		;orig msb must be 0
	jnz	gnum81		;too big
	xchg	si,dx		;ok
	jmp	short gnum97	;done
;Bank: mult num by 64k
gnum92:	xchg	dx,di		;mov # to hi16
	xor	di,di		;zero low16
	jmp	short gnum91	;test too big
;no valid entry
gnum95a:dec	bx		;point last good chr
gnum95:	cmp	ax,ax		;set z=no entry
	jmp	short gnum98	;set nc also
;all chrs done, or terminated by delim (set nz,nc)
gnum96:	dec	bx		;point last good chr
gnum97:	xchg	ax,di
	xchg	dx,si		;dx:ax=32bit number
	test	[negflag],1	;negative?
	jz	gnum97b		;no
	neg	ax		;yes
	sbb	dx,0		;32bit neg
gnum97b:
	push	ax
	or	al,01
	pop	ax		;set nz,nc=ok number
gnum98:	clc			;nc=ok number
gnum99:	pushf
	and	[negflag],0FEh	;reset neg
	popf
	pop	cx
	pop	di
	pop	si		;bx=ptr delim
	ret			;dx:ax=number,cy=error
msgover:
	db	"Number too large:",24
GETNUMMOD endp

DELIMSMOD proc near
;--SKIPDELIM (skip space or delims till chr or end line)
; cy=eol reached, nc=non delim
; cx=#chrs left,bx=index into string (last chr used)
; returns cx=#left, bx=ptr last delim
;  cy=cr,0,or "/" stopped search
skipdelim:
skipd5:	call	getnextchr	;incs bx before get,unless end
	jbe	skipd99		;end of search(cy=eol,z='/')
;<< mod for getnum in order to skip equal sign before a num>>
	call	spcomequal	;space,comma,ctrl,equal?
;	call	checkdelim	;space or comma or ctrl?
	jnc	skipd5		;no
;non-delim found
skipd98:;check for alpha num here, set z=alpha-num
	clc
	dec	bx		;point to last delim
	ret			;nc=non-delim found
skipd99:stc			;cy=end line
	ret
DELIMSMOD endp

ALPHANUMMOD proc near
;--ALPHANUM (check if alpha num)
; al=chr, nc,z=number, nc,nz=alpha, cy=other
alphanum:
	push	ax
	call	upper
	cmp	al,5a		;gt Z?
	ja	alph80		;yes,err
	cmp	al,30		;lt 0?
	jb	alph80		;yes,err
	cmp	al,39		;le 9?
	jbe	alph96		;yes,a number
	cmp	al,41		;ae A?
	jae	alph97		;yes, a letter
;check legal "alpha-num equivs" here
	cmp	al,"-"		;neg sign?
	je	alph96		;yes
alph80:	stc
	jmp	short alph99	;pop and ret
;set z=number (nc also)
alph96:	cmp	al,al		;set z
	jmp	short alph98	;ret
;set nz=alpha (nc also)
alph97:	or	al,al		;set nz
alph98:	clc
alph99:	pop	ax
	ret
ALPHANUMMOD endp

TVTILLCRMOD proc near
;--TV TILL CR (si=ptr message, stops at cr)
;mods no regs, does not output cr
tvtillcr:
	cld
	push	ax
	push	si
tvtc10:	lodsb		;al=[si],si+1 get chr
	cmp	al,0dh		;cr?
	jz	tvtc20		;yes,exit
	call	tvbyte		;tv
	jmp short tvtc10	;till done
tvtc20:	pop	si
	pop	ax
	ret
TVTILLCRMOD endp

STRINGSMOD proc near

;--BADENTRY Message (al=bad chr)
badentrymsg:
	call	errortv		;"Error"
	call	tvbyte		;show bad chr
	push	si
	mov	si,offset cseg:msgbadentry
	call	tvprompt
	pop	si
	ret
msgbadentry:
	db	" = bad entry",24
STRINGSMOD endp
subroutinesp endp
;..............................................

;=======INIT SEGMENT ==========================
jbootinit	proc far
assume cs:cseg,ds:cseg

if ($-start) mod 10h		;align on para
org ($-start)+10h-(($-start)mod 10h)
endif

buffptr	dw	offset cseg:buffer	;config.sys line

;--Transient MSG area ----
;messages:
msgjbootbin	db	0Dh,'JBOOT   ',0 ;name to print out
msgdosk		db	'now in DOS.   ',24
msgdoskwanted	db	'wanted in DOS.',24
msgramk		db	0Dh,' Sizing memory, RAM = ',24
msgcontigramk	db	'(Non-contig),  RAM = ',24
msgjramk	db	'  JRAM = ',24
msgnotenough	db	'Not enough Memory:  DOS or USERK changed',24
msglockalready	db	'RAM Disk found. DANGER: check if corrupted',0Dh,0Ah,24
msgbadswap	db	'Bad '
msgswapfull	db	'SWAP page not free: changed',0Dh,0Ah,24


;---OPTION TABLE (slash options)----
memtestopt=bit0
zerointopt=bit1
div0opt=bit2
parityopt=bit3
cadopt=bit4
flushopt=bit5
batchopt=bit6
jramopt=bit7

quietopt=bit0
timeopt=bit1
multiopt=bit2
useropt=bit3
regmemopt=bit4
onmemopt=bit5
swapopt=bit6
eagleopt=bit7

tabinitopt:
	db	3			;#items in each entry
	db	'M',bit1,9		;M=long mem test
	dw	offset memtestf
	db	'Z',zerointopt,1	;Z=zero user ints
	db	'D',div0opt,1		;D=divide by zero
	db	'P',parityopt,1		;P=parity query
	db	'C',cadopt,1		;C=contrl alt del mod
	db	'F',flushopt,21		;F=cntrl alt F=flush spooler
	dw	offset cseg:doflush
	db	'B',batchopt,1		;B=int 58 = batch file reboot
	db	'J',jramopt,1		;J=test jram
;second flag
	db	'Q',quietopt,11		;Q=quiet (no beep)
	db	'T',timeopt,1		;T=time
	db	'#',multiopt,1		;#=multitask partition,int68
	db	'U',useropt,20
	dw	offset cseg:douser
	db	'R',regmemopt,20
	dw	offset cseg:doregmem
	db	'O',onmemopt,20
	dw	offset cseg:doonmem
	db	'S',swapopt,20
	dw	offset cseg:doswap
	db	'E',eagleopt,20
	dw	offset cseg:doeagle
	db	'Y',0,21
	dw	offset cseg:doyear
	db	'X',0,21
	dw	offset cseg:dox
	db	'V',0,21
	dw	offset cseg:dooops
	db	0			;end of table

;--Port Table
porttab1:
	dw	3F8,2F8,3E8,2E8,368,268,348,248	;COM1-COM8

;==Transient CODE area=========================================
public init
if ($-start) mod 10h		;align on para
org ($-start)+10h-(($-start)mod 10h)
endif
;--INIT JBOOT (ds:bx=req hdr)
init:
;--Get Command Line, move to local buffer
	xor	bp,bp		;bp=0 used below
	lds	si,dword ptr [bx+12] ;ds:si=ptr to command str (source)
	push	cs
	pop	es		;es:di=local buff (dest)
	mov	di,offset cseg:buffer
	mov	cx,100		;256 bytes max
	rep	movsb
;--Stop disk from turning (ds=0, es=cs, delay for action at mpi40)
stopdisk:
	mov	ds,bp		;0:440=motor count
	mov	si,400
	mov	word ptr[si+40],2 ;set count to 2 (108 ms)

;--Get [413], [158+] vals if [158]=1111 (ds=0, es=cs)
; [413] always = 1234 in COMPAQ, so [158] is used
	mov	di,offset cseg:jbflagtab ;start of table
	mov	si,413
	lodsw			;ax=0:413=dos size in Kbytes
	stosw			;init [origdosk],di+2
	stosw			;init [doskwanted],di+2
	mov	si,158		;(di=ptr internal jbflagcop)
	mov	ax,[si]		;get flag
	cmp	ax,1111		;previous jboot?
	je	mpi01		;yes, warm boot,do copy
	cmp	ax,0011		;makedos reboot?
	jne	mpi02		;no, cold boot,no copy
mpi01:	mov	cx,jbcopsize	;flag, datelo,datehi,etc.
	rep	movsw		;move to internal
	or	cs:[memtestf],bit6+bit4 ;indicate warmboot
mpi02:
;--Get local copy of int vectors (es=cs,ds=0)
	xor	si,si		;ds:si=0:0 (source)
	mov	di,offset cseg:intvectable ;es=cs (dest)
	mov	cx,40h		;32vecs * 2 words=64words
	rep	movsw		;move es:di=ds:si

;--Check for all 8 possible COM ports
; (es=cs, ds=0)
checkports:
	push	cs		;ds=cs
	pop	ds
	mov	si,offset cseg:porttab1 ;list of port addresses
	mov	di,offset cseg:porttab	;final list
	mov	cl,8		;8 poss com ports
ckpt10:	mov	dx,[si]		;dx=addr of poss port
	inc	dx
	inc	dx		;point to irq id reg (like 2FA)
	mov	al,0ff
	out	dx,al
	in 	al,dx
	and	al,0F8h		;serial port there?
	jnz	ckpt30		;no
	movsw			;yes, put in table [di]=[si]
	jmp	short ckpt33	
ckpt30:	lodsw			;cheap si+2
ckpt33:	loop	ckpt10

;--Move first 4 coms to DOS table at 400-408h
	mov	es,bp		;es=0
	mov	di,400		;0:400=destination
	mov	si,offset cseg:porttab
	mov	cl,4		;4 com ports
	rep	movsw		;update DOS table
;--Get DOS parallel ports into local table
	push	cs
	pop	es		;es=cs
	mov	ds,bp		;ds=0
	xchg	di,si		;ds:si=0:408=parallel ports
	add	di,8		;point to end of local table
	mov	cx,4
	rep	movsw		;get parallel ports
;--Calc checksum  (es=cs, ds=0)
	push	cs		;ds=cs
	pop	ds
	mov	si,offset cseg:intvectable ;es=cs (dest)
	mov	cx,checksumsize	;#bytes to sum
	call	getchecksum	;calc for these vecs+code
	mov	[checksum],ax	;save result

;--Get NUMBERS and OPTIONS (string from config.sys file is in buffer)
options:
	mov	si,offset cseg:buffer ;ptr command str
opts5:	lodsb			;al=[si],si+1
	cmp	al,20h		;20 ,0 or 0D? end of name?
	ja	opts5		;no
	cmp	byte ptr[si],20h ;end of line?(no num no opts?)
	jae	opts7		;no
	dec	si		;point to 0, force end of line
	mov	byte ptr[si],0Dh
opts7:	mov	bx,si		;bx=end of name+1=begin opts
	mov	[buffptr],bx	;save for later display
	dec	bx		;getnum incs bx

;--Get first number (DOSKWANTED wanted size of DOS)
	call	getnum24	;bx=ptr chrs
	jbe	opts40		;cy=bad,z=no num, use [origdosk]
	call	dlaxtok		;ax=dl:ax/1k (rounded up)
	cmp	ax,40		;64k is min allowed
	jb	opts40		;below, use current value [origdosk]
	mov	[doskwanted],ax	;range 64k+ (40h+)(704k=2C0h)

;--get SLASH OPTIONS (/a,b,c,etc)
opts40:	push	bx
	mov	bx,offset cseg:defaultstr-1	;default str
	mov	si,offset cseg:initflag1	;init default flag
	mov	di,offset cseg:tabinitopt	;slash options table
	call	getopt				;do defaults
	pop	bx
	call	getopt		;bx=ptr string (user specd)
	jmp	opts55

dosubs proc near
;--"DO" Routines called by getopt

;"F" Option (cntrl-alt-f flushes spooler buff)
doflush:
	mov	al,53
	jnz	dofh56		; -F specd
	mov	al,21		; F
dofh56:	mov	[byte ptr flush1+1],al ;modify code
	ret

;"U" USERK  #K reserved for user application
douser:
	call	getnum24	;"U"
	jbe	dous90		;cy=bad,z=no num,use default
	call	dlaxtok		;get ax=#k
	mov	[userk],ax	;#k reserved by user
dous90:	ret

;"R" MAX REG MEM #banks reg memory possible 10b=640k
; (i.e.top bank to check for reg mem (must be below 15 if JRAM used.))
doregmem:
	call	getnum24
	jbe	dorg90		;cy=bad,z=no num, use default
	or	ax,ax		;even #64k blocks?
	jnz	dorg90		;no, error,use default
	dec	dl		;convert #banks to bank#
	js	dorg90		;0=default
	cmp	dl,0Fh		;must be 0-F
	ja	dorg90		;bad, use default
	mov	[maxregmem],dl	;max turned-on mem
dorg90:	ret

;"O" MAX TURNED ON MEM #banks turned-on memory 10b=640k
doonmem:
	call	getnum24
	jbe	doon90		;cy=bad,z=no num, use default
	or	ax,ax		;even #64k blocks?
	jnz	doon90		;no, error,use default
	dec	dl		;convert #banks to bank#
	js	doon90		;0=default
	cmp	dl,[maxregmem]	;maxtonmem le maxreg?
	ja	doon90		;bad, use default
	mov	[maxtonmem],dl	;max turned-on mem
doon90:	ret

;"S" SWAP BANK  13b=page 0D
doswap:
	call	getnum24
	jbe	dosw90		;cy=bad,z=no num, use default
	or	dl,dl		;0 entry?
	jz	dosw90		;yes, use default
	or	ax,ax		;even #64k blocks?
	jnz	dosw38		;no, error,use default
;is this obsolete???
	mov	al,dl
	cmp	al,0Bh		;cant use tv page
	je	dosw38		;ok
	cmp	al,0Eh		;must be 0E or below
	jbe	dosw39		;ok
dosw38:	mov	si,offset cseg:msgbadswap
	call	errormsg
	jmp	dosw90		;use default
dosw39:	mov	[swapbank],al
dosw90:	ret

;"X" Set/Reset legal Memory bank# (11B=704k= bank B)
dox:	pushf			;nz=-X, z=X
	call	getnum24	;get bank#
	jbe	dox90		;cy=bad,z=no num, use default
	or	dl,dl		;0 entry?
	jz	dox90		;yes, use default
	xor	ax,ax		;for -X
	popf
	pushf
	jnz	dox30		;-X
	inc	ax		;X
dox30:	push	bx		;chr ptr
	xor	bx,bx
	mov	bl,dl
	shl	bx,1		;bx=word index into tempbanks
	mov	word ptr[bx+offset cseg:tempbanks],ax
	pop	bx		;chr ptr
dox90:	popf
	ret

;"E" Eagle patches
doeagle:
	jnz	doea90		;-E
	mov	ax,9090		;nops
	mov	word ptr[egpt1],ax	;elim out,0A0
	mov	word ptr[egpt2],ax
doea90:	ret

;"Y" Year patch (elim retainment of date)
doyear:	mov	ax,08EBh	;jmp +8 (-Y)
	jnz	doyr80		;-Y
	mov	ax,21CDh	;int 21 (Y)
doyr80:	mov	word ptr[datept],ax ;modify date save
	ret

;"V" Change mind during coldboot patch
dooops:	mov	ax,90FFh	; nop + no irqs (-V)
	jnz	dooo80		;-V
	mov	ax,0FBFDh	;sti + allow keyboard (V)
dooo80:	mov	byte ptr [pat10+1],al ;allow only keyboard
	mov	byte ptr [pat11],ah   ;sti, allow change of mind
	ret

dosubs endp

;--------------begin code again -----------
;"Z" Option (Zero user INTs)
opts55:	test	[initflag1],zerointopt
	jz	opts60		;-Z
	push	es
	mov	di,150		;yes, zero 0:150 to 3ff
	mov	cx,2B0		;zero int 54 thru FF
	call	ifat
	jnz	opts57
	xor	ax,ax		;at vecs int 70 thru 77
	mov	es,ax
	mov	cx,70		;zero 0:150 to 1bf
	rep	stosb		;int 54 thru 6f
	mov	di,1e0		;zero 0:1e0 to 3ff
	mov	cx,220		;int 78-ff
opts57:	xor	ax,ax
	mov	es,ax
	rep	stosb
	pop	es
opts60:
opts95:

;--MEMTEST/ FILL BANK TABLE
; 4096 bytes checked, 1 sec to do this no test mem
memtest:
;setup ax=dos now, cx=dos wanted for poss display
mpi15:	mov	si,offset cseg:memtestf
	and	byte ptr[si], not bit5 ;elim dos change flag
	mov	ax,[origdosk]
	mov	cx,[doskwanted]
	cmp	ax,cx			;dos change size?
	jz	mpi17			;no
	or	byte ptr[si],bit5	;yes
mpi17:	test	byte ptr[si],bit4	;prev mem scan? (1111 or equiv.)
	jz	mpi40			;no,cold boot
	test	byte ptr[si],bit7	;80=bad banks gt 0?
	jnz	mpi40			;yes, keep memtest on
	and	byte ptr[si],not (bit0+bit1) ;warm boot,no fill or test
	test	byte ptr[si],bit3	;show message?
	jnz	mpi40			;yes
	cmp	ax,cx			;dos changes size?
	je	mpi41			;no, no message
;show name and sizes wanted
mpi40:	or	byte ptr[si],bit4	;20=will scan mem
	mov	si,offset cseg:msgjbootbin
	call	tvprompt
	mov	si,offset cseg:verno	;ver#
	call	tvprompt
	mov	si,offset cseg:serno	;ser#
	call	tvprompt
	call	blank			;1 space
	mov	si,offset cseg:serno+7	;Copyright
	call	tvprompt
	call	crlf
	mov	si,[buffptr]
	call	tvtillcr		;show entered options
	call	showdosk
	xchg	ax,cx
	call	binascaxk		;show user wanted amount
	mov	si,offset cseg:msgdoskwanted
	call	tvprompt
	call	crlf
	mov	al,1
	call	delayal			;.1 sec for motor to stop

;turn jram off, size reg memory (may turn off DOS if in jram)
mpi41:	push	cs
	pop	es		;get es:di=temp jram banktable
	mov	di,offset cseg:tempjbanks
	xor	ax,ax
	mov	cx,101		;allow 256+1 words
	rep	stosw		;store zeroes
	mov	si,offset cseg:msgramk
	call	tvprompt
	call	turnoffall	;reset disk,kill nmi, new nmi, jram off
				;from now on, NO DOS CALLS
	mov	[nbadbanks],0	;
	mov	bx,1		;start at bank#1 (64k+)
	mov	di,offset cseg:tempbanks+2 ;bank#1
	mov	cx,0101		;ch=count,cl=last good contig reg mem+1
mpi42:	cmp	word ptr [di],0	;is membank entry free?
	jne	mpi44		;no, skip it (not contig)
	call	banktest	;mem there?
	jnc	mpi43		;good mem
	jz	mpi44		;no mem
	mov	ax,bx		;ax=bad bank#
	mov	si,offset cseg:msgbadmem4
	call	tvprompt	;bad reg mem
	call	binhexax
	call	crlf
	inc	byte ptr[di]	;0001=bad bank
	inc	[nbadbanks]	;#bad+1
	jmp	short mpi43a	;still contig (because it's reg mem)
mpi43:	call	banktoseg	;get es= mem code (1000,2000,etc)
	mov	word ptr[di],es	;fill bank table
mpi43a:	inc	ch		;ch=#reg mem banks
	cmp	bl,cl		;last good+1 = cur good? (contig?)
	jnz	mpi44		;no
	mov	cl,ch		;yes, contig
mpi44:	inc	bl		;next bank
	inc	di		;next bank
	inc	di
	cmp	bl,[maxregmem]	;all poss reg mem done? (0-E?)
	jbe	mpi42		;no, do next bank
	mov	[rambanks],cx	;ch=#ram, cl=good+1 (#contig)

;--TEST JRAM
;init and test each bank of all boards
;(ch=#ram banks, cl=last good+1 = #contig banks)
testjram:
	push	cx		;ch=#banks, cl=#contig
	xor	ax,ax		;ah=board#, al=quad+bank
	xor	cx,cx		;default jram=0
	test	[initflag1],jramopt ;ok to test jram?
	jz	mpi60		;no
;check if swap page is free
	mov	di,offset cseg:tempbanks
	xor	bh,bh
	mov	bl,[swapbank]	;check if swap page free
	shl	bx,1		;index to table
	add	di,bx		;di=swap ptr
	cmp	word ptr[di],ax ;0=free?
	jz	mpi54		;yes
;search for swap page (page 0 illegal)
	mov	si,offset cseg:msgswapfull
	call	errormsg	;bad swap
	mov	di,offset cseg:tempbanks+0Eh+0Eh;
	mov	cx,0Eh		;start at page E
	push	cs
	pop	es
	std			;hi to low
	repnz	scasw		;find a 0000
	cld
	jnz	mpi60		;no free bank
	dec	di
	dec	di		;ptr to free bank
	inc	cl
	mov	[swapbank],cl	;new swap bank (1-E)
mpi54:	inc	word ptr [di]	;denote that it is not free

;test banks, leave invisible (all tests use swap bank)
; ax=0 = board + quad + bank
	xor	cx,cx		;cx=#jram banks counter
	mov	di,offset cseg:tempjbanks ;for jram sizing
mpi55:	call	progjramswap	;ah=board,al=quad+bank
	jc	mpi57		;cy=no or bad jram found
	inc	cx		;#jram banks
mpi57:	cmp	ah,8		;all boards done?
	jb	mpi55		;no
mpi60:	mov	[jrambanks],cx
	pop	bx		;bh=#ram, bl=#contig ram,(cx=#jram)
	test	[nbadbanks],0FFh ;any bad banks?
	jz	mpi63		;no
	or	[memtestf],83	;noted (keep fill+test)

;--Display Sizes (bh=tot reg mem, bl=contig reg mem, cx=#jram)
mpi63:	push	bx
	cmp	bh,bl		;all contig?
	jz	mpi64		;yes
	xchg	bh,bl		;no, show total
	call	nbanktok	;get ax=#k reg mem tot
	call	binascaxk
	xchg	bh,bl
	mov	si,offset cseg:msgcontigramk
	call	tvprompt
mpi64:	call	nbanktok
	call	binascaxk	;#k contig reg mem
	jcxz	mpi65		;no jram
	mov	si,offset cseg:msgjramk
	call	tvprompt
	mov	bx,cx		;cl=#banks found
	call	nbanktok1	;get ax=#k
	call	binascaxk	;#k of jram
mpi65:	pop	dx		;dh=#reg mem, dl=#contig banks
	xor	ax,ax
	mov	al,dl		;get tot=contig+jram
	add	ax,cx		;ax=total #banks
	mov	bp,ax		;bp=total # banks (jram+contig)
	mov	[nbanks],ax
	mov	[jbflagcop],1111;mem init done
	call	turnonall	;old nmi,parity +nmi on

;Check requested sizes vs avail memory
	mov	ax,[doskwanted]
	call	ktobank		;bl=bank# needed for dos
	mov	[dosbank],bl
	mov	dh,bl		;dh=dosbank#
	add	ax,[userk]	;total K needed
	call	ktobank1
	inc	bx		;#dos+user banks
	mov	[freebank],bx
				;cx=#banks of jram
;Scan for max turned-on mem poss (dl=#contig banks, dh=dosbank#)
	mov	cx,0Ah		;10 banks to scan (1-A)
	mov	di,offset cseg:tempbanks+2 ;skip bank0
	push	cs
	pop	es
	xor	ax,ax
	repnz	scasw		;find zero
	push	cx		;scasw decs cx before comp
	repz	scasw		;find a non-zero
	jz	mpi66		;found it
	inc	cx		;not found,correct cx
mpi66:	pop	ax
	sub	ax,cx		;ax=#zeros(free banks)-1
	add	al,dl		;ax=max bank# avail (0-A)
;check DOSK (bx=#dos+user, dh=dos bank#, dl=#contig banks, bp=#tot banks)
	xor	cx,cx		;cx=flag for error
	cmp	ax,bp		;max #banks-1 lt total?
	jb	mpi67		;yes, use ax
	mov	ax,bp		;no, use total
	dec	ax		;make bank#
mpi67:	cmp	al,dh		;max bank# poss ge dos bank#?
	jae	mpi68		;yes, ok
	inc	cx		;cx=1=error
	mov	bl,al		;set dos=max poss
	call	banktok		;ax=max pos dosk
	mov	[doskwanted],ax
	add	ax,[userk]	;new dos+user
	call	ktobank1	;get bl=bank#
	inc	bx		;new #dos+user
;check USERK (bx=#dos+user,  bp=#banks tot)
mpi68:	sub	bx,bp		;#dos+user - #banks tot?
	jbe	mpi69		;enuf mem
	inc	cx		;cx=1=not enuf mem
	call	nbanktok1	;convert extra wanted user to k
	sub	[userk],ax	;reduce userk
	jnc	mpi69		;enuf space for user
	mov	[userk],0	;no space
mpi69:	jcxz	mpi70		;no error
errornotice:
	or	[memtestf],bit3	;force message
	mov	bl,[swapbank]	;clear swap page for retry
	shl	bx,1		;index to table
	mov	byte ptr[bx+offset cseg:tempbanks],0 ;0=free
	mov	si,offset cseg:msgnotenough
	call	errormsg
	call	crlf
	jmp	mpi15		;try again

;bp=#banks total, dl=#contig
mpi70:	add	bx,bp		;recover bx
	xor	dh,dh		;dx=#contig banks

;--SIZING FINISHED, turn on windows and setup table
; bx=#dos+user, dx=#contig , bp=#banks avail
;assemble final table into one piece
	push	cs
	pop	es		;es=cs (ds=cs)
	mov	si,offset cseg:tempbanks  ;move regmem info
	mov	di,offset cseg:tempbanks1 ;assembled table
	mov	cx,dx		;#contig banks
	rep	movsw
	mov	si,offset cseg:tempjbanks ;append jram info
	test	[initflag1],jramopt ;ok to allow jram?
	jz	mpi73		;no
	mov	cx,101		;100 words (256 banks=8 boards)
	rep	movsw		;(+1 for end of table)

;turn on dos banks and as many userk banks as poss
;bx=#dos+user,	dx=#contig banks, bp=tot #banks
mpi73:	mov	cl,[maxtonmem]	;gt dos, but may be lt dos+user
	or	cx,cx		;zero = autosize?
	jnz	mpi84		;no,use entered value
				;yes,set max=dos+user#
	mov	cl,0A		;top bank# poss (704k)
	dec	bx		;bx=bank#
	cmp	bx,cx		;dos+user# gt 0A?
	ja	mpi84		;yes, use 0A
	mov	cx,bx		;no, use dos+user#
mpi84:	mov	[maxtonmem],cl
	inc	cx		;cx=tot #banks to be left on
	sub	cx,dx		;cx=#banks needing turnon
	jbe	mpi89		;none
	xchg	bx,dx		;bx=first bank# to turn on (jram)
;bx=first bank to turn on, cx=#banks
	mov	di,offset cseg:tempbanks1 ;start after contig banks
mpi86:	shl	bx,1		;word ptr
	mov	ax,[di+bx]	;get code
	mov	dx,ax
	or	al,80		;signify "on"
	mov	[di+bx],al	;update table
	shr	bx,1
	and	al,070		;elim "on" and bank#
	mov	es,ax		;(es=E830)
	xchg	ax,dx		;al=bank#
	call	jrambankon1	;es=creg, al=bank#, bl=window
	inc	bx		;next bank
	loop	mpi86		;till done
mpi89:	

;check for jdrive(s) in memory (maybe corrupted if rom reset)
mpi90:	call	jdrivelock	;(uses tempbanks1, tests freebank)
	mov	al,[memtestf]
	jc	mpi96		;cy=no jdr found
	test	al,bit6		;warm boot?
	jz	mpi93		;no, corrupted
	test	al,bit5		;dos change size?
	jz	mpi96		;no	
mpi93:	mov	si,offset cseg:msglockalready
	call	errormsg
mpi96:	test	al,bit5		;dos change size?
	jz	setmisc		;no, dont reboot

;=========================================
; REBOOT NECESSARY (#K Wanted diff from Actual)
;disable serial/parallel port irqs, reset pending irqs (why?)
;use int56+ area to set jboot vals to be recoverd after reboot
	call	stuff158	;put jbflagtab at [158+]
				;sets [413]=[doskwanted],sets es=0
	call	disableirqs	;end keybd irq etc. (irq0-7)
	int	19		;dos boot

;==========================================
; NO REBOOT, SET MISC VALUES

; Set Ending Addr (next valid addr after end)
; (ds=cs)
setmisc:
	mov	ax,[origdosk]
	call	showdosk	;(crlf finishes ram-size msg)
	call	crlf
	xor	ax,ax
	mov	ax,[nbanks]	;# banks in table
	inc	ax		;+1 for 0=end of bank
	shl	ax,1		;#words
	add	ax,offset cseg:membanks	;end of resident part
	mov	dx,cs		;segment of driver end
	call	setendaddr	;dx:ax=end

;--Obtain and Plug into INTERRUPT CHAINS ----------
;--KEYBOARD Setup (Int 9)
	cli
	mov	di,offset cseg:initflag1 ;options flag
	test	byte ptr[di],cadopt	;control alt del wanted?
	jz	stmi30			;no
	mov	al,9			;vec 9
	mov	bx,offset cseg:new09
	call	xchgvectorcs		;set new vec 9
	mov	[word ptr jmp09+1],bx	;continue chain
	mov	[word ptr jmp09+3],dx

;--DIV0 Setup (Int 0)
stmi30:	test	byte ptr[di],div0opt	;div by 0 trap?
	jz	stmi40			;no
	mov	al,0			;vec 0
	mov	bx,offset cseg:new00
	call	xchgvectorcs

;--NMI Setup (Int 2)
stmi40:	test	byte ptr[di],parityopt	;parity trap?
	jz	stmi50			;no
	mov	al,2			;vec 2
	mov	bx,offset cseg:new02
	call	xchgvectorcs

;--INT 58 (Batch File reboot)  /B option
; overwrites date stored in this area
stmi50:	test	byte ptr[di],batchopt	;batch reboot?
	jz	stmi55			;no
	mov	al,[jbootvec]		;vec 58=160h
	mov	bx,offset cseg:makedos	;???batchint	;new58
	call	xchgvectorcs
;--Set QUIET if requested /Q option
stmi55:	inc	di			;next flag
	test	byte ptr[di],quietopt	;no beep?
	jz	stmi60			;keep beep
	mov	byte ptr[cseg:msgwarm1],20   ;elim beep from warm boot msg
	mov	byte ptr[cseg:coldsweep],0C3 ;put return in coldsweep
;--Set up Multitask interface /#  (??? not yet implemented)
stmi60:	test	byte ptr[di],multiopt	;multitask interrrupt?
	jz	stmi65			;no
	mov	al,[jbootvec]		;vec 68=1A0h
	mov	bx,offset cseg:makedos	;???batchint	;new58
	call	xchgvectorcs
stmi65:
;--Set DATE (recovered if warm boot)
stmi90:	call	ifat
	jz	userinit		;dos 3 sets AT date
	cmp	word ptr[datept],8ebh
	jz	userinit		;no save - no set
	mov	dx,[datelow]
	mov	cx,[datehi]		;get cx:dx=date
	mov	ah,2Bh
	int	21			;set date
userinit:
iexit:
;SPECIFIC IRQ RESET reset interrupt chip (why do this???)
	mov	al,61h		;end of irq
	out	20,al		;reset chip
	mov	si,offset cseg:tempbanks ;regmem + final table
	mov	di,offset cseg:regmembanks ;resident table
	push	cs
	pop	es		;es=cs  (ds=cs)
	mov	cx,131		;10 reg+ 10 mem + 100 words (8 boards)
	jmp	copytemp	;copy table and return

;==========INIT SUBROUTINES======================
initsubsp proc near

;--SHOW DOSK (ax=#k in dos)
showdosk:
	call	crlf
	call	blank
	call	binascaxk		;show #k in dos
	mov	si,offset cseg:msgdosk
	call	tvprompt
	ret

openbankp proc near
; === NMI and PARITY ON-OFF CONTROL ===
;(port A0 gates NMI to cpu, port 61 clears/allows parity
;port A0 also gates numeric processor ints)

;TURNOFF ALL (NMI, Jram, etc.)
;sets up temp nmi for use in mem testing
;mods bx,dx
turnoffall:
	call	parityoff	;cli,reset disk,clear parity, nmi off
	mov	bx,offset cseg:tempnmi
	mov	al,2		;set new NMI vec 2
	call	xchgvectorcs
	mov	[nmioffset],bx	;dx:bx=old NMI vec
	mov	[nmiseg],dx
	test	[initflag1],jramopt ;test jram?
	jz	toa90		;no
	jmp	turnoffjram	;turn off all JRAM
toa90:	ret

;TURN ON ALL (restore nmi, turn on parity, nmi port,
;mods bx,dx
turnonall:
	push	ax
	push	bx
	push	dx
	call	parityoff	;cli,reset ff and port62, turn off nmi gate
	mov	al,2		;NMI=vec 2
	mov	bx,[word ptr nmioffset]
	mov	dx,[word ptr nmiseg]
	call	xchgvector	;recover old nmi vector
	pop	dx
	pop	bx
	pop	ax
parityon:
	call	resetnmi	;clear ff's and port 62 info
nmion:	push	ax
	call	ifat
	jz	atpon		;at pc
	mov	al,80		;nmi can reach cpu
egpt1:	out	0A0,al		;patched out for eagle
	pop	ax
	ret
atpon:	in	al,61
	or	al,0c		;tog io/par ck en off
	jmp	short $+2
	out	61,al
	jmp	short $+2
	and	al,0f3		;then io/par ck en on
	out	61,al
	pop	ax
	ret

nmioffset	dw	0
nmiseg		dw	0

; nmi off, reset disk, cli, parity chk off,clears parity info at port 62
parityoff:
	push	ax
	call	ifat
	jz	atpoff		;at pc
	xor	ax,ax		;0=NMI cant reach cpu (parity,n.p.)
egpt2:	out	0A0,al
	int	13		;reset disk (NEC chip,etc.)
	pop	ax
	cli
	jmp	resetnmi	;reset ram and iock ff
atpoff:	in	al,61
	jmp	short $+2
	or	al,0c		;set io/par ck en off
	out	61,al
	xor	ax,ax
	int	13		;reset disk (NEC chip,etc.)
	pop	ax
	ret


;--PROGRAM JRAM (bl=window#, ah=board 0-7, al=quad+boardbank 0-3, 0-7)
; fill membanks, update ah,al to next conseq boardbank
progjramswap:
	mov	bl,[swapbank]	;0Dh;force swap bank
;bl=bank# (window) to turn on, bank left on unless swapbank
;di=ptr membanks entry, sets es=CREG
progjram:
	push	cx
	push	ax		;ah=board 0-7,al=quad+bank
prjr5:	cmp	word ptr [di],0	;is membank entry free
	je	prjr10
	cmp	di,offset cseg:tempbanksend ;space left?
	jb	prjr6
	jmp	prjr33		;no, set cy
prjr6:	inc	di
	inc	di		;next entry
	jmp	short prjr5
prjr10:	call	jrambankon	;sets es=CREG,al=TON
	call	banktest1	;there?
	pushf			;save flag, cy,z=no mem
	jc	prjr18		;no good mem present
	push	ax		;ck for lower dialed-in
	push	bx		; mem which matches
	push	ds		; current bank
	push	es
	call	banktoseg	;es=mem segment
	cmp	bl,0a
	jbe	prjr11
	mov	bl,0a
prjr11:	mov	cl,0c
	shl	bx,cl		;conv to seg adr
prjr12:	sub	bh,10
	jz	prjr17		;end of redundent test
	mov	ds,bx
	mov	ax,word ptr es:[bx]
	cmp	ax,word ptr[bx]
	jne	prjr12		;no match
	not	word ptr es:[bx]
	not	ax
	cmp	ax,word ptr[bx]
	not	word ptr es:[bx]
	jne	prjr12		;no 2nd match
	pop	es		;match - mem same
	pop	ds
	pop	bx
	pop	ax
	popf
	xor	cx,cx		;set no mem
	stc
	pushf
	jmp	short prjr18
prjr17:	pop	es		;no match found
	pop	ds
	pop	bx
	pop	ax
prjr18:	mov	cx,es		;cx=CREG (E820)
	or	cl,80		;(make E8A0 = on already)
	cmp	bl,[swapbank]	;0Dh;swap bank?
	jnz	prjr20		;no turn-off needed
	xor	cl,80		;(make E820)
	mov	es:[0],al	;turnoff bank
prjr20:	popf
	pop	ax		;orig vals
	jnc	prjr35		;mem found
;display bad memory bank info
	jz	prjr45		;no mem (cy,z)
	inc	[nbadbanks]	;bad+1
	push	ax
	mov	si,offset cseg:msgbadmem1 ;BOARD
	call	tvprompt
	mov	cx,ax		;ch=board, cl=quad+bank
	xor	ax,ax
	mov	al,ch		;ax=board#
	inc	ax
	call	binascax
	mov	si,offset cseg:msgbadmem2 ;BANK
	call	tvprompt
	mov	al,cl
	and	al,07h		;ax=bank#
	call	binascax
	mov	si,offset cseg:msgbadmem3 ;QUAD
	call	tvprompt
	mov	al,cl
	mov	cl,4
	shr	al,cl		;ax=quad#
	call	binascax
	call	crlf
prjr33:	pop	ax
	stc
	jmp	short prjr45
;membank found, fill table
prjr35:	or	cl,al		;add quad+bank info, set nc
	mov	[di],cx		;fill membanks
prjr45:	pop	cx		;count
	pushf			;retain flag
	add	al,10		;next quad (0-3 in top nib)
	cmp	al,40		;all quads done?
	jb	prjr55		;no
	inc	al		;next bank (0-7)
	and	al,07		;init quad=0, z=board done?
	jnz	prjr55		;no,still in same board
	inc	ah		;next board
prjr55:	popf			;restore flag
	ret			;cy=mem not found

msgbadmem1	db	' -Bad JRAM, board=',24
msgbadmem2	db	', bank=',24
msgbadmem3	db	', quad=',24
msgbadmem4	db	' -Bad Mem bank=',24

;--BANKTEST 1 (tests for 256 or 64k chips)
; bl=window
; board on with al=TURN ON val, es=CREG (like E820),
; cy,nz = bad mem
; cy,z = no memory found or quad specd with 64k chip
check256:
banktest1:
	push	ax
	push	cx
	push	si
	push	di
	push	es
	push	ds
	and	al,0DFh		;elim bit5= off, set nc
	pushf			;save cli, nc set (good mem)
	call	parityoff	;sets cli (mem cant change)

;test for 256k chips (if quad gt 0 specd)
	push	dx
	push	es		;es=E820,etc
	mov	dx,es		;al=TON, dx=CREG
	call	banktoseg	;get es=mem segment
	push	es
	pop	ds		;ds=mem seg
	mov	ah,dl		;ah=quad info
	xor	dl,dl
	mov	es,dx		;es=E800-F100 (no quad info)
	mov	dh,ah		;dh=quad info (0,10,20,30)
	mov	cl,4
	shr	dx,cl		;dx=0,100,200,300 =quad info
	mov	si,dx		;es:si=creg ,(al=ton)
	jz	bt1f		;quad=0 ok for 64k chip
	xor	dh,3		;get another quad
	mov	di,dx		;si=turnon#1, di=turnon#2,al=TON
bt1d:	mov	cx,[di]		;cx=value inside quad#1
	mov	es:[di],al	;turnon quad #2
	mov	dx,[di]		;dx=value inside quad#2
	cmp	cx,dx		;same?
	jnz	bt1f		;no, must be 256k chip
	not	dx		;invert and store
	mov	[di],dx
	mov	es:[si],al	;turnon quad #1
	cmp	dx,[di]		;inverted quad2 = quad1 ?
	mov	es:[di],al	;turnon quad #2
	mov	[di],cx		;restored
	jnz	bt1f		;not same, must be 256k chip
	pop	es		;64k chip, illegal quad specd
	pop	dx
	xor	si,si		;si=0=no mem
	jmp	bt95		;no quad poss,set z,cy
bt1f:	mov	es:[si],al	;turnon orig quad #1
	pop	es		;orig creg (E820)
	pop	dx
	popf
	jmp	short bt7	;test this bank

;--BANK TEST (set cy=not there or bad mem)----------
; non-destructive test of all mem in the bank
; before entry , temp nmi must be set up (see turnoffall)
; bl=bank# 0-nn, 0=0-64k,1=64-128k,etc
; cy=no mem or bad chip
banktest:
	push	ax
	push	cx
	push	si
	push	di
	push	es
	push	ds
bt7:	xor	di,di		;also set nc=good mem
	xor	si,si		;si=counts errors
	pushf			;save state of cli
	call	parityoff	;cli,(at power on, parity is random)
	call	banktoseg	;bl=bank#,get es=seg

; compare 16 words to affirm mere presence of bank
	push	es		;ds=es (si=di=0)
	pop	ds		
	mov	di,6001		;will test all 16k banks
	push	bx
bt12:	mov	bx,[di+2]	;normal bus data
	mov	ax,[di]		;normal bus data
	not	ax
	mov	[di],ax		;inverted bus data
	mov	[di+2],bx	;normal bus data
	cmp	ax,[di]		;still inverted?
	not	ax
	mov	[di],ax		;restored (resets parity ff)
	je	bt14		;good mem
	inc	si		;no, #bad+1
bt14:	shl	di,1		;mult * 2
	jnz	bt12		;not done
	pop	bx
	or	si,si		;good mem? (si=0?)
	jz	bt16		;yes
	sub	si,10		;all 16 bad? = no mem
	jmp	short bt95	;z=no mem, nz=bad mem (si=0 or n)

; store data to store correct parity (in case just after power-up)
bt16:	test	cs:[memtestf],01 ;bit1=test, bit0=fill
	jz	bt20		;no fill
	mov	cx,8000		;32k words/bank (es=ds, di=si=0)
	rep	movsw		;mov in place (es:di=ds:si)
;(time=32768 *25 * .21= 32k * 5.25 usec=172 ms per bank)

;		====Main test loop =====
;CALCULATED times:
;106 clocks * .21 * 32k = .729 sec/bank (5.84 sec/512k)
;149 clocks * .21 * 16k = .512 sec/bank (4.10 sec/512k) 29.7% faster
;141 clocks * .21 * 16k = .485 sec/bank (3.88 sec/512k) 
;265(133)   * .21 *  8k = .456 sec/bank (3.65 sec/512k)
;MEASURED are:
;orig 106		  .750 sec/bank  ( 6.01 sec/512k)
;     195		  .665 sec/bank  ( 5.32 sec/512k)
;149			  .581 sec/bank	 ( 4.6  sec/512k)
;141			  .526 sec/bank  ( 4.21 sec/512k)
;(265 guess .496 sec)

;NON-COMPARE MEM TEST LOOP (requires parity to detect error)
; will detect any stuck bit except the parity bit
; di=si=0, ds=mem space (8k * 4 words/loop)
; si will count the # of parity errors
bt20:	test	cs:[memtestf],02;bit1=test ok?
	jz	bt98		;no,done, good mem
	call	parityon	;reset ff's and port62, nmi on
	not	byte ptr [di]	;no wrap for at
bt24:	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	not	word ptr [di]	;29
	inc	di		;2
	inc	di
	je	bt25
	dec	di
	not	word ptr [di]	;29
	inc	di		;2
	jmp	short bt24	;16/4 (total 264/qword)
bt25:	dec	di
	not	byte ptr [di]	;no wrap for at
bt27:	or	si,si		;si=0=good mem?
	jz	bt98		;yes
bt95:	popf
	or	si,si		;set z= no mem
	stc			;cy=bad or no mem
	pushf
bt98:	call	parityon
	popf			;recover irq state
bt99:	pop	ds
	pop	es
	pop	di
	pop	si
	pop	cx
	pop	ax
	ret			;nc=good, cy=bad,z=no mem

;--Parity error (NMI) handler
tempnmi:
	inc	si		;#bad+1
	push	ax
	mov	ax,di		;get addr
	push	ds
	push	cs
	pop	ds		;ds=cs
	call	binhexaxsp	;show
	pop	ds
	pop	ax
	cli
	cmp	si,0010		;limit before termination
	jae	tpni30		;over limit, terminate
tpni90:	call	parityon	;reset ff's and port62 info, nmi on
	iret			;continue testing
tpni30:	dec	di		;adjust
	add	sp,6		;adjust stack
	jmp	bt27		;reenter banktest

openbankp endp

;--GET OPTIONS ; scan for slash options till end line
; si=ptr flag byte(s) to modify, di=ptr options table
; bx points first chr to scan -1
; mods ax, sets z=no options, cy=illegal options or error
getopt proc near		;getopt:
	cmp	byte ptr[bx+1],0Dh ;end of line?
	jbe	gopt95		;yes
gopt20:	call	getnextchr	;inc bx before get
	jc	gopt96		;exit,end of line
	jnz	gopt22		;not "/"
	inc	bx		;ignore "/"
	jmp	short gopt20	;till end
gopt22:	call	checkdelim	;sp,comma,cntrl?
	jnc	gopt20		;yes,ignore
	push	si		;si may be changed
	call	gtaboptn	;search for letter,do command
	pop	si
	jnc	gopt20		;do next chr (or finish neg)
gopt30:	call	badentrymsg	;inform user, al=bad chr
gopt32:	stc			;cy=illegal chrs
	dec	bx		;point to previous good chr
	jmp	short gopt99	;done (cy,nz)
;set z=no entry,nc=no errors
gopt95:	cmp	ax,ax		;set z,nc=no entry
	jmp	short gopt99	;done
;set nz=entry, nc=no errors
gopt96:	push	ax
	or	al,1		;set nz,nc=ok options
	pop	ax
gopt99:	ret			;exit
getopt	endp

initsubsp endp
;....end of install code.............................
jbootinit	endp

;------ BUFFER AREA (aligned on paragraph)-----
if ($-start) mod 10h		;align on para
org ($-start)+10h-(($-start)mod 10h)
endif
tempbanks:	dw	0,0,0,0,0,0,0,0	;0-7
		dw	0,0,0,0,0,0,0,0	;8-F (see defaultstr for -B,-C,-E,-F)
tempbanks1:				;final copy put here
tempjbanks=offset cseg:tempbanks1+20	;jram info assembled here
tempbanksend=offset cseg:tempjbanks+200	;512 words =256 banks (8 boards)
buffer=tempbanksend+10			;config.sys info put here

jboot	endp
mainseg ends
end	begin	;testingentry	;sets start addr=begin (not needed)
