;@#$ c m10 l0;marg=10
page	60,132
title	Tall Tree Systems JDRIVE

;************************************************
;*          JDRIVE 2.90 (Mix chips)		*
;*    Copyright(c)1984,85 Tall Tree Systems	*
;************************************************

;Jan 20, 1985
.radix 16

; written for Tall Tree Systems by John Henderson
; rewritten for use with JBOOT by Hugh Macdonald

; prom to ibmbio & ibmdos transfer area defs
abs0	segment at 0
abs0	ends

;========= MAIN SEGMENT JDRIVE ==============
cseg	segment para public 'code'
jdrive	proc	far
assume	cs:cseg,es:abs0,ds:cseg
begin:
start	equ	$

; equates r/w

rh	equ	0	;request header
rhcmd	equ	2	;cmd byte
status	equ	3	;drive return status
dta	equ	0eh	;disk transfer area
count	equ	12h	;byte/sec count
ssn	equ	14h	;starting sector number

; equates media check

retbyt	equ	0eh	;byte returned from driver

; equates makbpb

baptr	equ	12h	;ptr to bpb

; equates init

units	equ	0dh	;num of drives
bradr0	equ	0eh	;next break adr offset
bradr1	equ	10h	;next break adr segment
bpboff	equ	12h	;bios parm block offset
bpbseg	equ	14h	;bios parm block segment


;============= DEVICE HEADER ===================
; special device header (see pg 14-5 DOS 2 man)
nxtdev	dd	-1	;ptr to next dev
attrib	dw	2000h	;block device (non-ibm format)
strat	dw	jstrat	;ptr to device strategy
intr	dw	jintr	;ptr to device interrupt handler
nodrv	db	1	;number of block devices
	db	'$JDRIV'; name
	db	'R'	; type (RAM disk)

;--BOOT RECORD (the next 80+ bytes become sect#0 of e. disk)
bootrec	equ	$	;dummy dos boot record
	db	0CDh,19h,0 ;dummy jump to boot code
	db	'TTS 2.90' ;mfg name at offset 3 in boot record

; bios parameter block

bpb	equ	$
secsiz	dw	200	;sector size (512)
edsb	db	1	;sectors/allocation unit (cluster size)
elres	dw	0001	;no reserved sectors (boot sec)
fatnum	db	1	;no of fats
eldir	dw	100	;no of dir entries (256=8k, 16 secs)
edsec	dw	0048h	;no of sectors (calcd by init)
	db	0fch	;media descriptor
fatsec	dw	0001	;# sectors for fat (calcd by init)

copw	db	'Copyright (C)1984,85 Tall Tree Systems ',0
verno	db	'JDRIVE RAM Disk  Ver 2.90 ',0 ;needs JBOOT to work

;--Page Zero and Init values
jdrbegin	dw	0000	;start bank# of ram disk (see init)
jdrbanks	dw	0000	;#banks in ram disk (0=autosize)
bootlen = $ - bootrec
;............... END BOOT RECORD .....................



swapoff		db	0	;code to turnoff swap

bpbptr	dw	bpb	;bpb pointer
savsp	dw	0000	;system stack ptr save
savss	dw	0000	;system stack segment save
rhoff	dw	0000	;req hdr
rhseg	dw	0000
nextbank dw	0000	;2nd half xfr bank#

funtab	label	word
	dw	init	;initialization
	dw	media	;media ck
	dw	makbpb	;build bpb
	dw	dummy	;ioctl input
	dw	input	;input (read)
	dw	dummy	;non_destructive input no wait
	dw	dummy	;input status
	dw	dummy	;input flush
	dw	output	;output (write)
	dw	outver	;output (write) with verify
	dw	dummy	;output status
	dw	dummy	;output flush
	dw	dummy	;ioctl output

; device strategy entry point (Not utilized for DOS 2.0+)

assume	ds:cseg,es:cseg
jstrat:	mov	cs:rhoff,bx
	mov	cs:rhseg,es	;save req hdr
	ret

; device interrupt entry point (called after jstrat by DOS)
; (overhead:	402us non-split,  553us split, excluding movsw)
; (incl int25:	889us            1040us  (movsw = 104us/sec))
; (push-pop all reg takes 241 t = 50.6 usec)

jintr:	cld
	push	es		;optional (DOS throws es:bx away)
	push	bx
	push	ds		;save all registers
	push	ax
	push	cx
	push	dx
	push	di
	push	si
	push	bp
	mov	ax,cs
	mov	ds,ax		;ds=cs
	mov	savsp,sp	;save at this point
	mov	savss,ss	;see pg 14-10 dos 2 man
	cli
	mov	ss,ax		;switch to local stack
	mov	sp,offset begsp
	sti
	lds	bx,[dword ptr rhoff] ;req hdr ptr
	mov	al,rhcmd[bx]	;get req hdr cmd code
	cbw
	shl	ax,1		;conv to word index
	mov	di,ax
	jmp	cs:[offset funtab+di]	;(ds:bx=req hdr, stack empty)

media:	mov	byte ptr retbyt[bx],1	;media unchanged
	jmp	short exit1

makbpb:	mov	word ptr baptr[bx],offset bpb
	mov	baptr+2[bx],cs		;give bpb addr
	jmp	short exit1

;--INPUT (disk read, can span jram bank boundary)
; ds:bx=req hdr ptr
input:	call	setxfr		;setup 1st half xfr
	jnc	inp10		;ok, cx=#words
	movsb			;do odd byte
inp10:	rep	movsw		;1.35 ms vs. 1.83 ms/sector
	call	secondhalf	;(es:di=xfer, dx=#bytes)
	jmp	short both	;do xfer

;--OUTPUT (disk write, can span jram bank boundary)
; ds:bx=req hdr ptr
outver:				;no verify, mem cant fail
output:	call	setxfr		;setup 1st half xfr
	mov	bx,es		;exchg es:di with ds:si
	mov	ax,ds
	mov	ds,bx
	mov	es,ax 
 	xchg	si,di
	jnc	opt10		;ok, cx=#words
	movsb			;do odd byte
opt10:	rep	movsw		;1.35 ms vs. 1.83 ms/sector
	mov	es,bx		;get es:di=next xfer seg
	mov	di,si
	call	secondhalf	;turn 1st off, 2nd on (es:di=addr,dx=#bytes)
	mov	bx,es		;xchg es:di with ds:si
 	mov	ax,ds
	mov	ds,bx
	mov	es,ax
 	xchg	si,di

;BOTH (es:di=ds:si block transfer)
both:	jnc	both1		;ok, cx=#words
	movsb			;do odd byte
both1:	rep	movsw		;1.35 ms vs. 1.83 ms/sector

;TURN OFF JRAM -  bp = 0 or CREG
toff:	or	bp,bp		;turn-off?
	jz	exit		;no
	mov	ds,bp
	mov	al,cs:[swapoff]
	mov	[cseg:0],al	;turn-off jram bank
dummy:
exit:	db	9Ah		;far call to jboot setbankfree
sbfoff	dw	9090		;(mod by init)
sbfseg	dw	9090
exit1:	lds	bx,cs:[dword ptr rhoff]	 ;recover req hdr ptr
	mov	word ptr status[bx],100h ;set done
exit2:	cli
	mov	ss,cs:savss
	mov	sp,cs:savsp	;restore system stack
	sti
	pop	bp		;restore rest of dos regs
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	ax
	pop	ds
	pop	bx		;es:bx restore optional
	pop	es
	ret

; If no space in RAM Disk, Return device not ready
nodev:	mov	word ptr status[bx],8102h ;dev not rdy err
	mov	word ptr count[bx],0	  ;no sec transferred
	jmp	short exit2

setxfrp proc near
;--SECOND HALF Turn off jram, do 2nd half (es:di=xfer addr, dx=#bytes)
; 2nd half is done whenever two jram banks are spanned
; sets	ds:si = swap:0 (always begins at 0 in next jram bank)
secondhalf:
	or	bp,bp		;turn-off?
	jz	schf10		;no
	mov	ds,bp
	mov	al,cs:[swapoff]
	mov	[cseg:0],al	;turn-off jram bank
schf10:	mov	cx,dx		;any more to do?
	jcxz	exit		;no, ignore ret addr & exit
	mov	bx,cs:[nextbank];next bank to turn on
secondhalf1:			;(called by init)
	xor	si,si		;2nd half ds:si si=0
	jmp	short firsthalf	;turn-on jram

;--SET XFER (common input/output transfer setup)
; ds:bx = ptr to request header (see pg 14-11)
; FFFF = max # bytes legal for a movb
; <<mod permits 64k copy if no offset wraparound>>
; sets up for:
; 1st half  bx=abs bank#, es:di=xfer addr,  cx=#bytes, si=jram offset
; 2nd half [nextbank]=" ,                   dx=#bytes, (si=0)
; also:	ds:si = jram addr of desired sector
;	bp=0 if no turn off needed, else bp=CREG (like E800)
setxfr:	jmp	short nodev		;eliminated by init
	mov	ax,word ptr [bx+ssn]	;starting sec#
	mov	si,word ptr [bx+count]	;#sec to xfer (0-512)
	les	di,dword ptr dta[bx]	;es:di=xfr addr
	mov	bx,ax		;begin data sect,save for within bank
stx11p:	mov	cl,7		;div by sec/bank (see init)
	shr	ax,cl		;ax=e.d. bank# (relative 0-nnn)
	add	ax,cs:[jdrbegin];add dos+user  (absolute)
	xchg	bx,ax		;bx=bank# wanted, ax=beg sec#
	mov	bp,di		;bp=xfer addr offset (begin)
	xor	dx,dx		;dx=2nd half count (assume 0)
stx12p:	mov	cl,9		;#bytes/sec (9=512)
	shl	si,cl		;si=#bytes
	jnz	stxf15		;non 64k xfer
	jnc	exit1		;0 sectors requested, exit
stxf15:	add	bp,si		;end offset = wraparound?
	jnc	stxf20		;no (except for zero)
stxf16:	sub	si,bp		;si=new count
stxf20:	shl	ax,cl		;ax=sec# * #bytes/sec = jram bank offset
	mov	cx,ax		;cx=jram offset
	or	si,si		;64k xfer?
	jz	stxf22		;yes, force split checking
	add	ax,si		;ax+#bytes = ending offset
	jae	stxf26		;not across two jram banks
stxf22:	sub	si,ax		;si=1st half count reduced
	mov	dx,ax		;dx=2nd half count increased
	mov	ax,bx		;ax=bank# for 1st half
	inc	ax		;next bank
	mov	cs:[nextbank],ax ;bank# for 2nd half
stxf26:	xchg	cx,si		;cx=#bytes, si=jram offset

;--FIRST HALF (turn on JRAM bank with desired sector)
; 1st half  bx=abs bank#, es:di=xfer addr,  cx=#bytes, si=jram offset
;(2nd half [nextbank]=bank#,                dx=#bytes)
; sets	ds:si = jram addr of desired sector
;	bp=0 if no turn off needed, else bp=CREG (like E800)
firsthalf:
	xor	bp,bp		;bp=0 if no turnon
	push	es		;save xfer seg
	db	9Ah		;far call to jboot accessbank
accoff	dw	0000		;sets ds=loc of data, es=CREG
accseg	dw	0000		;(filled in by init)
	mov	cs:[swapoff],al	;al=TOFF, (cy=no turnon/off)
	jc	fihf12		;no turnon/off
	mov	bp,es		;turn off required
fihf12:	pop	es
	stc
	jcxz	fihf15		;64k xfer cx=8000 words
	clc
fihf15:	rcr	cx,1		;cx=#words, cy set if odd byte needed
	ret			;ds:si=addr of sector, al=toff, bp=creg
setxfrp	endp


;if	($-start) mod 10h		;testing ????
;org	($-start)+10h-(($-start) mod 10h)
;endif
;============ STACK =================================
; jdrive uses about 50h bytes, rest is for interrupts
topstack=$

;Slash Options table,(like /R or /I)
initflag1	db	0
tabinitopt:	db	3	;3 items each unless call
		db	'S',00,20  ;(neg not allowed)
		dw	offset dosecsize
		db	'C',00,20
		dw	offset doclustersize
		db	'D',00,20
		dw	offset dodirsize
		db	'B',00,20
		dw	offset dobeginloc
		db	'N',00,20
		dw	offset donumboot
		db	'R',40,0
		db	'I',80,0
		db	0
messages:
msgrestored	db	'RESTORED',0Dh,0Ah,0
msginit		db	'* Init *'
msgcrlf		db	0Dh,0Ah,0
msgtruncated	db	7,' Truncated',0
msgbootfatdir	db	' Boot+Fat+Dir = ',0
msgdata		db	'Data = ',0
msgk		db	'K, ',0
msgjbootname	db	'$JBOOT',0
msgneedjboot	db	7,'* No JBOOT in CONFIG.SYS *',0
msgtoomany	db	' * Too many RAM disks',0
msgnospace	db	7,' <<No space avail>>',0Dh,0Ah,0
msgdanger	db	7,0Dh,0Ah,'*ERROR* Previous clusters, size,'
		db	' or version different.',0Dh,0Ah
		db	'(Cntrl-Alt-K will clear all RAM disk(s),'
		db	' or use /R option.)',0Dh,0Ah,0


	org	offset topstack+140h ;big stack

begsp	equ	$
drvend	equ	$
;alternate was is to allow no unused space (about 40 bytes)
; begsp = offset topstack+140h
; drvend = begsp


;=================== INIT JDRIVE ======================

;contents of JBOOT BANKSINFO and MEMBANKS  (256+ words -- 16 Mb)
;banksinfo:		;(loc = membanks - 10h)
;rambanks dw	0000	;0 hi=#banks tot, lo=#contig banks
;jrambanks dw	0000	;2 #banks of JRAM avail
;userk	dw	0000	;4 #k reserved for user (default 0k)
;maxregmem db	0Dh	;6 limit of reg mem (9=640k)
;maxtonmem db	00	;7 last bank turned-on mem (0=autosize)
;swapbank db	0Dh	;8 JRAM swap area (0D typ)
;dosbank db	00	;9 last bank of dos
;jdriveptr dw	offset cseg:jdr1bank ; A loc of ram disks
;freebank dw	0000	;C first unused bank
;nbanks	dw	0000	;E #banks
;membanks:		;10+

;Location of subroutine call table in JBOOT
nondata	label	word
accessbanktab	dd	000000	;ptr to jboot table

; reserve room and plug in driver (see pg 14-17 dos 2 man)
; (ds:bx= req hdr, stack empty)
init:	mov	sp,offset buffer1+240h ;temp stack
	mov	al,cs:[nodrv]	;#units default
	mov	byte ptr units[bx],al ;# of units
	mov	word ptr bradr0[bx],offset drvend ;ending offset
	mov	bradr1[bx],cs	;ending segment
	les	si,dword ptr[bx+12h] ;get es:si=ptr to command str
	mov	word ptr bpboff[bx],offset bpbptr ;ptr to bpb
	mov	bpbseg[bx],cs

;--Scan input string for size of jdrive (es:si=ptr, ds=req hdr)

	push	es
	pop	ds		;ds:si=command str (source)
	push	cs
	pop	es		;es:di=local buff (dest)
	mov	di,offset cseg:buffer1
	mov	cx,100		;256 bytes max
	rep	movsb

;--Get NUMBERS and OPTIONS (string from config.sys file is in buffer1)

	push	cs
	pop	ds		;ds=cs (es=cs)
	mov	si,offset verno	;title and version
	call	tvshow
options:
	mov	si,offset cseg:buffer1 ;ptr command str
opts5:	lodsb			;al=[si],si+1
	cmp	al,20h		;20, 0 or 0D? end of name?
	ja	opts5		;no
	cmp	byte ptr[si],20h ;end of line?(no num no opts?)
	jae	opts7		;no
	dec	si		;point to 0, force end of line
	mov	byte ptr[si],0Dh ;force end of line
opts7:	mov	bx,si		;bx=end of name+1=begin opts
	call	tvtillcr	;show options, etc. (bx=end of name)
	push	si
	mov	si,offset msgcrlf
	call	tvshow
	pop	si
	dec	bx		;getnum incs bx

;--Get first number (SIZE of RAM Disk  1b=64k, 0=autosize)
	call	getnum		;ds:bx=ptr chrs
	jbe	opts40		;cy=bad,z=no num, use default
	or	ax,ax		;if non even bank add a bank
	jz	opts8
	inc	dx
opts8:	mov	[jdrbanks],dx

;--get SLASH OPTIONS (/a,b,c,etc)
opts40:	mov	si,offset cseg:initflag1	;init default flag
	mov	di,offset cseg:tabinitopt	;slash options table
	call	getopt		;bx=ptr string

;--Locate JBOOT and plug in call to accessbank (ds=cs)
	mov	dx,offset msgjbootname ;open JBOOT for iocontrol
	mov 	ax,3D02h	;open (read/write)
	int	21h
	jnc	ini6		;found
ini4:	mov	si,offset msgneedjboot
	call	tvshow
	jmp	ini78		;set 0 size and exit
ini6:	mov	bx,ax		;bx="handle"
	mov	cx,0		;0=get address of JBOOT table
	mov	dx,offset accessbanktab ;put data here
	mov	ax,4402h	;iocontrol "in"
	int	21h		;get info
	pushf			;cy=error
	mov	ah,3Eh		;close bx=handle
	int	21h
	popf
	jc	ini4		;error

;check if space avail for RAM Disk (es=cs, ds=cs)

	lds	si,[accessbanktab] ;ds:si=table inside JBOOT
	lodsw			;get membanks addr
	push	ax
	mov	ax,ds		;far segment
	mov	di,offset accoff;ptr far call accessbank
	movsw
	stosw			;put in segment
	mov	di,offset sbfoff;ptr far call setbankfree
	movsw
	stosw
	pop	si		;ptr membanks
	sub	si,30h		;point to banksinfo
	mov	di,[si+0Ah]	;ptr jdr1bank#
	mov	bp,[si+0Ch]	;freebank (first poss jdr begin)
	mov	dx,[si+0Eh]	;#banks total (end of mem)
ini33:	mov	ax,[di]		;bank# from jboot list
	inc	ax		;FFFF = end of list?
	jnz	ini35		;not end
	mov	si,offset msgtoomany
	call	tvshow
ini34:	jmp	ini78		;no space,exit
ini35:	cmp	ax,bp		;bank#+1 gt freebank? (ok to use?)
	ja	ini36		;yes
	inc	di		;no
	inc	di
	jmp	short ini33	;try next one
ini36:	mov	ax,cs:[jdrbegin];(0=autolocate)
	cmp	ax,bp		;this bank free?
	jae	ini36a		;yes (not autolocate)
	mov	ax,bp		;starting bank#=freebank
ini36a:	cmp	ax,dx		;start ge end of mem+1?
	jae	ini34		;yes, no space left, exit
	mov	[di],ax		;update jboot
	mov	cs:[jdrbegin],ax
	mov	bp,ax

;calc ending bank (ax=bp=begin bank#, dx=#banks max)

	mov	cx,cs:[jdrbanks] ;cx=#banks wanted
	or	cx,cx		;#banks=0=autosize?
	jz	ini37		;yes
	add	ax,cx		;ax=total #banks wanted
	cmp	ax,dx		;#wanted gt #avail?
	jbe	ini38		;no
	push	si		;yes, reduce size
	mov	si,offset msgtruncated
	call	tvshow
	pop	si
ini37:	mov	ax,dx		;use max #banks
ini38:	sub	bp,ax		;begin bank#-(end bank#+1)
	jz	ini34 		;no space
	neg	bp		;bp=#banks (revised)
	mov	cs:[jdrbanks],bp ;update #banks
	mov	[si+0Ch],ax	;update freebank

;compute #sectors in ram disk (ax=top bank# used +1, bp=#banks)
; (arith done in log base 2)
	push	cs
	pop	ds		;ds=cs
	mov	ax,[secsiz]	;#bytes in a sector (power of 2)
	push	ax
	mov	ch,-1		;get ch=log #bytes/sec
ini44:	inc	ch
	shr	ax,1		;root base 2 (shift factor)
	jnz	ini44
	pop	si		;si=#bytes/sec (used below)
	mov	byte ptr [stx12p+1],ch ;log #bytes/sec
	mov	cl,10h		;get factor for #sec/bank
	sub	cl,ch
	mov	byte ptr [stx11p+1],cl ;log #sec/bank (shift cnt)
	shl	bp,cl		;#banks * #sec/bank = #sec total
	jnz	ini47		;lt 64k sectors = ok
	push	si
	mov	si,offset msgtruncated
	call	tvshow
	pop	si
	dec	bp		;make as big as poss (FFFF=33Mb)
ini47:	mov	[edsec],bp	;#sec in ram disk (boot+fat+dir+data)

;calc #sec needed for dir (bp=#sec tot, si=#bytes/sec)
	mov	ax,[eldir]	;num of 32 byte dir entries
	mov	cl,5		;32 bytes/dir entry
	shl	ax,cl		;ax=#bytes needed (16k max)
	xor	dx,dx		;dx:ax=#bytes needed for dir
	div	si		; div [secsiz]	dx=remainder, ax=#sectors
	or	dx,dx		;no remain?
	jz	ini50		;no
	inc	ax		;yes, add 1 sec
ini50:	add	ax,[elres]	; + #reserved sectors
	mov	[nondata],ax	;save for sizing
	inc	ax		;assume 1 sec for fat (to start)

;calc #fat entries needed (bp=#sec tot, si=#bytes/sec, ax=#non-data sec)
; (1.5 bytes/fat entry,e.g for 64k data= 128 entries = 192 bytes)

	xchg	ax,bp
	sub	ax,bp		;ax=approx #data sectors
	mov	di,ax		;save incase cluster size too big
ini53:	xor	dx,dx		;dx:ax=#data sec
	mov	ax,di
	xor	cx,cx
	mov	cl,[edsb]	;cx=#sec/clus
	div	cx		;div #sec/clus=#clusters (4k max)
	cmp	ax,0FFE		;#sec < 4k? (-2 for fat code)
	jbe	ini55		;yes, ok
	shl	[edsb],1	;no, too big, #sec/clus*2
	jmp	short ini53	;try again
ini55:	mov	cl,3
	mul	cx		;dx:ax=3 * #clus
	shr	ax,1		;ax = 3/2 * #clus = #bytes in fat
	div	si		; #bytes/ #bytes per sec = #sec
	or	dx,dx		;remainder?
	jz	ini58		;no
	inc	ax		;add one sec
ini58:	mov	[fatsec],ax	;#sectors in fat (1-0Ch)
	add	ax,[nondata]	;#non-data sectors

; show size of RAM disk  (ds=cs , ax=#non-data sec)

	mov	bx,[edsec]	;bx=total #sectors
	sub	bx,ax		;bx=total-non data = #data sec
	mov	si,offset msgbootfatdir
	call	showkilo	;ax=boot+fat+dir
	xchg	bx,ax
	mov	si,offset msgdata ;data size
	call	showkilo	;ax=data #bytes

; open elec. disk boot sector (#0), RESTORE if lock there

	mov	bx,[jdrbegin]	;first bank of jdrive
	call	secondhalf1	;turn-on jram boot sec (bx=bank#)
	mov	ax,cs:[secsiz]	;(ds:si=D000:0 typ)
	mul	cs:[elres]	;dx:ax=#bytes in boot sec
	mov	bx,ax		;bx=#bytes
	mov	di,offset bootrec ;es=cs from above (si=0)
	mov	cx,bootlen	;cx= size of boot record
	test	cs:[initflag1],80h ;always init? ("I")
	jnz	ini80		;yes
	cmp	word ptr [bx-4],55AAh ;lock there?
	jne	ini80		;not found, re-init
	cmp	word ptr [cseg:3],'TT'	;tall tree logo?
	jne	ini80		;not found, re-init

; Elec. Disk is RESTORED, hopefully banktable just calcd is the
; same previously, check if cluster, size , etc are same
; (ds:si=addr of boot, cx=bootlen)
	test	cs:[initflag1],40h ;always restore? ("R")
	jnz	ini67		;yes
	rep	cmpsb		;compare es:di=ds:si
	jne	ini70		;bad compare
ini67:	mov	si,offset msgrestored
	call	tvshow
	jmp	short toffi		;(bp=0 or CREG)

;--Previous Ram Disk with diff parms
ini70:	mov	si,offset msgdanger
	jmp	short ini79	;turn-off and exit

;--No Elec Disk, error exit
ini78:	mov	cs:[word ptr exit],03EBh ;jump over far call
	xor	bp,bp		;flag= no turn-off
	mov	si,offset msgnospace
ini79:	call	tvshow
	jmp	short toff2	;turn-off if bp<>0

;--Init exit, turns off jram bank
toffi:	add	cs:[word ptr input+1],2	 ;cancel no device jump
	add	cs:[word ptr output+1],2
toff2:	jmp	toff

;======= INIT Elec. Disk Fat and Dir =================
; copy local boot info (es:di) to e.d. boot record (ds:si)
ini80:	push	si
	mov	si,offset msginit
	call	tvshow
	pop	si
	push	es		;xchg es:di with ds:si
	push	ds
	pop	es
	pop	ds		;ds:si = local boot info
	xchg	di,si		;es:di = es:0 =boot
	mov	ax,cx		;save cx=bootlen
	rep	movsb		;es:di<=ds:si (e.d gets boot sector)
	mov	cx,bx		;(bx=#bytes in boot sec)
	sub	cx,4		;512-4 bytes (space for bootlok)
	sub	cx,ax		;#bytes left unfilled in sector
	xor	ax,ax
	rep	stosb		;fill rest with zeroes
	mov	ax,55AAh	;last two words are 55AAh
	stosw
	stosw

; clear the electronic disk fat + directory
	mov	al,0FCh		;media code
	stosb			;di points to next sector,ie. FAT TABLE
	mov	ax,0FFFFh	;complete first 2 fats=3 bytes
	stosw
	xor	ax,ax
	mov	cx,4000h	;32k clear (allows 6k fat,16k dir max)
	rep	stosw
	jmp	short toffi	;turn off jram (if bp not 0) and return


;---SUBROUTINES used by INIT
initsubs proc near

;various do routines called by getopt
dosubs proc near
;(can mod al,cx,dx (ah=flag)

dobeginloc:
	call	getnum		;"B"
	jbe	dobl90		;cy=bad,z=no num,default
	or	dx,dx		;lt 64k?
	jnz	dobl90		;no, exit
	mov	[jdrbegin],ax	;new value
dobl90:	ret

doclustersize:			;"C"
	call	getnum		;ds:bx=ptr chrs
	jbe	docs90		;cy=bad,z=no num, use default
	call	powertwo	;round to powerof2
	mov	[edsb],al	;#sec per cluster
docs90:	ret

dodirsize:			;"D"
	call	getnum
	jbe	dods90		;cy=bad, use default
	mov	dx,200		;512 max
	cmp	ax,dx		;too big?
	jbe	dods80		;no
	xchg	ax,dx		;yes, use max
dods80:	or	ax,ax		;zero?
	je	dods90		;yes, use default
	mov	[eldir],ax	;#directory entries
dods90:	ret

donumboot:			;"N"
	call	getnum
	jbe	donb90		;cy=bad, use default
	or	dx,dx		;must be < 64k !
	jnz	donb90
	mov	[elres],ax	;#boot sectors
donb90:	ret

dosecsize:			;"S"
	call	getnum
	jbe	dosz90		;cy=bad,use default
	mov	cl,7		;div by 128
	shr	ax,cl		;ax=units of 128 bytes
	call	powertwo	;round up
	shl	ax,cl		;restore ax=#bytes
	mov	[secsiz],ax	;update
dosz90:	ret


;POWER of TWO  (round up to power of two, 0 becomes 1)
powertwo:
	push	cx
	xor	cx,cx
pwtw10:	inc	cx
	shl	ax,1
	jc	pwtw20		;got a bit
	jnz	pwtw10
	stc			;force 0 to be 1
pwtw20:	jz	pwtw30		;ok, power of two
	dec	cx		;use next power up
	mov	ax,0
pwtw30:	rcr	ax,cl		;cx=#bits shifted
	pop	cx
	ret
dosubs	endp

;--SHOW MSG then KILOBYTES (ax=#bytes, si=ptr msg)
; rounds up (1.5 = 2) , mods dx, si
showkilo:
	call	tvshow		;si=ptr msg
	mul	[secsiz]	;dx:ax=#bytes
	add	ax,200h		;32 bit round up
	adc	dx,0
	mov	si,400h		;div by 1k
	div	si		;ax=#k, dx=remainder
	call	showax
	mov	si,offset msgk
	call	tvshow
	ret

;SHOW AX as HEX  (no leading zeros)
;showaxhex:
;	push	bx
;	mov	bx,10h		;hex
;	jmp	short shax5
;SHOW AX as DECIMAL (no lead zeros)
showax:	push	bx
	mov	bx,0Ah		;decimal
shax5:	push	ax
	push	cx
	push	dx
	xor	cx,cx
shax10:	inc	cx		;#chrs to show
	xor	dx,dx		;dx:ax=#
	div	bx		;ax=divsor, dx=remainder
	push	dx		;save digit for later
	or	ax,ax		;0 left to divide?
	jnz	shax10		;no
shax20:	pop	ax		;start with msb digit
	add	al,30h
	cmp	al,39h		;over 9?
	jbe	shax23		;no
	add	al,7		;make A-F
shax23:	call	tvbyte
	loop	shax20		;do all chrs
	pop	dx
	pop	cx
	pop	ax
	pop	bx
	ret

tvproc proc near
;TVSHOW (can be called during INIT only)
; si=ptr string, ends with 0
; mods si only, (ds can be anything)
tvprompt:
tvshow:	push	ax
	push	dx
	push	ds
	push	cs		;ds=cs
	pop	ds
	cld
tv20:	lodsb			;al=ds:si, si+1
	or	al,al		;end of line?
	jz	tv99		;yes,done
	call	tvbyte
	jmp	tv20		;till end of line
tv99:	pop	ds
	pop	dx
	pop	ax
	ret

;--BINASCAXSP (number followed by ,space)
;binhexaxsp:			;testing ????
;	call	showaxhex	;number
;	push	si
;	mov	si,offset cseg:msgcommasp
;	call	tvshow
;	pop	si
;	ret
;msgcommasp db	', ',0

;TVCHR  (al=chr to tv)
;bp save,initial set mode required for early IBM rom
tvbyte:
tvchr:	push	ax
	push	bx
	push	ax
	mov	ah,0Fh		;get page of tv screen in bh (0=typ)
	int	10h
	mov	bl,7		;get bl=mode (7=normal)
	pop	ax
	push	bp		;bp mod by old IBM rom
	mov	ah,0Eh		;"TTY output"
	int	10h
	pop	bp
	pop	bx
	pop	ax
	ret

tvproc endp

GTABOPTMOD proc near
;============new GTABOPT ==================
;--TABLE SYNTAX
;table= letter,flag code,if neg poss/invert, other optional codes
; (min 3 bytes each entry) di=ptr table, update flag in ah
;flagbyte1	db	0		;si points to these
;flagbyte2	db	0		;(one per 8 letters)
;delimtable:
;	db	5			;#bytes in each entry (127 max)
;	db	'^',oneg,40,0,0		;neg symbol (like -)
;	db	'D',delopt,0,0,0	;neg not poss
;	db	'U',delopt,81		;U=-D
;	dw	offset doprint		;subroutine ptr
;	db	0			;end of table
; Syntax: letter, bit-pattern, control byte, call-address, other.
;   The first three bytes are required
;		bit-pattern bits or'ed to flag
;		control byte bit0=negating this letter ok
;			bit3=use offset as ptr to flag
;			bit4=go to next flag (si+1)
;			bit5=use offset to call sub
;			bit6=this letter means negate
;			bit7=invert meaning of bit-pattern
;		(i.e. if p=-w, both have oprint, but w has negposs=81)
;	two negs cancel each other

;--GET TABLE OPTIONS
; al=chr, bx=chr ptr (in case more chrs to be read)
; di=ptr table of opt letters, si= ptr flag bytes
; sets ah=flag [si+nn], al=entry # in table
;	(note, nz =negated letter when call [di] is done)
;	(dx is passed to [di], nz=neg, can mod dx,cx,al)
; sets	al=chr if not in table else undefined
;	ah=flag [si+nn] changed
;	si=ptr flag that changed
;	cy=not found or illegal use of neg (al=chr)
;	nc,z=done, nz=negate chr found
gtopneg 	db	0	
gtaboptn:
	push	di
	push	cx
	push	bp
	push	dx		;dx info passed to sub
;	call	upper		;al=upper
	mov	cx,ax		;cl=al=chr,ah=flag
	mov	ch,[gtopneg]	;ch=neg flag
	xor	dx,dx
	mov	dl,[di]		;#bytes per entry
	inc	di		;point to letter
gtop10:	test	byte ptr[di+2],10 ;use next flag?
	jz	gtop11		;no
	inc	si		;yes, point next flag
gtop11:	mov	al,[di]		;get table letter
	cmp	cl,al		;chr=option?
	jz	gtop20		;yes,got chr
	or	al,al		;end of list?
	jz	gtop15		;yes
	test	byte ptr[di+2],28;bit3+bit5 ;offset specd?
	jz	gtop12		;no
	inc	di		;yes, move past offset
	inc	di
gtop12:	add	di,dx		;next entry
	jmp	short gtop10
;not in table, check for neg
gtop15:	cmp	cl,'-'		;negate ?
	jnz	gtop99		;no, illegal letter
gtop17:	xor	ch,0FFh		;set nc,nz (2 negs = +)
	jmp	short gtop98	;store negflag
;got chr, process
gtop20:	test	byte ptr[di+2],8 ;bit3 ;use diff flag?
	jz	gtop22		;no
	mov	si,word ptr[di+3] ;yes, new flag
gtop22:	mov	ah,[si]		;flag to change
	inc	di
	mov	al,[di]		;(+1)=bits to set/reset
	inc	di
	test	byte ptr [di],40 ;(+2) a negate symbol?
	jnz	gtop17		;yes
	or	ch,ch		;previous negate symbol?
	jz	gtop40		;no
	test	byte ptr [di],1 ;(+2)=neg possible for this option?
	jz	gtop99		;no, error exit
	or	ah,al		;set,then reset flag
	xor	ah,al		;reset
	jmp	short gtop80
gtop40:	or	ah,al		;set flag
gtop80:	test	byte ptr [di],80 ;(+2) invert meaning of bit code?
	jz	gtop86		;no
	xor	ah,al		;invert flag
gtop86:	test	byte ptr [di],20 ;(+2) call wanted?
	jz	gtop90		;no
	test	byte ptr [di],8	;new flag also?
	jz	gtop87		;no
	inc	di		;yes, use 2nd offset
	inc	di
gtop87:	pop	dx		;recov dx=info passed
	mov	bp,ax		;temp place for flag
	or	ch,ch		;set nz if neg
	call	word ptr[di+1]	;sub can mod ax,cx,dx
				;(bx=str ptr, bp=flag, di=[+2])
	mov	ax,bp		;restore ah=flag
	push	dx
gtop90:	xor	ch,ch		;reset neg, set nc,z
gtop97:	mov	[si],ah		;update flag
gtop98:	mov	[gtopneg],ch	;update
	mov	al,cl		;recov chr (perhaps)
	pop	dx		;(dx may be changed by sub)
	pop	bp
	pop	cx		;(al=chr,ah=flag)
	pop	di		;restore table loc
	ret			;nc,z=done  nc,nz=neg
gtop99:	xor	ch,ch		;reset neg
	stc			;cy,z=wrong option or use of neg
	jmp	short gtop98
GTABOPTMOD endp

;=============== CODE ======================
GETNEXTCMOD proc near
;public getnextchr
;public spcomequal
;public checkdelim
;--GETNEXTCHR get [bx+1], test for end
;0 or 0D set cy = end, "/" sets z,nc, other chrs=nc,nz
;0 or cr or "/" do not inc bx
getnextchr:
	mov	al,[bx+1]	;get chr
	cmp	al,0Dh		;cr? (end?)
	jz	gnext99		;yes
	cmp	al,";"		;semicoln=end of line
	jz	gnext99		;yes
	or	al,al		;0?  (end?)
	jz	gnext99		;yes
	cmp	al,"/"		;slash?
	jz	gnext98		;yes
	inc	bx		;point to this chr
	clc			;nc,nz
gnext98:ret			;nc, (z="/")
gnext99:push	ax		;(bx points to last valid chr)
	inc	ax		;set nz
	pop	ax
	stc			;cy,nz=end of str
	ret

;--SPACE COMMA EQUAL (nc, cr=nc,z, else=cy)
;--CHECKDELIM al=space or comma or control code are ok=nc
; z=cr,nz=space or comma or control code
; cy=invalid delim (not sp or ,)
spcomequal:
	cmp	al,"="		;equal?
	jz	chkd98		;yes (nc)
checkdelim:
	cmp	al,","		;comma?
	jz	chkd98		;ok (nc)
	cmp	al," "		;space? (or control code?)
	jbe	chkd98		;ok (nc)	
	stc			;cy=no valid delim
	ret
chkd98:	cmp	al,0Dh		;cr?
	clc
	ret			;nc=delim, z=cr
GETNEXTCMOD endp

;=============== CODE ======================
;--GETNUM24  (get dl:ax=24 bit num)
; bx=ptr chr-1, cx=#chrs (see getnum)
; sets cy=number over 24 bits (mods dh)
;getnum24:
;	call	getnum		;get dx:ax=32 bit num
;	jbe	gtnm90		;done (z=no,cy=bad num)
;	or	dh,dh		;over 24 bits?
;	jz	gtnm95		;no, ok
;	stc			;cy=too big
;gtnm90:	ret
;gtnm95:	push	ax
;	or	al,01
;	pop	ax		;nc,nz
;	ret

GETNUMMOD proc near
;extrn alphanum:near
;extrn upper:near
;extrn errormsg:near
;extrn badentrymsg:near
;extrn setnznc:near

;--GETNUM --get dx:ax=+ or - integerr,(bx=first chr-1)
;ax=default number,reads console, number put in ax
;cy=overflow or error or quit if al="Q"

number	dw	0	;temp use
negflag db	0	;bit0=1 if negative number

getnum:	push	si
	push	di
	push	cx
	xor	si,si		;si:di=number=0
	xor	di,di
; Get Begin Number (non delim) (skip equal sign)
gnum10:	call	skipdelim	;bx=ptr last delim
	jnc	gnum12
gnum11:	jmp	gnum95		;cy=end line (no number)
gnum12:	call	getnextchr	;check if valid number begin
	call	alphanum	;z if number or "-"
	jnz	gnum95a		;not number
	cmp	al,"-"		;negative number?
	jnz	gnum21		;no, process digit
	or	[negflag],1	;yes,set flag
	jmp	short gnum70	;continue scan	
; Decode into binary
gnum20:	call	getnextchr	;incs bx before get
	jbe	gnum97		;number done (cy=eol,z="/")
gnum21:	;call	upper
	;cmp	al,"Q"		;quit?
	;jz	gnum89		;yes, exit
	cmp	al,","		;comma?
	jz	gnum70		;ignore
	cmp	al,"K"		;kilo?
	jz	gnum90		;yes,mult by 1k
	cmp	al,"B"		;bank?
	jz	gnum92		;yes,mult by 64k
	cmp	al,"9"		;above 9?
	ja	gnum96		;yes,end number
	cmp	al,"0"		;below 0?
	jb	gnum96		;yes,end number
; valid chr, convert to binary
	sub	al,30		;make 0-9
	xor	ah,ah		;ax=digit
	xor	dx,dx		;dx:ax=digit
	add	di,di		;si:di=total*2
	adc	si,si
	mov	cx,5		;loop chr+2+4+6+8+10
gnum33:	jc	gnum34		;overflow
	add	ax,di		;add 2*n each loop
	adc	dx,si		;top16
	loop	gnum33
	xchg	di,ax		;si:di=32 bit total
	xchg	si,dx
gnum34:	jc	gnum81		;cy=overflow msg
gnum70:	jmp	short gnum20	;do next chr
gnum81:
;	mov	si,offset cseg:msgover; inform user
;	call	errormsg
;illegal chrs, display message
gnum88:	mov	al,[bx]		;al=bad chr
	call	badentrymsg
gnum89:	dec	bx		;point last good chr
	xor	ax,ax
	xor	dx,dx		;dx:ax=0
	stc			;cy=bad number
	jmp	short gnum99	;exit	
;Kilo: mult number by 1024
gnum90:	mov	ax,400		;1024
	mul	di		;dx:ax=low16*1K
	xchg	di,ax		;get si:di=#
gnum91:	or	si,si		;orig msb must be 0
	jnz	gnum81		;too big
	xchg	si,dx		;ok
;	dec	cx
	jmp	short gnum97	;done
;Bank: mult num by 64k
gnum92:	xchg	dx,di		;mov # to hi16
	xor	di,di		;zero low16
	jmp	short gnum91	;test too big
;no valid entry
gnum95a:dec	bx		;point last good chr
gnum95:	cmp	ax,ax		;set z=no entry
	jmp	short gnum98	;set nc also
;all chrs done, or terminated by delim (set nz,nc)
gnum96:	dec	bx		;point last good chr
gnum97:	xchg	ax,di
	xchg	dx,si		;dx:ax=32bit number
	test	[negflag],1	;negative?
	jz	gnum97b		;no
	neg	ax		;yes
	sbb	dx,0		;32bit neg
gnum97b:
	push	ax
	or	al,01
	pop	ax		;set nz,nc=ok number
gnum98:	clc			;nc=ok number
gnum99:	pushf
	and	[negflag],0FEh	;reset neg
	popf
	pop	cx
	pop	di
	pop	si		;bx=ptr delim
	ret			;dx:ax=number,cy=error
;msgover:
;	db	"Number too large:",24
GETNUMMOD endp

;=============== CODE ======================
DELIMSMOD proc near
;--SKIPDELIM (skip space or delims till chr or end line)
; cy=eol reached, nc=non delim
; cx=#chrs left,bx=index into string (last chr used)
; returns cx=#left, bx=ptr last delim
;  cy=cr,0,or "/" stopped search
skipdelim:
skipd5:	call	getnextchr	;incs bx before get,unless end
	jbe	skipd99		;end of search(cy=eol,z='/')
;<< mod for getnum in order to skip equal sign before a num>>
	call	spcomequal	;space,comma,ctrl,equal?
;	call	checkdelim	;space or comma or ctrl?
	jnc	skipd5		;no
;non-delim found
skipd98:;check for alpha num here, set z=alpha-num
	clc
	dec	bx		;point to last delim
	ret			;nc=non-delim found
skipd99:stc			;cy=end line
	ret
DELIMSMOD endp

;=============== CODE ======================
ALPHANUMMOD proc near
;public alphanum
;extrn upper:near
;--ALPHANUM (check if alpha num)
; al=chr, nc,z=number, nc,nz=alpha, cy=other
alphanum:
	push	ax
;	call	upper
	cmp	al,5a		;gt Z?
	ja	alph80		;yes,err
	cmp	al,30		;lt 0?
	jb	alph80		;yes,err
	cmp	al,39		;le 9?
	jbe	alph96		;yes,a number
	cmp	al,41		;ae A?
	jae	alph97		;yes, a letter
;check legal "alpha-num equivs" here
	cmp	al,"-"		;neg sign?
	je	alph96		;yes
alph80:	stc
	jmp	short alph99	;pop and ret
;set z=number (nc also)
alph96:	cmp	al,al		;set z
	jmp	short alph98	;ret
;set nz=alpha (nc also)
alph97:	or	al,al		;set nz
alph98:	clc
alph99:	pop	ax
	ret
ALPHANUMMOD endp

;=============== CODE ======================
TVTILLCRMOD proc near
;--TV TILL CR (si=ptr message, stops at cr)
;mods no regs, does not output cr
tvtillcr:
	cld
	push	ax
	push	si
tvtc10:	lodsb		;al=[si],si+1 get chr
	cmp	al,0dh		;cr?
	jz	tvtc20		;yes,exit
	call	tvbyte		;tv
	jmp short tvtc10	;till done
tvtc20:	pop	si
	pop	ax
	ret
TVTILLCRMOD endp

;=============== CODE ======================
STRINGSMOD proc near
;--BADENTRY Message (al=bad chr)
;public badentrymsg
badentrymsg:
;	call	errortv		;"Error"
	call	tvbyte		;show bad chr
	push	si
	mov	si,offset cseg:msgbadentry
	call	tvprompt
	pop	si
	ret
msgbadentry:
	db	" = bad entry",0
STRINGSMOD endp

;--GET OPTIONS ; scan for slash options till end line
; si=ptr flag byte(s) to modify, di=ptr options table
; bx points first chr to scan -1
; mods ax, sets z=no options, cy=illegal options or error
getopt proc near		;getopt:
	cmp	byte ptr[bx+1],0Dh ;end of line?
	jbe	gopt95		;yes
gopt20:	call	getnextchr	;inc bx before get
	jc	gopt96		;exit,end of line
	jnz	gopt22		;not "/"
	inc	bx		;ignore "/"
	jmp	short gopt20	;till end
gopt22:	call	checkdelim	;sp,comma,cntrl?
	jnc	gopt20		;yes,ignore
	push	si		;si may be changed
	call	gtaboptn	;search for letter,do command
	pop	si
	jnc	gopt20		;do next chr (or finish neg)
gopt30:	call	badentrymsg	;inform user, al=bad chr
gopt32:	stc			;cy=illegal chrs
	dec	bx		;point to previous good chr
	jmp	short gopt99	;done (cy,nz)
;set z=no entry,nc=no errors
gopt95:	cmp	ax,ax		;set z,nc=no entry
	jmp	short gopt99	;done
;set nz=entry, nc=no errors
gopt96:	push	ax
	or	al,1		;set nz,nc=ok options
	pop	ax
gopt99:	ret			;exit
getopt	endp

;..............................................
;if	($-start) mod 10h
;org	($-start)+10h-(($-start) mod 10h)
;endif
buffer1:

initsubs endp

jdrive	endp
cseg	ends
end	begin		;starting addr
