;spooler: @#$t0 c m10 L0; marg=10
;jspool (also see part2=jspooli (init) )
title	Tall Tree Systems JSPOOL
page	60,128

;************************************************
;*		  JSPOOL 2.09			*
;*  Copyright(c)1983,1984 Tall Tree Systems	*
;************************************************

; written for Tall Tree Systems by Hugh Macdonald
; August 23, 1984
.radix 16 
;----NON-LOCAL SEGMENTS-----------------
abs0	segment at 0
	org	0
zero	label	byte	;for self mod code jumps
;--prom to ibmbio & ibmdos transfer area defs
	org	400	;rs232 printer port base
rs232base0 label word	;base printer #0
	org	408	;parallel printer port base
parabase0 label word	;base printer #0
	org	413h
bootsz	label	word	;amt of kbyte for PC DOS
	org	43f
motor	label	byte	;bit 3-0 =drive 3-0 running, bit7=write
			;at 40=count 37=two seconds motor delay
	org	46Ch
timelow	label	word	;cnt 18.2 times a sec, double word
abs0	ends
.list
;--------------------------------------------------
; JSPOOL SEGMENT,  LOADABLE DEVICE DRIVER, ORG at 0
;--------------------------------------------------
cseg group mainseg    ;stackseg,testseg,subseg,initseg
mainseg	segment para ;public 'code'
jspool	proc	far
assume	cs:cseg,ds:cseg,es:abs0
begin:
start	equ	$

;--Equates for Spooler
chr1 =	40	;escape chrs @ # $ (40,23,24h)
chr2 =  23	;#
chr3 =	24	;$

bit0 = 1	;for bit setting and clearing
bit1 = 2
bit2 = 4
bit3 = 8
bit4 = 10
bit5 = 20
bit6 = 40
bit7 = 80

;SPFLAG equates  (buffering control)
spesc1 =bit7	;chr 1 entered (esc code="@#$")
spesc0 =bit6	;00,01,10,11=0to3 chrs entered
spfunct =bit5	;escflag has meaning
spkill =bit4	;K,A:spooler killed, use normal int14 or 17
spnull =bit3	;N:spooler is a bit bucket
spimmed =bit1	;I:1=immediate action
spnot =bit0	;-:negates some commands (-K,-P,-N)

;OFLAG equates (output printing control)
ofesc1 =bit7	;bits 7,6= 00 for no esc
ofesc0 =bit6	;01=1, 10=1&2, 11=1&2&3
ofunct =bit5	;S,B or T function,see escflag
ohalt =bit4	;P,R: output halt
oxoff =bit3	;XON-XOFF halt
orep =bit2	;Repeat chr
;oimmed =bit1	;Immediate/Delay
;onot =bit0	;bit 0 save as IFLAG= not (invert)

;REPFLAG (iflag or oflag repeats)
irepeat = bit7  ;repeat set by buffit (input)
orepeat = bit6	;repeat set by timeloop (output)
multirep = bit5	;multiple input repeat
multorep = bit4	;multiple output repeat

;ESCFLAG equates (Multibyte commands)
efnot =bit0	;for - functions
efsel =bit1	;S: next number=printer #0-3,4-7
efpage =bit2	;?halt at page end?
eftab =bit3	;T: next numbers are tabstops
efxchg =bit4	;X: next chr is new esc chr#1
efdumb =bit5	;D: next # is dumb mode
efline =bit6	;L next # = chrs till trucate
efmargin =bit7	;M next # is left margin

;ESCFLAG2 equates (multibyte commands)
;efnot =bit0	;-
efparity =bit1	;P: next chr=E,O,N
efbaud =bit2	;B: next #=baud rate 0-7=110-9600
eftime =bit3	;Y: next #=time slice 10-C0h
eftickchr =bit4	;Z: next #=#chrs/tick
eftimeout =bit5	;U: next #=timeout val
efctsdsr =bit6	;V: next #0,1,2,3,4=cts,dsr to check
efbusy =bit7	;W: next #=#busy counts max

;CONCODEFLAG equates (control code flags)
cfesc =bit0	;1Bh=esc seq being printed

;.....................................................
;==============beginning of CODE======================
; device header dintr gives entry address
.xlist
;
;----------DEVICE HEADER-----(pg 14-5 DOS man)--------
; special header for loadable driver (orgd at 0 not 100)
; Note: attribute byte: bit #   0=is not     1=is
;			15      character device (vs. block)
;			14	ioctl supported
;			13	non-IBM (block)
;			 3	current clock dev
;			 2	current nul dev
;			 1	current std output dev
;			 0	current std input  dev
;
.list
zerocseg label byte	;used to turn on jram

nxtdev	dd	-1	;dw ptr to next dev, filled by DOS
attrib	dw	0C000h	;w  char device/ioctl supported
dstrat	dw	strat	;w  ptr to device strategy
dintr	dw	intr	;w  ptr to device interrupt handler
pname	db	'$JSPOOL ' ;8 byte string=device name
serno	db	'000001',0
copyw	db	'Copyright(c)1983,1984 Tall Tree Systems',0
verno	db	' Ver 2.09  Ser.#',0

;----------END of DEVICE HEADER-----------------------------


;==========CUSTOMIZATION DATA======================
; User sets values used by Init to establish environment

;--SPOOL BUFFER data-------------------------------
; customized values. (see data sheets)
spooltable:		;origin of spooler data table
sptype	db	0	;0 buffer type 1=print only, no input
spbeg:			;spool buff begin (24bits)
spbegoff dw	0000	;1,2 low 16 bits
spbegbank db	0h	;3 hi 8 bits (bank#)

spend:			;spool buffer end (24bits)
spendoff dw	0000	;4,5 low 16 bits
spendbank db	0h	;6 hi 8 bits (bank#)

spbytes:		;no. of bytes in buffer (24bits)
spbytes16 dw	0000	;7,8 low 16 bits (0=autosizing)
spbytesmsb db	0	;9 hi 8 bits (msb)


;========Spooler VARIABLES===========================
; (part of table returned by status call)

;--Count= #chrs in spool buffer
spcount:
spcount8 db	0	;A # bytes left in buffer (lo 8 bits)
spcount24 dw	0000	;B,C top 16 bits of spcount

flagsize=$
;--Spooler Flags ,Data and Counters (Input and Output)--
iflag	db	0	;D 0=no esc, 10=killed,8=null
oflag	db	0	;E same      10=haltd,etc.
repflag db	0	;F i/o repeat chrs
iescflag dw	0000	;10,11 markers for later exec
oescflag dw	0000	;12,13 output esc
concodeflag db	0	;14 contrl code flags
flagsize=$-flagsize	;#bytes of flags to zero
initflag db	0	;15 flag for install options

;--Timeloop Flags, Data and Counters (Output and XON-XOFF)-
;keep order of next 2 below, accessed together
ticklim	db	0Ch	;16 max chrs/tick (3=54chrs/sec)
busylim	db	0Bh	;17 max busy cycles allowed/tick(.2ms/count)
timelim db	40	;18 #mini ticks allowed each tick(40=25%)
timeoutval dw	1800	;19,1A = 1000=about 4 to 8 seconds
; 0.214msec /mini-tick ( = 100h counts at 1.19MHz)
;each tick is 54.9 msec (10000 counts at 1.19 MHz)
;default uses 15% (max) of this time for spool output.
;	baud	chr	busy	tick  (cps max if time=40)
;	9600	1.04ms	05	0C	216
;	4800	2.08	0A	06	108
;	2400	4.16	14	03	 72
;	1200	8.33	29	02	 36
;	 300   33.33	A4	02	 36
;300-1200 baud make use of UART double buffering to get 2 per tick.

; baud 0-7=110-9600, parity: 0=1stop, 4=2stops, 0=N,80=O,18=E
; 2=7bits=2, 3=8bits
printer dw	0000	;1B,1C default 0=rs232 ptr#1 (4=parallel)
curport dw	0000	;1D,1E
curbaud	db	07	;1F (baud 0-7, 7=9600)
curparity db	07	;20 (parity inf 7=8N)

;---HEAD,TAIL,SCAN pointers---
;--Begin and End rollover values--
begbank		db 0	;21 bank# 0-29h
begoff		dw 0000	;22,23 offset of buff beginning
begseg		dw 0000	;24,25 seg
endbank		db 0	;26
endoff		dw 0000	;27,28 special values for end
endseg		dw 0000	;29,2A force rollover at right spot
;--Head Info  (input to buffer)--
head:
hbank		db 0	;2B current bank#
hton		db 0	;2C turn on command (or x0 if RAM)
hcreg		dw 0E000 ;2D,2E cmnd reg addr(JRAM turn on)
hoff		dw 0000	;2F,30 offset of next chr entry
hseg		dw 0000	;31,32 seg (B000 or D000 if swap)
;--Tail Info  (output from buffer to printer)--
tail:
tbank		db 0	;33 same meaning as head
tton		db 0	;34
tcreg		dw 0E000 ;35,36
toff		dw 0000	;37,38
tseg		dw 0000	;39,3A
;--Scan Info  (points to data in buffer)--
scan:
sbank		db 0	;3B
ston		db 0	;3C
screg		dw 0E000 ;3D,3E
soff		dw 0000	;3F,40
sseg		dw 0000	;41,42

;---FILE NAME (used in block mode)
fcbdrv	db	0,'           ',0  ;(43)44 name and (4F) attrib
fcbsize	dw	0000	;50,51 file size (bytes)
	dw	0000	;52,53 (hi 16)
fcbfirstfat dw	0000	;54,55 first cluster
callprogds dw	0000	;56,57 calling prog ds

;---JETDRIVE and FILE and INIT values
swapbank	db 0Ah	;used by init (0A typ)
;below never used
swapseg		dw 0000	;set by init (A000 typ)
;next two used only by init
dosbank db	0	;last 64K bank used by DOS
dosk	dw	0	;#k used by DOS
edbegin	db	0	;beg bank for elec. disk
handle	dw	0	;DOS id for filename
;--filled in by Init: Constants etc.
maxbank		db 0	;0-29 last 64K bank
tbankoff	dw 0	;banktable loc in JETDRIVE
tbankseg	dw 0
firsttime db	0	;first time flag (1=first time)

;--INSIDE DOS BUFFER VALUES  beg,end,bytes
; (Makefile options copies these to spbeg,etc.)
insidetab:
insbeg:			;spool buffer begin (24 bits)
insbegoff dw	0	;low 16 bits
insbegbank db	0	;hi 8 bits (bank#)
insend:			;spool buffer end (24bits)
insendoff dw	0	;low 16 bits
insendbank db	0	;hi 8 bits (bank#)
insbytes:		;no. of bytes in buffer (24bits)
insbytes16 dw	0	;low 16 bits (0=autosizing)
insbytesmsb db	0	;hi 8 bits (msb)
inscount:
inscount8 db	0	;# bytes left in buffer (lo 8 bits)
inscount16 dw	0	;top 16 bits of spcount
;--Inside Head/Tail Info  (input/output to buffer)--
inshead:
inshbank	db 0
inshton		db 0
inshcreg	dw 0E000
inshoff		dw 0000
inshseg		dw 0000
instail:			;tail info
instbank	db 0
instton		db 0
instcreg	dw 0E000
instoff		dw 0000
instseg		dw 0000
;--printer select table
; printer #, port# 0-7, baud,parity, chrlim, ticklim, busylim
printtab:
	db	1,4,0FF,0FF,0A,40,0FF,0	;parallel printer
	db	2,0,04,7,02,50,0FF,0	;serial, 1200 baud
	db	3,0,07,7,07,40,0FF,0	;serial, 9600 baud
	db	0

;--Statistics counters, etc.-------
	db	'===STAT==' ;for future db's
;keep order of next 2 below, accessed together
escpoint db	0	;#chrsleft when esc detected
overtime db	0	;#times time exhausted before 1 chr printed
haltcount db	0	;#times halt scanned
tickchrs db	0	;#chrs printed remain per tick
busycnt	db	0	;# busy cycles remain per tick
busymax db	0	;total busy per print cycle
timemax dw	0	;max time detected

chrsmax    db	0	;max #chr detected/tick
chrsleft   db	80d	;# chrs left in line
chrslim    db	80d	;max line size
linelim    db	66d	;max #l/page
lcount	   db	66d	;#lines left
pagecount  db	0	;odd/even page count
lmargin    db	0	;no left margin
repeatsize=$
;--repeat buffs and tabs
repchr	   db	20	;chr to be repeated
repcount  db	0	;# repeats remaining
orepchr    db	20	;chr to repeat
orepcount  db	0	;# repeats
imultinfo:
imultcount db	0	;set =2 for Citoh init to 12 pitch
imultindex db	0	;index into multbuff
imultbuff  db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
omultinfo:
omultcount db	0	;set =2 for Citoh init to 12 pitch
omultindex db	0	;index into multbuff
omultbuff  db	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
;Citoh:  esc E sets 12pitch, esc Q set 17pitch, esc N =10 pitch
repeatsize=$-repeatsize

tabcomp	db	0	;last computed tab (chrpos)
ntabs	db	0	;#of tabs entered (terminator=0)
nexttab db	0	;next tab value to check
tabtab:	db	33 dup(0) ;32 tabs max

; IFLAG Command Letters Table
iflagtab:
	db	3	;#items
	db	'-',spnot,0
	db	'K',spkill,1
	db	'N',spnull,1
	db	'I',spimmed,1
	db	0
oflagtab:
	db	3
	db	'-',spnot,0
	db	'H',ohalt,1
	db	'R',ohalt,81
	db	'I',spimmed,1
	db	0
; Escape Command Letters Table
esc1tab:
	db	3	;#items
	db	'-',efnot,0
	db	'S',efsel,0
	db	'T',eftab,0
	db	'X',efxchg,0
	db	'D',efdumb,0
	db	'L',efline,0
	db	'M',efmargin,0
	db	0		;end
esc2tab:
	db	3
	db	'-',efnot,0
	db	'P',efparity,0
	db	'B',efbaud,0
	db	'Y',eftime,0
	db	'Z',eftickchr,0
	db	'U',eftimeout,0
	db	'V',efctsdsr,0
	db	'W',efbusy,0
	db	0		;end


;--Request Header Info & Stack
;rhoff	dw	0	;req hdr ptr set by strat
;rhseg	dw	0	;(see setesbx subroutine)
savsp	dw	0	;system stack ptr save
savss	dw	0	;system stack segment save

;--------------JSPOOL MAIN PROCEDURES--------------------
assume cs:cseg,ds:cseg,es:cseg,ss:cseg

;========COMMAND CODE JUMP TABLE ============
cmdtab	label	byte
	dw	init	;0 initialization
.xlist;	dw	dummy	;1 media ck
;	dw	dummy	;2 build bpb
;	dw	dummy	;3 ioctl input
;	dw	dummy	;4 input (read)
;	dw	dummy	;5 nondestructive input no wait
;	dw	dummy	;6 input status
;	dw	dummy	;7 input flush
;	dw	dummy	;8 output (write)
;	dw	dummy	;9 output (write) with verify
;	dw	dummy	;A output status spool(printer)
;	dw	flush	;B output flush
;	dw	dummy	;C ioctl output
.list
cmdmax=(($-offset cmdtab)-2)/2	;max cmd number

;--- STRATEGY ENTRY  (to be used by DOS 3.0?)
;  generally save ES:BX as pointer to Req Hdr
strat:	call	setesbx		;store rhoff,rhseg
.xlist;	mov	cs:rhoff,bx    ;es:bx has req hdr ptr
;	mov	cs:rhseg,es
	ret	; note es:bx remains at intr entry
.list
;--- DEVICE INTERUPT ENTRY (Main entry,executes command code)---
.xlist;	(not an INT but a call, so a RET ends this routine.)
;	(es:bx points to req hdr which contains command code,
;	required data, and space for return data --if any.)
.list
intr:	cld
	push	ds
	push	ax
	push	cx
	push	dx
	push	di
	push	si
	push	bp
	mov	ax,cs		;establish local addressing
	mov	ds,ax
	mov	[savsp],sp
	mov	[savss],ss	;(pg 14-10 use internal stack)
	cli			; no irq while stack half changed
	mov	ss,ax
	mov	sp,offset cseg:begsp; internal stack
	sti
	les	bx,[dword ptr rhoff] ;??? get rh pointers
	push	bx
	push	es		;save rh pointers on local stack
; get command and jump to routine
	mov	al,es:[bx+2]	;rhcmd get command code
	cmp	al,cmdmax	;past end of table?
	ja	cmdexit		;yes,set error ????
	cbw
	shl	ax,1
	mov	di,ax
;	mov	di,offset cmdtab
;	add	di,ax
	jmp word ptr[di+offset cmdtab]	;branch to selected routine
				;cs=ds=ss=cseg
;--IO CONTROL processing

;---CMD EXIT  (all DOS calls return here.)------
cmdexit: 
dummy:	pop	es
	pop	bx		;restore req hdr pointer
done:	mov	es:word ptr[bx+3],100h	;status done, bit 9
;	or	es:word ptr[bx+3],100h   ;status set done,bit 9
	cli
	mov	ss,cs:[savss]
	mov	sp,cs:[savsp]  ;restore DOS stack
	sti
	pop	bp
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	ax
	pop	ds
	ret

;---STATUS ---code=0A------------------------
.xlist; gets printer status
;ostatus:
;	call	checkfull	;z=full
;	mov	al,0		;assume not busy
;	jnz	ostatus1	;not full,not busy
;	mov	al,2		;2=busy, full
;ostatus1:
;	mov	es:byte ptr[bx+4],al ;status+1
;	jmp	cmdexit
;--- FLUSH ---code=7 input, 0B out------------------------
;	sets tail and scan = head, thus reseting buffer
;	could also send printer code to flush printing
;flush:	call	copyheadtailscan
;	;reset ints if using irq version
;	;reset pointers
;	jmp	cmdexit
;...end FLUSH................................
.list
;======MAIN JSPOOL ENTRIES (via int)=====================
; this call optional input to spool.
;--NEW INT 14 -- all calls come here to spool
.xlist;	dx=0 or 1 for card #0 or #1 
;	ah=0=init port; 1=transmit chr  2=receive 
;	   3=get status
;	status: ah=uart   al=modem lines (cts,ri,dsr,etc.)
;ah:	bit 7=time out, 6=txempty, 5=tran hold reg empty,
; 4=break detect, 3=frame err, 2=parity err, 1=overrun,
; 0=data ready

;MODE and PRINT grap int14 and 17 and slow everything
;down. Mode grabs even if not redirected, even when
;just setting baud rate.
.list
new14:
	sti
	cmp	ah,1	;0=init, 1=print, 2=recv, 3=status
	jnz	new141	;not print
	call	buffit	;return int14 like status in ah only
;	test	ah,80	;make	al,90	;ok?
;	jnz	new14stat
	mov	al,0F0	;set low byte of status
	iret
new141:	jb	jmp14	;ah=0,do init (init could flush...)
	cmp	ah,2	;receive?
	je	jmp14	;yes, go to old vec 14
new14stat:
	test	[iflag],spkill	;spooler killed?
	jnz	jmp14		;yes, old vec14
;return busy status if buffer full, else, return ready
	call	checkfull	;z=full
	mov	ax,60F0	;txs & txh empty, cts,dtr,etc ok
	jnz	new14s1	;not full
	mov	ah,80	;timeout, tx full
new14s1: iret
jmp14:	jmp	far ptr zero	;old vec14 filled in by init


;--NEW INT 17  (standard entry into spooler)
;  only dx=0 (port 0) allowed for spooler
;		ah=0  al= chr to be printed
;		ah=1  initialize printer,ah<=status
;		ah=2  get status
; 80(bit7)=ready,  40=ack,  20=no paper, 10=selected,
;		   08=io err  01=timeout    
;===new: ah=80,81,82 for block transfers into spool buff
; 80 move block, cx=#chrs, ds:si=source,
;	 cy=bad move (cx=#left,ds:si=next chr)
; 81 init spooler to new table of start stop
; 82 status, z=empty, cy=full, nz,nz=between
;	bl:ax=#chrs left to print, es:bx=origin of spool tabs
new17:	or	ah,ah		;0=print, 1=init, 2=status
	jnz	new17a		;not print
	or	dl,dl		;port 0 = spooler
	jnz	jmp17		;use IBM rom driver
	call	buffit		;print chr (put in buff)
	iret
jmp17:	jmp	far ptr zero	;old 17, filled in by init

;--STAT or BLOCK commands (1,2+,80+)
; (PRINT and TYPE call stat first, see spooler full, then stops
; without trying buffit and timeout, thus status=always ready)
; (Init ignored as BASIC can wipe out printer settings
;  each time they are invoked.)
new17a:	cmp	ah,2		;1=init,2=status both ignored
	ja	new17c		;neither
	or	dl,dl		;port 0? (=spooler?)
	jnz	jmp17		;no,use IBM driver
	test	cs:[iflag],spkill ;spooler killed?
	jnz	jmp17		;yes,go to old 17
new17b:	mov	ah,90		;always ready (see note above)
	iret

new17c:	test	ah,80		;block commands? (80+)
	jnz	blockcommand	;yes, 80-FF

;--True STATUS (3-7F gives actual spooler status)
new17stat:
	or	dl,dl		;port 0? (=spooler?)
	jnz	jmp17		;no, use IBM driver
;--need stack local???
	call	checkfull	;z=full (uses cs:)
	jnz	new17b		;not full,set ready
	mov	ah,29		;not ready,paper out, timeout
	iret


;=================================================
;--BLOCK COMMANDS 80 81 82 etc (communicate with external prog)
blockcommand:
	push	ds
	mov	cs:[callprogds],ds ;save for later
;;--set local stack here
	push	cs
	pop	ds		;ds=cs local addressing
	call	turnoff		;temp stop spooler
	cmp	ah,81h		;cy=80,z=81,nz=82
	jc	blockstuff	;80="print"
	jz	blockinit	;81="init"
	cmp	ah,83h		;cy=82,z=83,nz=84+
	jc	blockstatus	;82="status"
	jnz	blkc81		;84+
	jmp	blockflush	;83="flush"
blkc81:	cmp	ah,85h		;cy=84,z=85,nz=86+
	jnc	blockstatus	;85+="status"
	jmp	blockreset	;84="reset"

;================================================
;--82=BLOCK STATUS, return es:di=loc of table
; sets es:di=loc table, bl:ax=#bytes left to print
; z=buff empty
blockstatus:
	push	cs
	pop	es		;es=cs (ds=cs)
	mov	di,offset spooltable
	call	spoolunprinted	;sets bl:ax=#bytes left
				;z=empty, es:di=spooltab
; BLOCK RETURN (recover ds, flags set, toss orig flags)
; be sure to have host prog STI again if necess since
; because of bug below  orig val of i and t flags not recovered
blockret:
	call	turnon		;spool on again
	pop	ds		;orig ds
	ret	2		;toss orig flags
;The following has produced problems with makefile and jtype
;for unknown reason, E2:CCA as an INT call interferes
;i.e. <0CCA><00E2><flags> found in buffer or DOS messed up
; (((HAS to do with bug in 8088 chip , earlier version.)))???
; irq is released early by some op codes
	push	ax
	pushf
	cli			;dont endanger stack
	add	sp,8		;"pop"  ax,ds,ret addr
	pop	ax		;orig flags
	sub	sp,0Ah		;recover stack
	xchg	ah,al		;get ah=z,cy etc
	popf			;recover flags to return
	lahf			;get ah=new current flags
	xchg	ah,al		;correct flag order
	push	ax		;set flags=ax
	popf
	pop	ax
;	pop	ds		;orig ds
;	ret	2		;toss orig flags

;=================================================
;--80=BLOCK STUFF buffer, block "print"
; ds:si=source, cx=#bytes
; 8.8 sec/64K = about 7300 chrs/sec
blockstuff:
	cld
	mov	ds,[callprogds]
bstf10:	lodsb			;al=[si],si+1
	call	buffit		;stuff in buffer
	cmp	ah,90		;ok?
	jnz	bstf20		;no, full
	loop	bstf10
	clc
bstf18:	jmp	blockret	;exit (ds not eq. cs)
bstf20:	dec	si		;ds:si=point next chr to stuff
	stc			;cx=#chrs left
	jmp	short bstf18	;exit

;===================================================
;-- 81=BLOCK INIT new buffer, from electronic disk,etc.
; this calcs actual abs loc and updates spbeg,etc.
; al=file type (0=internal, 1=buffer, 2=print only)
; bh:dx=#bytes (offset)from begin of elec disk
; cl:di=#bytes in file, ch:si=#bytes to print
; bp=ptr calling prog fcb (ds:bp)
; ret cy if error, al=0 buff not empty, no action taken
;		al=1 not electronic disk, " " "
;		al=2 read-only forced, end extended
;		al=3 if illegal init (like no jetdrive)
blockinit:
	push	bx
	push	es
	push	cs		;es=cs (ds=cs)
	pop	es
	mov	bl,al
	xchg	bl,[sptype]	;bl=current type
	cmp	bl,80		;no files or change allowed?
	jnz	blki3		;ok
	mov	al,3
	stc			;cy=error
	jmp	blki95		;no action taken,err 3
blki3:	cmp	al,1		;new type 0,1,or 2?
	jc	blki4		;type 0
	jz	blki7		;type 1
	or	[iflag],spnull	;set read-only
	jmp	short blki7		;type 2
;--TYPE 0 (inside dos buffer)
blki4:	call	insidebuff	;0=internal buff
	clc			;nc=no err
	jmp 	blki91		;done
;--TYPE 1 or 2 (outside dos buffer)
; type 1 or 2 cannot init till spooler empty or flushed
; type 1 must have 1A,'JspD' at the first addr (=lock)
;--Save present state of buffer if internal
blki7:	call	testempty	;spooler empty?
	jz	blki8		;yes,ok to init
	xor	al,al		;set z, al=0
	stc			;cy=err
	jmp	blki95		;err exit
blki8:	or	bl,bl		;old type 0(internal)?
	jnz	blki10		;no, no save
	call	savestate	;put vals in insidetab
; bh:dx=#bytes (offset)from begin of elec disk
; cl:di=#bytes in file, ch:si=#bytes to print
blki10:	mov	ax,dx
	mov	bl,bh		;bl:ax=begin offset
	add	bl,[edbegin]	;+first bank# of e.d.
	mov	[spbegoff],ax	;bl:ax=new beg spool buff
	mov	[spbegbank],bl
	mov	[spbytes16],di	;cl:di=new #bytes in buff
	mov	[spbytesmsb],cl
;check problem if cy set below, #bytes being diff than end-beg
	add	ax,di
	adc	bl,cl		;bl:ax=end of file+1
	sub	ax,01		;bl:ax-1
	sbb	bl,00		;cy=underflow
	push	ax
	and	al,0Fh		;must end on para
	cmp	al,0Fh		;i.e. last nib=F
	pop	ax
	jz	blki20		;ok,nc
	or	al,0Fh		;extend end
	or	[iflag],spnull	;force read only type
	mov	al,2		;signal read-only
	mov	[sptype],al
	or	al,al		;set nz
	stc			;cy,nz=danger
;set up beg end #bytes values for spooler
blki20:	pushf			;save cy`flag
	push	ax		;al=2 if readonly forced
	mov	[spendoff],ax
	mov	[spendbank],bl	;new end spool buff
	call	headtailinit	;setup beg,end,head,tail,scan
	mov	word ptr[spcount8],si
	mov	byte ptr[spcount8+2],ch ;new #bytes to print
	cmp	[sptype],1	;read/write must have lockcode
	jnz	blki30		;readonly,skip check lock
;check if LOCKCODE present
blki21:	push	es
	push	si
	push	di
	push	cx
	push	bx
; gets al=cl=chr, mods es,di,cx,bx,ah
	mov	si,offset msglockcode
	mov	cx,5		;5 letters in lock
blki22:	push	cx
	call	readbuff ;mods es,di,cx,bx,ah;al=next chr in buff
	pop	cx
	cmp	al,[si]		;buff=lock?
	jnz	blki27		;no, error
	inc	si
	loop	blki22		;till done
	cmp	ax,ax		;set z=lock found
blki27:	pop	bx
	pop	cx
	pop	di
	pop	si
	pop	es
;flush buffer to adjust for readbuff use above
	call	copyheadtail	;zeros flags
	jz	blki30		;found
;Lock not found, error al=1 (not elec disk)
	pop	ax		;ax=2 perhaps
	popf			;toss flags
	call	insidebuff	;return to inside DOS
	mov	al,1		;1=not elec disk
	stc			;error
	jmp	blki95		;exit
;Move FCB NAME,etc from outside to local
blki30:	push	si
	push	ds
	mov	si,bp		;bp=fcb addr in calling prog
	mov	ds,[callprogds]	;ds:si=ptr call prog fcb
	mov	ax,[si+10h]	;size of file
	mov	cs:[fcbsize],ax
	mov	ax,[si+12h]	;size (top 16)
	mov	cs:[fcbsize+2],ax
	mov	ax,[si+19h]	;firstfat
	mov	cs:[fcbfirstfat],ax
;move name to fcbdrv (es=cs,ds:si=call prog)
	push	di
	push	cx
	mov	di,offset fcbdrv ;es:di=local fcb
	mov	cx,0Dh		;13 bytes, drv,name,attrib
	cld
	rep	movsb		;es:di=ds:si (jspool=outside)
	pop	cx
	pop	di
	pop	ds
	pop	si
	pop	ax		;ax=2 perhaps
	popf			;cy perhaps
;successful init force oflag=0
blki91:	call	turnoff		;force oflag=0
blki95:	pop	es		;if cy,al=0 not empty,al=1 not elec disk
	pop	bx		;  al=2 readonly forced,al=3 illegal 
	jmp	blockret	;discard entry flags
msglockcode	db	1Ah,'JspD'

;83=FLUSH Buffer ==============================
; sets tail and scan = head, thus reseting buffer
blockflush:
	call	flushall
	clc			;nc=no err
	jmp	blockret

;84=BLOCK RESET ================================
; resets to "@", flush, set inside, reset kill,null
blockreset:
	call	flushall	;flush current buff
	call	insidebuff	;set type=0 internal buff
	call	flushall	;flush internal buff
	mov	[iflag],0	;reset kill,null
	call	dumb0		;reset dumb
	call	xchange0	;set "@"
	clc			;nc=no err
	jmp	blockret
;..............................................

copyheadp proc near
;-------FLUSH Subroutines----------
;--Flush all
flushall:
	call	copyscanhead	;reset to beg of buffer
	call	copyheadtail	;resets head,tail,flags
	call	turnoff		;zero turntemp, will zero oflag
	ret

;--Copy Head to Tail and to scan ---
; stop spooler (halt) before calling
; mods flags only, sets Head=Tail, resets all flags
copyheadtail:
	push	cx
	mov	cx,8		;make head=tail
	jmp short coph10
copyheadtailscan:
	push	cx
	mov	cx,10		;16 bytes, head=tail=scan
coph10:	push	si
	push	di
	push	es
	push	cs		;es=cs (ds=cs)
	pop	es
	cld
	mov	si,offset head
	mov	di,offset tail
	rep	movsb		;ds:si=es:di copy block
	mov	[spcount8],cl	;cx=0
	mov	[spcount24],cx	;init count=0 (empty)
	pop	es
	pop	di
	pop	si
	pop	cx
;RESET FLAGS (zeros all head-tail esc flags)
resetflags:
	push	ax
	push	cx
	push	di
	push	es
	push	cs		;es=cs
	pop	es
	xor	ax,ax		;store zeros
	mov	ah,[iflag]
	and	ah,spkill+spnull ;preserve kill and null
	mov	cx,flagsize	;#bytes of flags
	mov	di,offset iflag  ;start of flags
	rep	stosb		;zero all flags
	mov	cx,repeatsize	;#bytes of repeat buffer
	mov	di,offset repchr
	rep	stosb		;zero all rep chrs
	mov	[iflag],ah	;return oflag
	pop	es
	pop	di
	pop	cx
	pop	ax
	ret

;--Copy Scan to Head---
; be sure spooler stopped or on hold
copyscanhead:
	push	cx
	push	di
	push	si
	push	es
	push	cs
	pop	es
	mov	cx,8		;8 bytes
	mov	si,offset scan
	mov	di,offset head
	rep	movsb
	pop	es
	pop	si
	pop	di
	pop	cx
	ret
copyheadp endp
;...end FLUSH................................
spoolemptyp proc near
;--TEST if SPOOL EMPTY---------
;SPOOLUNPRINTED (bl:ax=#bytes left, z=empty)
spoolunprinted:
	mov	ax,[word ptr spcount8]
	mov	bl,[spcount8+2]
	call	testz24		;z=buff empty
	ret
;TEST EMPTY  (z=empty,mods no regs)
testempty:
	push	ax
	push	bx
	call	spoolunprinted
	pop	bx
	pop	ax
	ret
spoolemptyp endp

turnonoffp proc near
;--TURN ON/OFF SPOOLER (sets ohalt)--------
; mods no flags or regs, ds not used
turntemp db	0	;temp storage for oflag
turnoff:
	push	ax
	mov	al,ohalt
	xchg	al,cs:[oflag]	;stop spooler
	mov	cs:[turntemp],al ;save for turn on
	pop	ax
	ret
turnon1:push	ax		;init oflag=0
	mov	al,0
	jmp short trno10
turnon:	push	ax
	mov	al,cs:[turntemp] ;get prev flag
trno10:	mov	cs:[oflag],al	;restore flag
	pop	ax
	ret
turnonoffp endp	;..............................

insidebuffp proc near
;--INSIDEBUFF Setup internal buffer (init values)
; spooler should be off (see turnoff)
; i/o flags reset (except for kill, null)
insidebuff:
	push	ax
	push	si
	call	flushall	;flush,reset ioflags
	mov	[sptype],0	;init type=0=inside
	mov	si,offset insbeg;use ins vals
	call	headtailinitsi	;setup beg,end,head,tail,scan
	call	restorestate	;correct head,tail
	pop	si
	pop	ax
	ret
insidebuffp endp

saverestorep proc near
;--SAVE/RESTORE STATE of spooler
; mods no regs (user must halt spooler)
savestate:
	clc
	jmp short srst10
restorestate:
	stc		;nc=save, cy=rest
srst10:	cld
	push	cx
	push	si
	push	di
	push	es
	push	cs
	pop	es		;es=cs
	pushf
	mov	di,offset spbeg
	mov	si,offset insidetab ;inside vals
	mov	cx,0Ch		;12 bytes 4*3
	jc	srst15		;restore
	xchg	si,di		;save direction
srst15:	rep	movsb
	mov	di,offset head
	mov	si,offset inshead
	mov	cx,10h		;16 bytes 2*8
	popf			;z=save
	jc	srst20		;restore
	xchg	si,di		;save
srst20:	rep	movsb
	pop	es
	pop	di
	pop	si
	pop	cx
	ret
saverestorep endp

iescdecmod proc near

;--INPUT ESCAPE PROCESSING ROUTINES-------------------
.xlist
;  A 3 chr string initiates escape processing.
;	This string sets iflag non-zero and further
;	buffering is stopped until escape-end chr (cr).
;  Default chrs are @,#,$ (hex 40,23,24)
;  e.g "@ # $ i s" would cause Immediate set Even page
;????
; List of Escape COMMANDs
; Legal delimiters are " " and ","
; Illegal entries printed as a "e", Legal entries
; are capitalized when printed.
; H,R=Halt,Resume (stop/start output to printer)
; K,-K=Kill (no spool, printer directly)
; F=Flush buffer
; N,-N=Null (throw away input chrs)
; -=Not (inverts H,K,N)
; S=Select output printer
;	(0-3=serial, 4-7=parallel)
; I= Immediate (upon input) processing
; E,O Even Odd (sets page to even or odd)
;	(if delayed,then forces page eject if necess)
; cr or ; or any illegal chr  ends escape sequence
.list
;--IESC CODES (input escape seq codes)
;Esc chrs found, next chr(s) = command
iescdecode:
	call	uppercl		;convert cl to uppercase
	test	al,ofunct	;function active?
	jz	iesc3		;no
;Escape function processing (highest priorty)
; number (if req) already cleared, stored when esc done
	push	ax		;save orig flag
	test	al,spnot	;- specd?
	mov	ax,[iescflag]
	jz	iesc1		;no
	or	al,spnot	;set not in escflag
iesc1:	test	al,eftab	;tabs?
	jz	iesc2		;no
	call	tabstopdecode	;get tab stops
	mov	[iescflag],ax	;cy=end of tab
	jmp	iesc2a		;test end
;not tabs, other escape multi byte function
iesc2:	call	escfunction	;process function
	mov	[iescflag],ax	;update flag
iesc2a:	jc	iesc2e		;cl=poss new command letter
	or	ax,ax		;esc funct done?
	pop	ax
	jnz	iesc2b		;not done
	xor	al,ofunct	;done
iesc2b:	ret

;Try new command letter cl
iesc2e:	pop	ax		;orig iflag
	xor	al,ofunct	;reset funct

;CR or SEMICOLN (resets escape sequence)
iesc3:	cmp	cl,0Dh		;cr? resets
	jz	iesc5		;yes, reset
	cmp	cl,";"		;semicoln? reset
	jnz	iesc10		;no
iesc5:	and	al,not(ofesc1+ofesc0+ofunct+spimmed+spnot)
	ret

;I: IMMEDIATE Mode required to go any further
iesc10:	test	al,spimmed	;immediate?
	jnz	iesc15		;yes,(previous I)
	cmp	cl,"I"		;immediate?
	jnz	iesc14		;no, ignore
	mov	ah,spimmed	;yes,set flag
	call	setibit
iesc14:	jmp	iesc98		;exit,reset not


;"-"NOT? (inverts some commands, two in a row is illegal)
iesc15:	cmp	cl,"-"		;"NOT" function?
	jnz	iesc20		;no
	test	al,spnot	;not set already?
	jz	iesc16		;no,ok
	jnz	iesc14		;two nots, illegal
iesc16:	or	al,spnot	;set not
	ret

;ONE LETTER escape commands H R N K etc.
;al=flag
iesc20:	push	si
	mov	si,offset iflagtab ;IFLAG first (get I)
	mov	di,offset iflag
	call	getopt		;cl=chr,sets N,K,I
	jc	iesc30		;no match found
	mov	al,[di]		;get updated flag
	cmp	cl,'I'		;no added processing?
	jz	iesc22		;yes, not N or K
	mov	cl,';'		;put in buff to reset prev oescflag
iesc22:	jmp	iesc59		;reset not

iesc30:	mov	si,offset oflagtab ;OFLAG
	mov	di,offset oflag
	pushf			;prevent ints during change
	cli
	call	getopt		;cl=chr,sets H/R
	jc	iesc39		;no match found
	popf
	jmp	iesc59		;reset not
iesc39:	popf

iesc40:	mov	si,offset esc1tab
	mov	di,offset iescflag ;low order byte
	call	getopt		;cl=chr, sets S,T,X,D,L,M
	jc	iesc50		;no match found
;TABS require special pre-reset
	cmp	cl,'T'		;tabs?
	jnz	iesc57		;no
	call	resettabs	;yes, reset vals
	jmp	short iesc57	;set function active

;2nd Escape Table
iesc50:	mov	si,offset esc2tab
	mov	di,offset iescflag+1 ;hi order byte
	call	getopt		;cl=chr, sets P,B,Y,Z,U,V,W
	jc	iesc60		;no match
iesc57:	call	clearnum	;reset temp number in case used
	or	al,spfunct	;set function active
iesc59:	pop	si
	jmp	short iesc61	;reset not

;FLUSH (-F illegal, Flush buffer, reset flags)
iesc60:	pop	si
	cmp	cl,"F"		;flush?
	jnz	iesc75		;no
	test	al,spnot	;-F illegal
	jz	iesc62		;ok
iesc61:	jmp	iesc98		;reset not
iesc62:	call	copyheadtail	;resets flags,repeats,spcount
	pop	ax		;flush ret addr
	jmp	buff98		;quick exit

;EVEN (sets currently printing page=even)
iesc75:	cmp	cl,"E"		;even?
	jnz	iesc77		;no
	mov	ch,0FEh		;even mask,bit0=0
	jmp	short iesc78	;modify pagecnt
;ODD (sets current page=odd)
iesc77:	cmp	cl,"O"		;odd?
	jnz	iesc80		;no
	mov	ch,0FFh		;odd mask,bit0=1
iesc78:	test	al,spnot	;invert?
	jz	iesc79		;no
	xor	ch,bit0		;yes, invert bit0
iesc79:	mov	ah,[pagecount]	;current val
	or	ah,bit0		;make odd
	and	ah,ch		;odd/even mask
	mov	[pagecount],ah	;update
	jmp	short iesc98	;reset not
;COMPRESSED (Parallel: Customize for Serial)
iesc80:	cmp	cl,"C"		;compressed?
	jnz	iesc95		;no
	mov	di,offset cseg:imultinfo
	call	compress	;put printer code in buff,set orep
	jmp	short iesc98	;exit,reset not
;ILLEGAL chrs end up here, they reset esc
;only space and comma legal delimiters
iesc95:	cmp	cl," "		;space?
	jz	iesc98		;yes, ok
	cmp	cl,","		;comma?
	jz	iesc98		;yes, ok
	jmp	iesc5		;illegal, reset all
;--Escape decode Exits (reset/no reset not)
iesc98:	and	al,not spnot	;reset not
iesc99:	ret

;---Escdecode Subroutines------------
setbits	proc near
;Set/Reset al with bits in ah
setibit:
	test	al,spnot	;invert? (reset?)
	jz	setib2		;no,set
	not	ah		;yes,invert bits
	and	al,ah		;reset
	ret
setib2:	or	al,ah		;set
	ret

;Set/Reset [oflag] with bits in ah
; al not modified (this call used once! to set halt)
setobit:
	pushf			;save cli/sti
	cli			;oflag must be unused by irq
	test	al,spnot	;invert? (reset?)
	jz	setob2		;no,set
	not	ah		;yes,invert
	and	[oflag],ah
	ret
setob2:	or	[oflag],ah	;set
	popf			;recover cli/sti
	ret
setbits	endp

;===================================================
;  Main INPUT ESCAPE Processing Entry
; check iflag for esc chrs or for kill,null
; ah=iflag, al=chr
;check for chrs 2 and 3
esc11:	test	al,ofesc1	;esc#1&2 already?
	jnz	esc12		;yes,check #3
	cmp	cl,chr2		;chr2 found?
	jnz	esc18		;no, reset esc
	xor	al,ofesc1+ofesc0 ;01 becomes 10 (1&2 found)
	jmp	short esc20	;check kill,etc.
esc12:	test	al,ofesc0	;esc 1&2&3 already?
	jz	esc14		;no, check #3
	call	iescdecode	;yes, process command
	jmp	short esc20	;check kill,etc.
esc14:	cmp	cl,chr3		;chr 3?
	jnz	esc18		;no, reset esc
	or	al,ofesc0	;11=1&2&3 found
	jmp	short esc20	;check kill,etc.
;reset esc and function bits
esc18:	and	al,not(ofesc1+ofesc0+ofunct+spimmed+spnot)
	jmp	short esc20	;check kill,etc.

;== Main entry for INPUT ESCAPE ====
; (placed here to be close to buffit)
esc10:	xchg	al,ah		;al=iflag (faster)
	test	al,ofesc1+ofesc0 ;any esc already found?
	jnz	esc11		;yes
; Kill? no spool, just print (also update IFLAG)
esc20:	mov	[iflag],al	;save updated flags
	test	al,spkill	;kill? (no spooling)
	jnz	esc100		;send direct to print
; Null? (No spool, no print, Bit Bucket)
esc30:	test	al,spnull	;null?
	jz	esc40		;no
	jmp	buff98		;status, pop and ret
; Other checking
esc40:
esc98:	xchg	ah,al		;get al=chr,ah=iflag
	jmp	buff2		;return to buffit

;---Input Escape Exits from Buffit
;Pass chr on directly to printer
; cx=cmd and chr, dx=printer # (modified)
esc100:
oldvec:
	mov	ax,cx	;get ah=cmd,al=chr
	pop	bx	;less bytes to pop here
	pop	cx
	pop	di
	pop	ds
	pop	es
	inc	sp
	inc	sp		;pop call ret addr
;	cmp	dl,4		;parallel?
;	jae	oldvec1		;yes,#4-7
;	jmp	jmp14		;serial output
;oldvec1:
;	sub	dl,4		;convert to 0-4
	jmp	jmp17		;parallel out


;--FIRST ESC Chr FOUND, check current esc and set flag
esc1found:
	mov	al,ah		;ah=al=iflag
;	and	al,ofesc1+ofesc0 ;get esc bits
;	cmp	al,ofesc1+ofesc0 ;esc active?
;	jnz	esc1f10		;no
	and	al,not (ofesc1+ofesc0+ofunct+spimmed+spnot) ;clear esc
	or	al,ofesc0	;01=esc1 found
	jmp	esc20		;check kill & null
iescdecmod endp

;--PREVCHR  (dec to previous chr)
;al=chr not put into buffer, spcount-1
prevchr:
	call	deletechr
	jmp	buff98		;set status & ret

;=============BUFFIT procedures========================

;---BUFFIT:--(Store chr in Spool Buffer)--
; certain code below favors speed, not code size
; int routine: al=chr,sets AH=status
buffit proc near		;buffit:
	push	es
;--set local stack here and at exit ???
	push	ds
	push	di
	push	cx		;ch=timeout counter,then status
	push	bx
	mov	cx,cs
	mov	ds,cx		;ds=cs (in 4 clocks)
	mov	cx,ax		;ch=cmmd,cl=chr
; Check for Special Processing (al=cl=chr)
; Backspace or Delete
;	cmp	al,07eh		;backspace? (^ for testing)
;	jz	prevchr		;delete prev chr
;Escape Processing
	mov	ah,[iflag]	;used below
dumb2d:				;see D ,changes next op to or
chr1a:	cmp	al,chr1		;"@" ?(esc #1)
	jz	esc1found	;yes,set iflag
dumb2a:	or	ah,ah		;previous esc? (D changes to al,al)
	jnz	esc10		;yes, escape
;--Store chr in buff,(if not full)
;  cl=chr ,mods ax,etc.(Escape and Timeout reenter here)
	xor	ch,ch		;timeout counter (with di)
buff2:	mov	ax,[hoff]
	inc	ax		;next place to store chr
	cli			;allow no tail change
	jz	buff100		;rollover,ret here with ax=new offset
buff5:	mov	[hoff],ax	;update offset
	cmp	ax,[toff]	;poss full?
	jz	buff105		;yes, check bank#'s,ret here if not full,
				;else, do timeout
buff7:	mov	es,[hseg]
	mov	bx,ax		;es:bx=addr of chr in buff
;Check if turn-on required
buff8:	mov	al,[hton]	; turn-on command
	test	al,0Fh	  	; lo 4bits=0 if no turn-on
	jnz	buff15		;turn-on required
; No turn-on, normal memory write
	mov	es:[bx],cl	;store chr
	jmp	short buff60	;done
;turn-on JRAM, selected bank appears in swap window
buff15:
	mov	di,ds		;save ds
	mov	ds,[hcreg]	;(e.g.E400 =board#2)
	mov	[zerocseg],al	;turn-on (e.g.4D)
	mov	es:[bx],cl	;store chr
	or	al,20h		;bit 5 =turn-off
	mov	[zerocseg],al	;turn-off (e.g.6D)
	mov	ds,di		;restore ds=cs
;Chr stored,Not full, Set Status and return
buff60:	inc	[spcount8]	;#bytes in buff+1
	jnz	buff98		;no wrap
	inc	[spcount24]	;top 16 bits
buff98:	mov	ch,90h		;ready,sel,no err
buff99:	;(exit entry if full with ch=status=01 error)
	sti			;allow ints now
	mov	ax,cx		;get ah=status,al=chr
	pop	bx
	pop	cx
	pop	di
;;--restore stack here????
	pop	ds
	pop	es
	ret			;ah=status,al=chr
; Speed enhancing jumps, favor majority of chrs
;rollover to next 64K bank, set bx=new offset
buff100:
	mov	di,offset head
	call	rollup		;ax=new seg,bx=new offset
	mov	ax,bx		;ax=new offset
	jmp	buff5		;go back
buff105:
;---FULL BUFFER----set status----------------
;Check for full buffer, head=tail?
; cli from above, es:ax=ptr buffer, head vals already at next loc
fullbuff:
	mov	bl,[hbank]	;check bank#
	cmp	bl,[tbank]	;Head=Tail? (full?)
	jnz	buff7		;no, not full
	mov	di,offset head	;decrement Head
	call	decbuffer	;get previous loc
	mov	di,[timeoutval]	;delay with ints on
	;approx 4.5usec per count, 1000h=18ms xch=256 =4.6seconds
fulb10:	sti			;allow buff to empty via int 1C
	dec	di
	jnz	fulb10		;delay with ints on
	inc	ch		;timeout count+1
	jz	fulb99		;exit,timed out
fulb20:	test	[oflag],ohalt	;halt?
	jnz	fulb99		;yes,force time out
	;following allows spoolcom to enter escape seq (like flush) fast
	test	[iflag],ofesc1	;any iesc activity? (2 or 3 chrs of esc seq)
	db	90,90		;allow for patch
;	jnz	fulb99		;yes, force time out
	jmp	buff2		;try again (cl=chr)
fulb99:	mov	ch,01h		;status=timeout
	jmp	buff99		;exit,no inc,(full)
buffit	endp
;...................................................
decbufp proc near
;---DECBUFFER---(get previous location)-----
;di=Info bank to use (Head,Tail, etc.)
;mods ax,bx
decbuffer:
	;get starting offset for current bank (can be non-zero)
	push	cx
	cli			;allow no change
	mov	ch,[di]		;bank#
	mov	bx,[di+4]	;bx=current offset
	mov	ax,[begoff]	;(can wrap when non-zero)
	cmp	ch,[begbank]	;begbank?
	jz	decb12		;yes
	mov	ax,[endoff]	;(also can be non-zero)
	cmp	ch,[endbank]	;endbank?
	jz	decb12		;yes
	xor	ax,ax		;(mid-bank offset=0)
;if at beginning of bank, rolldown
decb12:	pop	cx
	cmp	bx,ax		;curr offset = begin of bank?
	jz	decb20		;yes,rolldown
	dec	bx
	mov	[di+4],bx	;just dec offset
	ret
;rolldown required,(i.e. last chr caused rollover)
decb20:	call	rolldown	;di=Info bank
	ret
decbufp endp

;=======================================================
;---TIMELOOP--(Vector 1C enters below)----------------
; Called each tick  18.2/sec (54.9 msec)
; Uses up to 25% (13.7msec) sending chrs to printer
timeloop proc	near
;--Output Halt, check for xon or repeat--
outhalt:
; get dx=printer #, do not check parallel port
	mov	ax,[printer]	;0-3 ser,4-7 parall
	cmp	al,4		;parallel? (ge 4)
	jae	outp30	;yes, skip,no XON for parallel ptr
; XON check status (chr received?)
	test	[oflag],oxoff	;xoff previously set?
	jz	outp30		;no
	push	dx		;not saved yet
	mov	dx,ax		;get dx=printer #
	mov	ah,3		;status
	int	54h		;old vec 14
	test	ah,bit0		;chr received? 
	jz	outp28		;exit,not received
; XON received? (to terminate halt)
	mov	ah,2		;receive chr
	int	54h		;vec 14
	cmp	al,11		;XON?
	jnz	outp28		;no, exit
	mov	al,not oxoff	;yes,reset xoff halt
	and	[oflag],al
outp28:	pop	dx
	jmp	short qexit	;exit,no print this tick
; Repeat overrides halt (del jnz below to elim)
outp30:	test	[oflag],orep	;active repeat?
	jnz	time14		;yes, override halt( no override xoff)
qexit:	jmp	quickexit	;yes,exit,no print

;++++++++++++++++++++++++++++++++++++++++++++++++++
;--INT 1C ENTRY---(18.2/sec 55.4 msec)-------------
;new1C:  Set local (ds=cs) addressing,  modify no regs

;TIME 10 (normal entry for OUTPUT section of JSPOOL)
;(also see new08 for replacement of int08)
time10:	push	ax
	push	ds
	mov	ax,cs
	mov	ds,ax		;ds=cs in 4 clocks
	cli			;in case sti done by timer chain (IRQ too)
	test	[oflag],orep+ohalt+oxoff ;rep or halt?
	jnz	outhalt		;yes, get xon,etc.
	xor	ax,ax		;ax=0
	cmp	[spcount8],al	;lo 8 bits=0?
	jnz	time14		;not empty
	cmp	[spcount24],ax	;hi16 =0?
	jnz	time14		;not empty
	jmp	quickexit	;exit,empty
.xlist
;if halt override above not done, include below
;	jnz	time12		;not empty
;	test	[oflag],orep	;repeat?
;	jnz	time14		;empty but do repeat
;	jmp	quickexit	;exit,empty
;--Buff not empty, check for halt
;time12:	sti		;ints ok now
;	test	[oflag],ohalt+oxoff ;halt?
;	jnz	outproc		;yes, get xon,etc.
.list
;--Get Printer type and send chr---

;--need stack local??? here???
time14:	sti			;ints ok now
	push	bx
	push	cx
	push	dx
	push	di
	push	es		;(exit via time99)
	mov	ax,[word ptr ticklim]; get tick & busylim
	mov	[word ptr tickchrs],ax; init tick&busylim

;--PRINTING LOOP---(cycles till time done)----------
time20:	cli			;no changes
	xor	al,al
	out	43,al		;latch downcounter on timer
	in	al,40		;get lsb of count (ignore)
	in	al,40		;get msb of count (214usec/cnt)
	sti			;al=counts left (FF-0)
	add	al,[timelim]	;nc if over limit
	jc	time21		;under limit
	inc	[overtime]	;statistics (testing???)
	jmp	short time22	;over limit
time21:	test	[oflag],ohalt+oxoff ;halt or xoff?
	jz	time24		;no
	inc	[haltcount]	;statistics (testing???)
time22:	jmp	timelimit	;exit
time24:	mov	ax,[printer]	;0-3=serial, 4-7=parallel
	mov	dx,ax		;using ax save bytes and time
	cmp	al,4		;parallel? ge 4?
	jae	timepar		;yes, its parallel

;--RS232 SERIAL PORT OUTPUT-------------
timeser:
; Check Status and if Chr received (XOFF)
	mov	ah,3		;get status, dx set above
	int	54h		;call old vec14
	test	ah,bit0		;chr received?
	jmp	tser10		;force no XOFF (see below)???
;	jz	tser10		;no
; XON-XOFF testing
; FIX this, disabled for now becaue of IBM rom ??????
	push	ax		;save above flag
	mov	ah,2
	int	54h		;get chr
	or	ah,ah		;errors?
	jnz	tser1		;yes, exit,pop,no print
	cmp	al,13		;XOFF?
	jnz	tser9		;no
; XOFF Found
	or	[oflag],oxoff	;set xoff halt
; Exit, no print
tser1:	pop	ax		;recover flag
tser2:	jmp	timelimit	;exit without printing
tser9:	pop	ax		;recover status

; Send Chr RS232
tser10:
; Line active? (CTS (and DSR?)) (??? BUG here becausse of IBM ROM)???
cts1:	xor	al,bit4+bit5	;CTS ok? (bit5=DSR)(invert bits)
	and	al,bit4+bit5	;select CTS and DSR,z=good
	jnz	tser2		;exit without printing
cts2:	test	ah,bit5		;xmt reg empty?
	jz	time40		;not empty, wait
;	cli			;cli/sti needed for IRQ
;;local stack here???
	call	getchr		;al= chr from buff
	jc	time50		;null print
	mov	ah,1		;send chr
;;elim all int 54's, etc all local ????
	int	54h		;old vec 14
	;check status if necess...
	jmp	time50		;inc # chrs printed

;--PARALLEL PORT OUTPUT-----------
timepar:
; Check Status and set dx=printer code
	sub	dl,4	;parallel pntr # 0-3
	mov	ah,2	;status request
;;elim all int 55h's
	int	55h	;old vec 17
	test	ah,80	;busy?
	jz	time40	;yes, wait
;	cmp	ah,90	;not busy,no ioerr?
;	jnz	time40	;no, wait
;	cli		;cli/sti needed for IRQ
	call	getchr	;get al=chr
	jc	time50	;null print
	xor	ah,ah	;print command
	int	55h	;old vec 17
;;---is old vec 17 reentrant??? can Jspool interrupt a call to 17?
;; (or to 14? as in a com port call???)

.xlist
; manual print routine used to elim delay...
;	push	ds
;	push	dx	;save timeout count
;	mov	ah,al	;save chr
;	xor	dx,dx	;set ds=0
;	mov	ds,dx
;	assume	ds:abs0
;	mov	dx,[parabase0] ;port#,pntr#0
;	assume ds:cseg
;	out	dx,al	;put chr in port
;	inc	dx	;status port
;	in	al,dx	;get status
;	test	al,80	;busy?
;	jnz	tp10	;not busy
;...	int 3	;testing, never should exec
;	nop
;	nop
;	nop
;tp10:	mov	al,0dh	;strobe=1
;	inc	dx	;bit0 port c
;	out	dx,al	;strobe hi
;	mov	al,0ch	;strobe lo
;	out	dx,al
;	mov	al,ah	;recover chr
;	pop	dx	;timeout count
;	pop	ds
.list
	jmp	short time50	;check limits

;---BUSY LOOP, inc busy count and continue--
time40:	dec	[busycnt]	;reset 0 when chr pnted
	jmp	short time60	;go test z=limit

;---ONE CHR HAS BEEN PRINTED --(inc cnt & save busy cnt)--
;dec spool count and test if empty (count=0)
time50:	xor	ax,ax		;ax=0
	cmp	[spcount8],al	;lo 8 bits=0?
	jnz	time51		;yes, (no borrow)
	dec	[spcount24]	;borrow top16,not empty
time51:	dec	[spcount8]	;count-1
	jnz	time52		;not empty
	cmp	[spcount24],ax	;top16=0?(empty?)
	jnz	time52		;not empty
	test	[oflag],orep	;repeat active?
	jz	timelimit	;no, exit,empty
;not empty, reinit busy count, compute max busy count
time52:	mov	al,[busylim]	;compute #busy cnts
	mov	ah,al		;save for below
	xchg	ah,[busycnt]	;get & init busycnt
	sub	al,ah		;al=# busy cycles
	cmp	al,[busymax]	;#cycles>last max?
	jna	time53		;not maximum
	mov	[busymax],al	;new max

time53:	dec	[tickchrs]	;#chrs left this tick-1

;Time Limit exceeded? (13.7 msec typ)
time60:	jz	timelimit	;previous z=exit
time95:	jmp	time20		;Loop, more printing

;--TIME LIMIT (or other limit) exceeded--------
timelimit:
;STATISTICS: (testing, summaries, etc.)
	xor	ax,ax
	cli
	out	43,al		;latch time
	in	al,40		;lsb
	mov	ah,al
	in	al,40		;msb
	sti
	xchg	al,ah		;countdown at limit
	neg	ax		;time used
	cmp	ax,[timemax] 	;above max?
	jbe	timelim10	;no
	mov	[timemax],ax	;new max
; STATISTICS: get # chrs printed this tick
timelim10:
	mov	al,[ticklim]	;max allowed
	sub	al,[tickchrs]	;# printed
	cmp	al,[chrsmax]	;above max?
	jbe	timelim12	;no
	mov	[chrsmax],al	;new max
timelim12:
; compute new time limit here (auto adjusting)
timelim99:

;--TIME LOOP EXIT ---(pop and return)--
time99:
	pop	es
	pop	di
	pop	dx
	pop	cx
	pop	bx
quickexit:			;used by halt,etc.
	pop	ds
	pop	ax
jmp1C:	ret			;short ret to intern clock int
	dw	0000		;see note below
	dw	0000		;space for jump
;NOTE: if new08 not used, then use the below
;jmp1C:	jmp	far ptr zero  ;typically f000:ff53
;		;continue chain of int08 (time int)
;=================================================
getcmod proc near
;--GET CHR FROM SPOOL BUFFER----------------------
;gets chr from spool buffer and check tabs, cr count
;al=chr, di=0, dx=printer, mods ah,es,cx,bx
;Main entry is GETCHR
;-- Recover escape chrs (not printed because of pending esc seq.)
; @ and or # to be printed and also cl=chr
;no mod al=flag, mods di
recoveresc:
	test	al,ofesc1	;esc 1&2 already?
	jz	rcve20		;no
	mov	ah,chr2		;send chr2
	call	putomultbuff	;put in 16 chr buff (mods di)
rcve20:	mov	ah,cl		;curr chr
	call	putomultbuff	;put in buff
	mov	cl,[byte ptr chr1a+1] ;get esc chr1 (@)
	mov	al,orep		;pseudo flag=no esc but repeats
	jmp	short gete20	;reset esc and ret nc=print

;-- GET ESC , Escape testing (called by getchr)
; al=[oflag], updates [oflag],returns al=chr
; Escape sequence check (00=none,01,10,11=all three)
;get next chr and check for escchrs 2 & 3
getesc:	push	ax		;save flag
	call	readbuff ;mods es,di,cx,bx,ah;get cl=chr
	pop	ax		;al=flag
	test	al,ofesc1	;esc#1&2 already?
	jnz	gete17		;yes,check #3
	cmp	cl,chr2		;chr2 found?
	jnz	recoveresc	;no, recov 1 esc chr,reset esc
	xor	al,ofesc1+ofesc0	;01 becomes 10
	jmp	gete89
gete17:	test	al,ofesc0	;esc 1&2&3 already?
	jnz	gete18		;yes, process cmmd
	cmp	cl,chr3		;chr 3?
	jnz	recoveresc	;no, reset esc
	or	al,ofesc0	;set #3 found
	jmp	short gete89
;escape decode, check "not"
gete18:	cmp	cl,"-"		;"NOT" function?
	jnz	gete30		;no
	test	al,spnot	;not not? (2 nots illegal)
	jz	gete25		;ok
;reset escape, set nc
gete20:	and	al,not(ofesc1+ofesc0) ;reset esc,set nc
	jmp	short gete90	;ret nc=print
gete25:	or	al,spnot	;set not
	jmp	short gete89	;no print exit
;valid esc seq, decode
gete30:	call	oescdecode	;yes, process command
	and	al,not spnot	;reset not
	cmp	cl,0Dh		;only cr prints
	jz	gete90		;nc=print
gete89:	stc			;cy=no print
gete90:	mov	[oflag],al	;save updated flags
	mov	al,cl		;al=chr
gete95:	ret			;cy/nc set

getdecp	proc near
;--OUTPUT (upon Printing) ESCAPE DECODING--
; All commands have been entered via
; default "-I" or no prefix escape command.
;"not" is set before entry, reset after exit
; cr or semicoln resets escape
oescdecode:
	call	uppercl		;convert cl to uppercase
	test	al,ofunct	;function active?
	jz	oesc3		;no
;Escape function processing (highest priorty)
	push	ax		;save orig flag
	test	al,spnot	;- specd?
	mov	ax,[oescflag]
	jz	oesc1		;no
	or	al,spnot	;set "-" in escflag
oesc1:	test	al,eftab	;tabs?
	jz	oesc2		;no
	call	tabstopdecode	;get tab stops
	mov	[oescflag],ax	;cy=end of tab
	jmp	oesc2a		;test end
;not tabs, other escape multi byte function
oesc2:	call	escfunction	;process function
	mov	[oescflag],ax	;update flag
oesc2a:	jc	oesc2e		;cl=poss new command letter
	or	ax,ax		;esc funct done?
	pop	ax
	jnz	oesc2b		;not done
	xor	al,ofunct	;done
oesc2b:	ret

;Try new command letter cl
oesc2e:	pop	ax
	xor	al,ofunct	;reset funct

;CR (resets escape sequence)
oesc3:	cmp	cl,0Dh		;cr? resets
	jz	oesc5		;yes, reset
	cmp	cl,";"		;semicoln? reset
	jnz	oesc10		;no
oesc5:	and	al,not(ofesc1+ofesc0+ofunct+spimmed+spnot)
	ret
;Delay (-I) Mode required
oesc10:	test	al,spimmed	;immediate?
	jz	oesc20		;ok,not immed
	ret

;ONE LETTER OUTPUT ESC commands H R N K etc.
;al=flag
oesc20:	push	si
	mov	si,offset oflagtab ;OFLAG (catch I here)
	mov	di,offset oflag
	call	getopt		;cl=chr,sets H/R
	jc	oesc30		;no match found
	mov	al,[di]		;get updated flag
	jmp	oesc59		;reset not
oesc30:	mov	si,offset iflagtab ;IFLAG
	mov	di,offset iflag
	pushf			;prevent ints during change
	cli
	call	getopt		;cl=chr,sets N,K (I already done)
	jc	oesc39		;no match found
	popf			;N or K found
	pop	si
	test	byte ptr[di],spnull+spkill ;either set?
	jnz	short oesc5	;yes,reset oflag
	ret
oesc39:	popf
oesc40:	mov	si,offset esc1tab
	mov	di,offset oescflag ;low order byte
	call	getopt		;cl=chr, sets S,T,X,D,L,M
	jc	oesc50		;no match found
;TABSET (sets tabs stops, T0 resets all to 8's)
;Reset tab vals
	cmp	cl,'T'		;tabs?
	jnz	oesc57		;no
	call	resettabs
	jmp	short oesc57	;set function active
;2nd Escape Table
oesc50:	mov	si,offset esc2tab
	mov	di,offset oescflag+1 ;hi order byte
	call	getopt		;cl=chr, sets P,B,Y,Z,U,V,W
	jc	oesc60		;no match
oesc57:	call	clearnum	;reset temp number in case used
	or	al,spfunct	;set function active
oesc59:	pop	si
	ret
oesc60:	pop	si

;EVEN (jumps to next page if necess to set page=even)
oesc75:	cmp	cl,"E"		;even?
	jnz	oesc76		;no
	xor	ch,ch		;ch=0 bit desired
	jmp	oesc77		;modify pagecnt

;ODD (jumps to next page if necess to set page=odd)
oesc76:	cmp	cl,"O"		;odd?
	jnz	oesc80		;no
	mov	ch,bit0		;odd bit0=1
oesc77:	test	al,spnot	;invert?
	jz	oesc78		;no
	xor	ch,bit0		;yes
;get page and force a form feed if necess
oesc78:	mov	ah,bit0		;select bit0
	and	ah,[pagecount]	;odd or even?
	cmp	ah,ch		;already as desired?
	jz	oesc79		;yes,no ff needed
	mov	ah,0Ch		;1 form feed
	call	putomultbuff	;put in rep buff,sets oflag=orep
	or	al,orep		;repeat flag? (could  cause probs??????)
oesc79:	ret

;COMPRESSED (Parallel: Customize for Serial)
oesc80:	cmp	cl,"C"		;compressed
	jnz	oesc95		;no
	mov	di,offset cseg:omultinfo
	call	compress	;put codes in buff
	or	al,orep		;repeat flag (stored again)
	ret

;DELIMS space,comma ok, all other chrs are illegal and reset esc
;tab (a repeat chr) is not allowed
oesc95:	call	chkdelimcl	;cl=space,comma,equal ok
	jnc	oesc99		;yes, ok
	mov	cl,';'		;display error as semicoln
	and	al,not(ofesc1+ofesc0+ofunct+spimmed+spnot) ;reset all
oesc99:	ret
getdecp	endp	;...............................

;TAB STOP NUMBER DECODE
; ax=oescflag, sets cy=tabs reset,illeg chrs
; cl=chr
tabstopdecode:
	test	al,spnot	;T- illegal
	jnz	tabs98		;reset flag,try new cmmd
	cmp	cl,'='		;ignore if =
	jz	tabs18		;exit ,nc
	xchg	di,ax		;save flag
	call	calcnum8	;al gets current total
	jc	tabs45		;non number, end of this val
	xchg	di,ax		;ax=flag again
tabs18:	ret			;flag unchanged,tabs still going
;Illegal or Legal (non-number) chrs terminate number
tabs45:	jnz	tabs97		;tab too big,tab > 255, reset
	or	al,al		;no entry or zero? (delim or 0)?
	jz	tabs46		;yes,poss end of tabs
	cmp	al,[tabcomp]	;gt last val? (must ascend)
	mov	[tabcomp],al	;update
	jbe	tabs97		;not ascending,reset
	xor	bh,bh		;compute index into table
	mov	bl,[ntabs]	;bl=table index
	xor	ah,ah		;next tab init val
	mov	[word ptr tabtab+bx],ax ;store tabstop,init next
	call	clearnum	;init num=0 for next tab
	cmp	[ntabs],20h	;over limit? (32 tabs max)
	jae	tabs46		;yes, stay at 32
	inc	[ntabs]		;#tabs+1
tabs46:	xchg	ax,di		;ax=escflag again
	cmp	cl,'A'		;another command begins?
	jae	tabs98		;yes, process it
	call	chkdelimcl	;cl=space,comma,equal?
	jc	tabs98		;no, process new command
	ret			;escflag unchanged
;Reset tabs and/or reset flag, process new command
tabs97:	xchg	ax,di		;get ax=escflag
	call	resettabs	;reset tabs values
	mov	cl,';'		;force end
tabs98: xor	al,eftab	;reset tab active
	stc			;cy=new command starts
	ret
;--RESET TABS
resettabs:
	mov	[ntabs],0	;yes, reset vals
	mov	byte ptr[tabtab],0 ;0=terminator
	mov	[tabcomp],0	;used to check order
	ret

;+++++++++++++++++++++++++++++++++++++++++++++++
;--Main GETCHR entry ---------------------------
getchr:	mov	al,[oflag]
	test	al,ofesc1+ofesc0+orep ;repeat or escape active?
dumb2b:	jz	gchr10		;no (D changes to jmp)
; Repeats? (have priority, above halt,must finish)
	test	al,orep		;any repeats?
	jz	gchr7		;none
	inc	[spcount8]	;adjust for later dec
	jnz	gchr4		;no rollover
	inc	[spcount24]	;top 16 bits
;omult has prior so codes finish before intrupted by immed vals
gchr4:	call	getomultbuff	;mult buff has priority
	jc	gchr4a		;no chrs,try other buff
	jmp	gchr20		;al=chr, check contrl code
gchr4a:	call	getimultbuff	;mods di
	jc	gchr5		;no chrs avail
	jmp	gchr20		;al=chr,check for cntrl code 
gchr5:	call	getrepeat	;single chr?
	jc	gchr6		;no chr avail
	jmp	gchr97		;al=chr,dont check for cntrl
gchr6:	xor	al,orep		;reset flag,no chrs found
	mov	[oflag],al	;update
;	cmp	[byte ptr dumb2d],0Ch ;dumb2 set?
;	jnz	gchr6a		;no
;	mov	[byte ptr dumb2b],0EBh ;yes,jmp gchr10
gchr6a:	stc			;cy=no print
	ret
;No repeats, do escape code processing
gchr7:	call	getesc		;decode esc
	jc	gchr98		;cy=no print
	jnc	gchr97		;got chr, no check, must print
gchr10:	call	readbuff ;mods es,di,cx,bx,ah;get al=chr from buff
	;al=chr  ah,es,bx now can be used
gchr20:
dumb1b:	cmp	al,20		;control code?
	jb	concode		;yes
chr1b:	cmp	al,chr1		;escape code?
dumb2c:	jnz	gchr97		;no (D changes to jmp)
;set escape #1 found (IRQ proc must cli here)
	mov	ah,al		;save chr
	mov	al,[oflag]
	and	al,not ofesc1	;set 01= 1 found
	or	al,ofesc0	;chr#1 found
	mov	[oflag],al	;update flags
	xchg	al,ah		;al=chr
	jmp	short gchr98	;no print
gchr97:	dec	[chrsleft]	;#chrs left in line
	clc			;nc=ok to print
line1a:	jmp	gchr99		;jnz, not at eol (see D and L)
	inc	[chrsleft]	;truncate till cr found
gchr98:	stc			;cy=no print
gchr99:	ret			;al=chr, es,bx,cx changed

;--Check control codes for tab expand, line count
concode proc near 		;concode:
	test	[concodeflag],cfesc ;previous esc?
	jz	conc10		;no
	cmp	al,0Dh		;cr? (terminator esc seq)
	je	conc8		;yes, done
	mov	ah,[escpoint]	;get #chrs since esc
	sub	ah,[chrsleft]
	cmp	ah,6		;allow 6 max in esc seq
	jbe	conc7		;esc active, still no decode or expand
	xor	[concodeflag],cfesc ;reset esc
conc7:	clc
	ret			;nc=print
conc8:	xor	[concodeflag],cfesc ;reset esc
	jmp	conc41		;set cr values
conc10:	cmp	al,09		;tab?
	jnz	conc20		;no
	call	tabspaces	;get #spaces
	;sets cy=no print, already there, else al=space
	jnc	gchr97		;print a space
	ret
;ESCAPE code (chrs following 1Bh passed un-decoded till cr)
conc20:	cmp	al,1Bh		;esc?
	jnz	conc30		;no
	or	[concodeflag],cfesc ;set esc found
	mov	ah,[chrsleft]	;point where esc starts
	mov	[escpoint],ah
	ret			;nc,print

;Line Feed before CR may require special treatment
;see Form Feed (below)
conc30:	cmp	al,0A		;line feed?
	jnz	conc40		;no
	jmp	short conc31	;skip centronics patch
;CENTRONICS mod , needs lf then cr to not miss chrs
; 0D is made into a null, non print chr (cy set)
	mov	[tickchrs],1	;force end of tick
	xor	al,al		;null
	stc			;cy=no print
	ret
conc31:	mov	ah,[lmargin]	;setup left margin
	or	ah,ah
	jz	conc32		;0=no margin
	;call repeatchr		;al=chr,ah=count
	mov	[repcount],ah
	mov	[repchr],20	;send n spaces, next tick
	or	[oflag],orep	;set repeat
conc32:	dec	[lcount]	;#lines left
	jnz	conc38		;not end of page
conc35:	mov	ah,[linelim]	;init l per page
	mov	[lcount],ah
conc37:	inc	[pagecount]	;page+1
conc38:	clc			;print ok
	ret

;CR (carriage return)
conc40:	cmp	al,0Dh		;return?
	jnz	conc45		;no
conc41:	mov	ah,[chrslim]	;#chrs/line
	mov	[chrsleft],ah	;init
	xor	ah,ah		;0 below
	mov	[nexttab],ah	;next table entry
	mov	[tabcomp],ah	;computed tab
	clc			;set to NOP if Centronics
	ret			;set to NOP for CENTRONICS
;CENTRONICS mod, needs lf,cr in that order
	call	conc31		;do lf reset
	mov	[repchr],al	;do cr next time
	mov	[repcount],1
	mov	al,0Ah		;lf first
	mov	[tickchrs],1	;only one more chr
	;force end of tick, to allow some millisecs for cr,lf
	;to set busy on DTR line
	clc
	ret
;Citoh printer must have a CR before FF,VT,LF
;take this out for printers with auto line feed!
;send CR first, follow with FF repeat=1
conc45:	cmp	al,0C	;formfeed?
	jnz	conc50	;no
	or	[oflag],orep	;set repeat
	mov	[repchr],al	;print next time 
	mov	[repcount],1	;1 time
	mov	ah,[lmargin]	;setup left margin
	or	ah,ah
	jz	conc46		;0=no margin
	;call repeatchr		;al=chr,ah=count
	mov	[orepcount],ah	;orep prints after rep
	mov	[orepchr],20	;send n spaces, next tick
conc46:	mov	al,0Dh		;CR this time
	call	conc35		;set new page vals
	jmp	conc40		;set cr vals
;for MASM, issues FF then a BACKSPACE,below can provide margin
conc50:	cmp	al,08		;backspace?
	jmp	conc60		;no or yes, ignored
	inc	[lcount]	;adj for above
	jmp	conc31		;do margin (part of line feed)
conc60:
conc99:	clc			;ok to print
	ret
concode	endp

;--Compute TABSPACES to next tabstop--------------
; sets cy if no spaces needed, else al=space, and
; repchr set as needed
tabspaces proc near		;tabspaces:
	push	dx
	mov	dh,[chrslim]	;max-#left=chr pos
	sub	dh,[lmargin]	;dont count spaces used for margin
	sub	dh,[chrsleft]	;#chrs pnted 0-255
	inc	dh		;next chr pos 1-256
	mov	dl,[ntabs]	;#tabs in table
	xor	ch,ch		;top 8 bits=0
	mov	cl,dl		;cx=#tabs
	mov	bh,ch
	mov	bl,[nexttab]	;last used table index
	sub	cx,bx		;cx=#tabs left=ntabs-nxttab
	jz	tabsp30		;none set, compute one
; Search table for next tab greater than chr pos
tabsp12:
	mov	al,byte ptr[bx+offset tabtab] ;get tabstop
	cmp	dh,al		;next chr pos < next tabstop?
	jb	tabsp40		;yes, got tab
	inc	bx		;next table entry
	loop	tabsp12
; No tab found, compute one
tabsp30:
	mov	al,dh		;next chr pos, 1-255
	add	al,7		;al-1+8
	and	al,0f8h		;truncate mod 8
	inc	al		;new next chr pos 9-256
	mov	bl,dl		;make nexttab=ntabs
; Calc # spaces al=tab chrpos, bl=nexttab, dl=ntabs
tabsp40:;(mov	[chrpos],al)
	mov	[nexttab],bl	;update next index
	sub	al,dh		;al=#spaces to output
	pop	dx
	cmp	al,1		;#spaces=0 or =1?
	jb	tabsp15		;no spaces
	jz	tabsp14		;one space
	or	[oflag],orep	;repeat
	dec	al		;#remaining after this
	mov	[repcount],al	;set remaining count
tabsp14:
	mov	al,20h		;chr=space
	mov	[repchr],al	;save
	clc			;print a chr
	ret
tabsp15:
	stc			;no print
	ret
tabspaces endp
calcnp proc near
;---CALC NUMBER (max=255, one chr at a time)---------------
;cl=chr to build into number
;sets al=current number, cy=end of number found (space or illeg chr)
calcnumtemp dw	0000		;temp number
clearnum:
	mov	[calcnumtemp],0
	ret
;8 and 16 bit calc numbers
;nc=number ok,  cy,z=not number, cy,nz=num too big
calcnum8:
	call	calcnum		;cl=chr
	jc	ccn8c		;cy,z=cl not number
	or	ah,ah		;number < 255?
	jnz	ccn8d		;no,too big (cy,nz)
	ret			;ok, (nc)
ccn8c:	cmp	al,al		;set z
ccn8d:	stc
	ret			;ax=8 bit number

calcnum:
	mov	ax,[calcnumtemp] ;currently built number
	call	calcnumclax	;cl=chr, cy=bad chr
	mov	[calcnumtemp],ax ;unchanged if cy
	ret

;cl=chr, one number returned in ax
calcnumcl:
	xor	ax,ax
	jz	calcnumclax
;cl=chr, al=number to mod
calcnumclal:
	xor	ah,ah		;set ax=al
calcnumclax:
	cmp	cl,30		;below 0?
	jb	cnum99		;yes,bad value
	cmp	cl,39		;above 9?
	ja	cnum99		;yes,bad value
	push	cx
	xor	ch,ch		;cx=chr
	sub	cl,30		;convert 0-9
	add	ax,ax		;n*2
	add	cx,ax		;n*2+digit
	add	ax,ax		;n*4
	add	ax,ax		;n*8
	add	ax,cx		;n*10+digit
	pop	cx		
	clc
	ret			;ax=number,cl=chr
cnum99:	stc			;cy=error
	ret
calcnp endp

delchrp proc near	;(now used,see prevchr)
;--DELETE CHR (decrement Head and Spcount)--------
;al=chr not put into buffer, spcount-1
deletechr:
	cli			;allow no change
	mov	bx,[spcount24]	;buffer empty?
	mov	ah,[spcount8]	;count=0?
	or	bl,ah
	or	bx,bx		;24bit count=0?
	jz	dchr98		;yes,empty,exit
;dec spcount and Head Info values
	or	al,al		;low8=0? (borrow coming?)
	jnz	dchr20		;no borrow
	dec	[spcount24]	;borrow
dchr20:	dec	[spcount8]	;count-1
	mov	di,offset head	;Head Info
	push	ax
	call	decbuffer	;get previous loc
	pop	ax
dchr98:	ret			;al=chr
delchrp	endp

rbuffp proc near
;--READBUF Subroutine (get chr at Tail loc)-----------
; inc pointer, then gets al=cl=chr, mods es:bx,di,cx,ah
readbuff:
	mov	ax,[toff]
	inc	ax		;next place to store chr
	cli			;allow no irq head change
	jz	rbuf100		;rollover,ret here with new ax=offset
rbuf7:	mov	[toff],ax
	mov	es,[tseg]
	mov	bx,ax		;es:bx=addr of chr in buff
;Check if turn-on required
	mov	al,[tton]	;turn-on command
	test	al,0Fh	  	;lo 4bits=0 if no turn-on
	jz	rbuf25		;no turn-on required
;Turn-on required
	mov	di,ds		;save ds
	mov	ds,[tcreg]	;creg like E400
	mov	[zerocseg],al	;turn on JRAM
	mov	cl,es:[bx]	;get chr
	or	al,20h		;bit5=turn-off
	mov	[zerocseg],al	;turn off
	mov	ds,di		;recover ds
	mov	al,cl
	sti
	ret			;al=cl=chr
; No turn-on, normal memory write
rbuf25:	mov	al,es:[bx]	;get chr
	mov	cl,al
	sti
	ret			;al=cl=chr
;Rollover to next bank
rbuf100:
	mov	di,offset tbank  ;Roll Tail
	call	rollup	;sets ax=seg,bx=offset
	mov	ax,bx	;get ax=offset
	jmp	rbuf7	;return ax=new offset
rbuffp endp
getcmod endp

;REPLACEMENT TIMER INTERRUPT (INT08)
;resets irq chip early so that com lines and other
;irqs can get through during the 12 ms slice used
;by the spooler. See Danger note below.
;public new08
new08:	sti
	push	ax
	push	dx
	push	ds
	xor	ax,ax
	assume	ds:abs0
	mov	ds,ax		;address base 0
	inc	[timelow]
	mov	ax,[timelow+2]
	jnz	new08a		;no overflow
	inc	ax
new08a:	mov	[timelow+2],ax	;update
	cmp	ax,18		;24 hours?
	jnz	new08b		;no
	cmp	[timelow],0B0h	;test low word
	jnz	new08b		;no
	mov	[timelow],0	;yes, reinit
	mov	[timelow+2],0
	mov	[byte ptr (timelow+4)],1 ;flag day changed
new08b:	dec	[motor+1]	;motor count done?
	jnz	new08c		;no
	and	[motor],0F0	;flag motor off 
	mov	al,0Ch
	mov	dx,03f2H	;disk controller command
	out	dx,al		;turn off motor
new08c:	mov	al,20		;enable further interrupts
	out	20,al		;8259 irq chip can allow lower prio irqs
	assume	ds:cseg
	pop	ds
	pop	dx
	pop	ax
;NOTE: end time10 with reg ret if this option is used
	call	time10		;do local
;DANGER, if user prog uses too much time, another clock
; tick will occur and cause recursion and possible stack crash
;differs from IBM in that ds not set to 40
	int	1Ch		;give a tick to user prog
	iret
timeloop endp
;................................................
jspool	endp
;mainseg ends
;..............END OF MAIN SEGMENT................

;========STACK SEGMENT============================
;stackseg segment para ;public 'code' ;(true "stack" will foil exe2bin)
;public begsp
assume cs:cseg,ds:cseg
if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif
	org	$+100h   ;DOS man recommends this much
begsp	equ	$
;stackseg ends
;...............END OF STACK SEGMENT..............

;=======TESTING SEGMENT=========================
;testseg segment para ;public 'code'
;public testingentry
;testingentry:
;testseg ends
;.....end testing..................................
;=============== CODE ======================
TESTSEGMOD proc near
;----TESTING SEGMENT -----------------------
;public testing
;start=$
;--TESTING ROUTINES ????????????
if ($-start) mod 10h
org ($-start)+10h-(($-start)mod 10h)
endif				;align on para
;extrn spbegoff:word
;extrn spbegbank:byte
;extrn spbytes16:word
;extrn spbytesmsb:byte
;extrn spbytes16:word
;extrn spbytesmsb:byte
testing proc near	;testing:
	mov	sp,0ffe0h
	mov	ax,cs
	mov	ds,ax
	inc	ax
	mov	es,ax		;pseudo dos table
	mov	bx,offset cseg:hdos ;bpb of pseudo dos
	mov	byte ptr[bx+2],0 ;init bpb
	sub	bx,10		;make bx-10 so es:bx is right
	mov	si,6		;fool assembler
	mov	ax,[si]		;preinit addr
	mov	[callpreinit],ax	;call loc
	mov	ax,[si+2]		;addr of init
	mov	[callinit],ax	;call loc
	mov	[callinitcs],cs ;far call seg
	mov	[callpreinitcs],cs	;same
;	call	far ptr [callpreinit]
	db	0FF,01E	;call far op codes
	dw	offset cseg:callpreinit
	mov	[spbegoff],0
	mov	[spbegbank],0
	mov	[spbytes16],0
	mov	[spbytesmsb],0
	mov	[spbytes16],0
	mov	[spbytesmsb],0
;	call	far ptr[callinit]
	db	0FF,01E	; call far op codes
	dw	offset cseg:callinit
	int	3
	int	3
callpreinit	dw	0	;double word call
callpreinitcs	dw	0	;seg
callinit	dw	0
callinitcs	dw	0
if ($-start) mod 10h
org ($-start)+10h-(($-start)mod 10h)
endif				;align on para

hdos	db	22 dup (74)	;pseudo bpb
if ($-start) mod 10h
org ($-start)+10h-(($-start)mod 10h)
endif				;align on para
;---RUN TEST OF SPOOLER---------------------
;extrn spcount:near
test2:
	mov	sp,0ffe0h
	mov	ax,0AAAAh
	mov	bx,0BBBBh
	mov	cx,0CCCCh
	mov	dx,0DDDDh
	push	cs
	pop	ds
testloop:
	mov	cx,1010
testl5:	mov	ax,003Ah	;print, chr=3A
	int	17
	test	ah,80
	jz	testl10
	loop	testl5
testl10:
	mov	bx,word ptr[spcount]
	int 3
	int 3
testing endp
.list

TESTSEGMOD endp
;=======SUBROUTINES SEGMENT======================
;cseg group subseg
;subseg segment para ;public 'code'
;assume cs:cseg,ds:cseg
.xlist
;;extrn spbegbank:byte
;;extrn spbegoff:word
;;extrn spendbank:byte
;;extrn spendoff:word
;;extrn head:byte
;;extrn tail:byte
;;extrn begseg:word
;;extrn begbank:byte
;;extrn begoff:word
;;extrn endseg:word
;;extrn endbank:byte
;;extrn endoff:word
;;extrn copyheadtailscan:near
;;extrn multcount:byte
;;extrn multindex:byte
;;extrn multbuff:near
;;extrn temp:byte
;;extrn repcount:byte
;;extrn repchr:byte
;;extrn printer:word
;;extrn chrslim:byte
;;extrn spcount8:byte
;;extrn spcount24:word
;;extrn spbytes:word
;;extrn swapseg:word
;;extrn swapbank:byte

;spnot=bit0
;efsel=bit1	;??????wrong
;efbaud=bit2;  ?????????????wrong
;orep=bit3;    ??????????????wrong
.list
jspsubs proc near		;jspsubs:
;--HEAD,TAIL,SCAN INIT Beg and End vals based on spbeg,etc.
; from spbeg,end,bytes gets Begin End and Head,Tail,Scan
; mods si=ptr spbeg,end,bytes to use
;public headtailinit
headtailinitp proc near
headtailinit:
	push	si
	mov	si,offset cseg:spbeg
	call	headtailinitsi
	pop	si
	ret
;si=ptr to spbeg,end,bytes to use
headtailinitsi:
	push	ax
	push	bx
	push	cx
	push	di
;Begin buff vals
	mov	di,offset cseg:head	;use Head Info area
	mov	bl,[si+2]		;[spbegbank];H (top 8 bits)
	mov	[begbank],bl
	call	calcbl	 		;gets ax=seg (bx not changed)
	mov	[begseg],ax		;copy to Begin Info
	mov	ax,[si]			;[spbegoff];ML (low 16 of buff addr)
	mov	[begoff],ax		;changed if end=beg bank
;End buffer vals
	mov	bl,[si+5]		;[spendbank];H (top 8 bits)
	mov	[endbank],bl
	call	calcbl			;get ax=seg (bx not changed)
	mov	[endseg],ax		;copy to End Info
;compute special offset and segment
	mov	ax,[si+3]		;[spendoff];bl still same
	inc	ax			;#bytes to end=FFFF-spendoff
	neg	ax			;  or  =0-(spendoff+1)
	mov	[endoff],ax		;mod later
	mov	cl,4
	shr	ax,cl			;/10h, make segment
	sub	[endseg],ax		;compensate seg for new offset 
;check if begin and end are in same bank,adjust offset
hti1:	mov	al,[begbank]
	cmp	al,[endbank]		;beg=endbank?
	jnz	hti2			;no
;In same bank: advance end offset to correspond to begoff
;	then set Begin Info=End Info
	mov	ax,[begoff]
	add	[endoff],ax		;set begseg:off=endseg:off
	mov	ax,[endoff]
	mov	[begoff],ax		;copy End to Begin
	mov	ax,[endseg]
	mov	[begseg],ax
;can now setup Head Info and Flush to setup Tail and Scan
; point to last byte of buffer, (first get of chr will increment)
hti2:	call	rolldend		;set head's ton,creg,seg,off
	call	copyheadtailscan	;copy head vals to tail,scan
	pop	di
	pop	cx
	pop	bx
	pop	ax
	ret
headtailinitp	endp

repeatmod proc near
;--PUT MULT BUFF (put chr in mult repeat buff)
;di=loc of buffer (imult buff, omult buff)
; ah=chr to put in buff, al not mod
putimultbuff:
	mov	di,offset cseg:imultinfo
	jmp	short putmultbuff
putomultbuff:
	mov	di,offset cseg:omultinfo
putmultbuff:
	pushf			;save state of irq
	cli			;allow no change
	push	ax		;save chr etc.
	push	bx		;index
	inc	byte ptr [di]	;[multcount]	;#chrs in buff
	xor	bh,bh
	mov	al,byte ptr[di+1] ;[multindex]	;loc in buff
	mov	bl,al		;bx=current loc
	inc	al		;next loc
	and	al,0Fh		;16chrs wrap
	mov	[di+1],al	;update [multindex]
	add	bx,di		;bx=index to chr
	mov	[bx+2],ah	;store chr in [multbuff]
	pop	bx
	pop	ax
	or	[oflag],orep	;set repeat
	popf			;recover state of irq
	ret

;--GETREPEAT--(get al=single repeated chr from buff)--
; check for single or mult repeat
; gets al=chr; sets cy if no rep chr; z,nc=last one
;public getrepeat
getrepeat:
	test	[repcount],0FFh	;rep chr empty?
	jz	grep30		;yes
	mov	al,[repchr]	;get chr
	dec	[repcount]	;count-1
	clc			;got chr
	ret			;z=last one
grep30:	test	[orepcount],0FFh ;orep empty?
	jz	gmlt99		;yes, err, no single repeat
	mov	al,[orepchr]	;get chr
	dec	[orepcount]	;count-1
	clc
	ret			;z=last one

;--GET MULT BUFF ;get chr from mult-buff
; di= ptr multbuff info
; gets al=chr
getimultbuff:
	mov	di,offset cseg:imultinfo
	jmp	short getmultbuff
getomultbuff:
	mov	di,offset cseg:omultinfo
getmultbuff:
	test	byte ptr[di],0FFh ;[multcount] ;buff empty?
	jz	gmlt99		;error,no repeat
	push	bx
	mov	al,[di+1]	;[multindex]	;buffer head
	sub	al,[di]		;[multcount]	;get al=tail
	and	al,0Fh		;wrap mod 16
	xor	bh,bh
	mov	bl,al		;bx=index
	add	bx,di		;bx=offset into buffer
	mov	al,[bx+2]	;get chr
	dec	byte ptr[di]	;[multcount]	;update count
	pop	bx
	clc			;got al=chr
	ret			;z=no more
gmlt99:	stc			;cy=no chr available
	ret			;al=unchanged
repeatmod endp

;--COMPRESS --get one or two chr for C,-C
; esc N,E,Q =10,12,17 for Citoh, 0F,12 = 10,17 Epson
; mods no regs, fills repeat buffer with 1 or 2 chrs
; di=ptr to multbuff info
; al=flag with "not" set for C or -C
;public compress
compress proc	near		;compress:
	push	ax
	mov	ax,[printer]
	cmp	al,4		;parallel?
	pop	ax
	jb	compress84	;no, do serial
	mov	ah,0Fh		;compress code
	test	al,spnot	;-C?
	jz	compress95	;not inverted
	mov	ah,12h		;non-compress
	jmp	short compress95 ;store
;serial (two codes esc + N,E,or Q)(10,12,17 cpi)
compress84:
	mov	ah,1Bh		;esc for serial
	call	putmultbuff	;put in buff (di=buff)(sets oflag=orep)
	mov	ah,"E"		;N,E,Q=10,12,17 cpi
	test	al,spnot	;-C?
	jnz	compress95	;-C uncompress
	mov	ah,"Q"		; C compress
compress95:
	call	putmultbuff	;put in rep buff,sets oflag=orep
	ret
compress endp

escfunp proc near
;--ESCFUNCTION --process Baud and Select
; ax=escflag, cl=chr, may mod cl if err
; cy=bad chr, try cl=new command
; if nc and ax=0, then legal code ended function
;public escfunction
escfunction:
	push	ax		;escflag
	cmp	cl,'='		;=?
	jnz	escf2		;no
	jmp	escf98		;yes,no reset,ignored
escf2:	test	al,spnot	;"not"? (B- or S-?)
	jnz	escf10		;yes, illegal, reset
	test	al,efsel	;select printer?
	jz	escf3		;no
	jmp	escf65		;yes
escf3:	test	al,efxchg	;new esc chr#1?
	jnz	escf30		;yes
	test	al,efdumb	;dumb mode?
	jnz	escf40		;yes
	test	al,efline	;line values?
	jz	escf3a		;no
	jmp	escf50		;yes
escf3a:	test	al,efmargin	;l margin?
	jz	escf4		;no
	jmp	escf55		;yes
escf4:	test	ah,efbaud	;baud?
	jz	escf5		;no
	jmp	escf70		;yes
escf5:	test	ah,efparity	;parity?
	jz	escf6		;no
	jmp	escf85		;yes
escf6:	test	ah,eftime	;timeslice val?
	jz	escf7		;no
	jmp	escf120		;yes
escf7:	test	ah,eftickchr	;tick chr val?
	jz	escf8		;no
	jmp	escf130		;yes
escf8:	test	ah,eftimeout	;timeout val?
	jz	escf9		;no
	jmp	escf140		;yes
escf9:	test	ah,efctsdsr	;serial port val?
	jz	escfa		;no
	jmp	escf150		;yes
escfa:	test	ah,efbusy	;busy val?
	jz	escf10		;no
	jmp	escf160		;yes
escf10:	jmp	escf97		;illeg, reset,try cl=new command

;X: XCHANGE (new escape chr #1)
; 0=default="@"
xchange0:
	push	ax
	jmp	short escf30a	;force "@"
escf30:	cmp	cl,'0'		;X0 reverts to "@"
	jnz	escf31		;ok
escf30a:mov	cl,'@'		;revert to "@"
escf31:	call	uppercl		;uppercase only
	mov	[byte ptr chr1a+1],cl ;new chr
	mov	[byte ptr chr1b+1],cl
escf32:	jmp	escf99		;done, reset flags

;D: DUMB MODE (0,1,2,3)
; D0=default=not dumb
dumb0:	push	ax
	jmp	escf41		;force dumb0
escf40:	call	calcnumcl
	jc	escf49		;not num, err exit
	cmp	al,3		;too big?
	ja	escf49		;yes, error
	test	al,bit0+bit1	;=0? (default=smart?)
	jnz	escf43		;dumb
escf41:	mov	[byte ptr dumb1b+1],20h	;control codes on
	mov	[byte ptr dumb2a+1],0E4h ;or ah,ah (esc chr)
	mov	[byte ptr dumb2d],3Ch	;cmp al,chr1 (esc chr)
	mov	[byte ptr dumb2b],74h	;jz gchr10 (repeat)
	mov	[byte ptr dumb2c],75h	;jnz gchr97 (esc chr)
	jmp	escf32		;done
;1,2,or 3, reset L=0, turn off requested functions
escf43:	mov	[byte ptr line1a],0EBh ;cancel line truncate (see L)
	test	al,bit0		;=1? (or 3?) (no control codes)
	jz	escf45		;no
	mov	[byte ptr dumb1b+1],0h	;control codes off
escf45:	test	al,bit1		;=2? (or 3?) (no esc processing)
	jz	escf32		;no, exit done
	mov	[byte ptr dumb2a+1],0C0h ;or al,al (skip esc)
	mov	[byte ptr dumb2d],0Ch	;or al,chr1 (no esc chr)
;dumb2b set after repeats are done
;	mov	[byte ptr dumb2b],0EBh	;jmp vs jz gchr10 (no repeat)
	mov	[byte ptr dumb2c],0EBh	;jmp vs jnz gchr97 (no esc chr)
	or	[oflag],orep	;force repeat
escf49:	jmp	escf65a		;kill flag, terminate escape

;L: LINE VALUES (#chrs till truncate)
; 0=default (ie. no truncate)
escf50:	call	calcnum8	;ax= number
	jnc	escf54		;number not done
	jnz	escf65a		;number too big
	mov	ah,al		;save orig val
escf50a:add	al,[lmargin]	;get total #chrs on a line poss
	jnc	escf51		;total ok
	xor	ax,ax		;force default=0
	jmp	short escf50a
escf51:	mov	[chrslim],al	;update
	or	ah,ah		;L0=no truncating?
	mov	al,0EBh		;jmp opcode
	jz	escf52		;yes
	mov	al,75		;jnz getchr99
escf52:	mov	[byte ptr line1a],al ;set line truncate on/off
escf53:	jmp	escf97		;done, try cl=new cmmd
escf54:	jmp	escf98		;no reset,not done

;M: MARGIN (#chrs in left margin)
escf55:	call	calcnum8	;al gets number
	jnc	escf54		;number not done
	jnz	escf65a		;error, too big
	mov	[lmargin],al	;update number
	jmp	short escf53	;done,reset

;PRINTER SELECT (follows S)
escf65:	call	calcnumcl	;cl=chr,get ax=#
	jc	escf65a		;not num,err exit
	cmp	al,7		;below 7?
	ja	escf65a		;no,err exit
	mov	[byte ptr printer],al ;save new val
	call	setprinter	;set up baud,etc.,sets ax
	jmp	escf99		;reset, done
escf65a:
	mov	cl,';'		;indicate err
	jmp	short escf97	;reset,try cl=command

;BAUD rate number (0=110,2=300,4=1200,7=9800)
escf70:	call	calcnumcl	;cl=chr, ax=#
	jc	escf65a		;bad num,indicate err
	cmp	al,7		;above 7?
	ja	escf65a		;bad #, err exit
	mov	[curbaud],al	;0-7 save
	jmp	escf99		;done

;PARITY (next letter = E, O, N, 2=2bits,1=1bit stop)
escf85:	mov	al,[curparity]	;current parity,stops,word len
	cmp	cl,'E'		;even?
	jnz	escf86		;no
	or	al,bit3+bit4	;yes
	jmp	short escf95	;not done exit
escf86:	cmp	cl,'O'		;odd?
	jnz	escf87		;no
	and	al,not bit4	;yes
	or	al,bit3
	jmp	short escf95	;not done
escf87:	cmp	cl,'N'		;no parity?
	jnz	escf87a		;no
	and	al,not bit3+bit4 ;yes
	jmp	short escf95	;not done
escf87a:cmp	cl,'1'		;1 stop bit?
	jnz	escf88		;no
	and	al,not bit2	;yes
	jmp	short escf95	;not done
escf88:	cmp	cl,'2'		;2 stops?
	jnz	escf89		;no
	or	al,bit2		;yes
	jmp	short escf95	;not done
escf89:	cmp	cl,'7'		;7 bits?
	jnz	escf90		;no
	or	al,bit1
	and	al,not bit0	;10=7bits
	jmp	short escf95	;not done
escf90:	cmp	cl,'8'		;8bits?
	jnz	escf97		;done, try cl=new cmmd
	or	al,bit1+bit0	;11=8 bits
escf95:	mov	[curparity],al	;update (ignore illeg vals)
	jmp	short escf98	;not done yet

escf96:	jnc	escf98		;ok, not done
;Illegal chr or New Command (cl=chr)
escf97:	pop	ax
	xor	ax,ax		;reset esc flag
	stc			;illeg chr, done,
	ret
;Legal chr,no reset, more to come
escf98:	pop	ax		;flag unchanged
	clc			;legal chr
	ret
;Legal chr (last one needed), reset, done
escf99:	pop	ax		;flag
	xor	ax,ax		;reset,set nc=ok chr
	ret

;Y: TIME-SLICE VALUE (#mini ticks 10-C0h)
;0=default of 40h
escf120:
	call	calcnum8	;get al= number
	jnc	escf98		;number not done
	jnz	escf121		;over 255, use default
	cmp	al,1		;min val?
	ja	escf122		;ok
escf121:
	mov	al,40h		;set default
escf122:
	mov	[timelim],al	;update
	jmp	short escf97	;done,try cl=new cmmd

;Z: Set #CHRS/TICK
;0=default of 0Ch
escf130:
	call	calcnum8	;get ax=#
	jnc	escf98		;number not done
	jnz	escf131		;over 255,use default
	or	al,al		;0=default?
	jnz	escf132		;no
escf131:
	mov	al,0Ch		;use default=12 chrs
escf132:
	mov	[ticklim],al	;update number
	jmp	short escf97	;done, try cl=new cmmd

;U: Set TIMEOUT value (16 bit number)
escf140:
	call	calcnum		;get ax=#
	jnc	escf98		;num not done
	or	ax,ax		;=0 (default?)
	jnz	escf141		;no
	mov	ah,18		;ax=1800
escf141:
	mov	[timeoutval],ax	;default=1800 (about 7 sec)
	jmp	short escf97	;done, try cl=new cmmd

;V: Set CTS/DSR bits (0,1,2,3,4)
escf150:
	call	calcnum8	;get ax=#
	jnc	escf152		;got number
escf151:
	jmp	escf65a		;not number
escf152:
	cmp	al,4		;too big?
	ja	escf151		;yes
	or	al,al		;=0 (default)?
	jnz	escf153		;no
	mov	al,3		;check CTS only
escf153:
	and	al,03h		;select bits 1,0 only
	shl	al,1
	shl	al,1		;move to bit 5,4 (DSR,CTS)
	shl	al,1
	shl	al,1
	mov	[byte ptr cts1+1],al ;set code for proper test
	jmp	short escf99	;done

;W: Set BUSY LIMIT (8 bit number)
escf160:
	call	calcnum8	;get ax=#
	jnc	escf98		;num not done
	jnz	escf161		;over 255,use default
	or	ax,ax		;=0 (default?)
	jnz	escf162		;no
escf161:
	mov	al,0Bh		;default=11
escf162:
	mov	[busylim],al
	jmp	short escf97	;done, try cl=new cmmd

setprinp proc near
;--SET PRINTER (uses current vals)
;Default parity=None, 8 bit word, 2 stop bits
; CITOH needs 2 stops bits at 9600baud
; SMARTMODEM needs 1 stop bit, so set ah,3 below
; mods ax
setprinter:
	push	dx
	mov	al,[curbaud]
	ror	al,1		;put in bits 7-5
	ror	al,1
	ror	al,1
	or	al,[curparity]	;parity+stop bits
	mov	dx,[printer]	;should be 0-3
	cmp	dl,3		;(serial)
	ja	escf73		;not,exit,ignore
	xor	ah,ah		;serial init =0,al=baud
	int	054h		;serial init
escf73:	pop	dx
	ret
setprinp endp

;--CHECKDELIMS CL(space, equal, or comma ok delimters)
;cl=chr, sets cy if illegal delim
;public chkdelimcl
;public chkdelimcl1
chkdelimcl proc near		;chkdelimcl:
	cmp	cl,','		;comma?
	jz	ckdl69		;yes
chkdelimcl1:
	cmp	cl,"="		;equal?
	jz	ckdl69		;yes
	cmp	cl," "		;space?
	jz	ckdl69		;yes
	stc			;cy=error
	ret
ckdl69:	ret			;nc=ok
chkdelimcl endp
escfunp endp
;..........................

checkfp proc near
;---CHECKFULL (if buffer full)---------------------
; sets z if buffer full (count=#bytes in buff)
; Note: spcount=16+8 bits, spbytes=8+16 for H,M,L bytes
;public checkfull
checkfull:
	push	ax
;	cli			;dont allow change
	mov	al,cs:[spcount8];check low 8 bits
	cmp	al,cs:[byte ptr spbytes];low 8 of spbytes
	jne	checkf1		;not full
	mov	ax,cs:[spcount24]
	sub	ax,cs:[word ptr spbytes+1] ;top 16 bits
;	jz	checkf1		;z=full (0-255 avail)
;	dec	ax		;z=full if (256-511 avail)
checkf1:
;	sti			;vars can change now
	pop	ax
	ret			;z=full, nz=not full
checkfp endp

rollmod proc near
;---ROLLDOWN  (negative roll to previous bank)----
; di=Info table ; mods ax,bx
;public rolldown
rolldown:
	;assume ds=cs, di=table
	dec	byte ptr [di]	;bank#-1
	mov	bl,[di]		;new bank#
	cmp	bl,[begbank]	;bank# < beg?
	js	rolldend	;yes,rolldown, set end
	je	rolldbeg	;set beg
;middle, set offst to FFFFh
rolldmid:
	call	rollmid		;set ton,creg,seg
	jmp	short rolld99	;set off=FFFF
;begin,setting off to FFFFh
rolldbeg:
	call	rollbeg		;set vals
	jmp	short rolld99	;set off=FFFF
;end, set offst to FFFFh
rolldend:
	call	rollend		;set vals
;set offst to FFFFh
rolld99:
	mov	bx,0FFFFh	;last byte in bank
	mov	[di+4],bx	;new offset
	ret

;---ROLLUP  (one bank finished, check wrap)------
;circular buffer, end offset and seg set to rollover
;at FFFF, so buffer must end on paragraph end.
; sets ax=segment, bx=offset
;public rollup
rollup:
	;(assume di=loc of Head-Tail-Scan, ds=cs)
	;mods bx,ax; di=same; ds must = cs
	inc	byte ptr [di]	;bank#+1
	mov	bl,[di]		;new bank#
	cmp	bl,[endbank]	;bank# ge. end?
	ja	rollbeg		;gt.,roll around
	je	rollend		;eq. set end
;middle bank, offset=0, full bank being used
rollmid:			;bl=bank#
	call	calcbl		;bank#,ton,creg,seg
	xor	bx,bx		;offset=0,ax=seg(by calcbl)
	jmp	short rollset	;set values
;set begin bank and offset
rollbeg:
	mov	bl,[begbank]	;bank#
	call	calcbl		;set bank#,ton,creg,(seg)
	mov	ax,[begseg]	;correct seg
	mov	bx,[begoff]
	jmp	short rollset	;set values
;end bank, set special offset,seg for proper rollover
rollend:
	mov	bl,[endbank]	;set end
	call	calcbl		;set bank#,ton,creg,(seg is wrong)
	mov	ax,[endseg]
	mov	bx,[endoff]
rollset:
	mov	[di+6],ax	;set segment
rolls1: mov	[di+4],bx	;set offset
	ret			;ax=seg, bx=offset
rollmod	endp

calcinfo proc near
;---CALC----(in: bank#, out:ton,creg,seg)------------
.xlist
;	di=loc of Info Table (head,tail,scan)
;		returns:es:di points to table
;banked ram requiring turn-on in the swap area
;	bcode=banktable(bank#)
;		bcode has two 4-bit parts:
;		7-4: jram BANKSELECT code C,0,8,5,4,9,D,1
;		3-0: jram BOARD SEL code 8,4,2,1 (0=RAM)
;	if BOARD SEL=0 then BANKSELECT is 0,1,2,3...9..etc
;	and applies to RAM or JRAM that is always on.
; e.g. 20 = bank 2 (128K-192K), always on
;      84 = jram bank 8, jram board #2
;	In the latter case, jram bank 8 would be made to
;	appear in an empty space, the swap space, by
;	issuing a command code ("ton") to a special
;	memory location ("creg").  In this case,
;		TON=8D    (mov E800:0,8D)
;	would turn on jram bank 8 at 8086 bank D (D000:)
;	Because E800:0 was written to, board #1 is selected.
.list
;	; di=table loc, bl=bank#, ds=cs
;	; mods es,ax=segment
;;;
;JBOOT Table of offsets sent as cs:offset (double words) by iocontrol
; to be used in final version
;accessbanktab:
;	dw	offset cseg:membanks		;( 0)
;	dw	offset cseg:accessbank		;(+2)
;	dw	offset cseg:setbankfree		;(+4)
;	dw	offset cseg:turnoffbank		;(+6)
;	dw	offset cseg:testbankinuse	;(+8)
;	dw	offset cseg:accessbankswap	;(+A)
;	dw	offset cseg:turnoffbankswap	;(+C)
;bankinuse:	db	0			;(+E)
;miscflag:	db	0			;(+F)
;	dw	offset cseg:porttab		;(+10)

;--CALCBL (bl=bank#)
; bl=bank#, di=ptr head,tail,scan Info
; sets ax=seg#, bh=0, sets [di+0,1,2,and 6],
;public calcbl
calcbl:	cli		;
	xor	bh,bh	;bx=bank#
	push	es
	push	cx
	mov	[di],bl		;bank#
	push	si
	les	si,[dword ptr tbankoff] ;es:si points banktable

	shl	bx,1		;word ptr bank#
	mov	cx,es:[bx+si]	;get bank info (like 3000 or E820)
	shr	bx,1		;recover bx
	pop	si
	cmp	ch,0E1h		;JRAM board? (E or F000?)
	jb	acbk90		;no ,cy (0-E000=reg mem)
	mov	al,cl
	and	al,86		;elim bit0,keep bit7="on"
	add	al,cl		;al=0,1,4,5,8,9,C,D
	jc	acbk40		;already turned on
	and	cl,70		;elim "on" and boardbank#
	mov	es,cx		;es=CREG (like E810)
	mov	cl,4
	shl	al,cl		;get top 4 bits=bank code
	mov	ah,[swapbank]	;like 0D
	or	al,ah		;al=TON=bank + swapbank (window)
	mov	ch,al
	shl	ch,cl		;convert to seg (D0)
	xor	cl,cl		;cx=segment (D000)
;--turn on, swap needed
	mov	[di+2],es	;CREG, like E820 (cx=SEG eg.D000)
	jmp	short acbk91	;(al=TON, cx=SEG e.g. D000)

;compute already-on segment (bx=0 - F) (CREG not used)
acbk40:	mov	cl,4
	mov	ch,bl		;convert to seg
	shl	ch,cl		;convert to seg (30)
	xor	cl,cl		;cx=segment (3000)
acbk90:	xor	al,al		;al=0=no turnon needed

acbk91:	mov	[di+6],cx	; SEG = swapsegment (e.g.3000)
	mov	[di+1],al	; TON = jram banksel:window
	mov	ax,cx		; return with ax=seg
	pop	cx
	pop	es
	ret		;ax=seg, bx=bank#
calcinfo endp

;--GET OPTION LETTERS
; di=ptr flag to modify, si=ptr options table
; cl= chr to decode, cy=not found or illegal neg,etc
;extrn gtabopt:near
getopt:
	call	chkdelimcl1	;= or space ok
	jc	gopt10		;not delim
	stc			;cy=no match
	ret
gopt10:	push	ax		;save flag
	mov	ah,[di]		;flag to modify	
	mov	al,cl		;get chr
	call	gtabopt		;search table, set bits
	mov	[di],ah		;update
	pop	ax
	ret

;--Convert to UPPER CASE --------------------------
;	chr in cl, only a-z changed
;public uppercl
uppercl	proc near	;uppercl:
	cmp	cl,7A	;chr > "z" ?
	ja	upcl99	;above z
	cmp	cl,61	;chr < "a" ?
	jb	upcl99	;below a
	and	cl,5F	;bit 5 = 0
upcl99:	ret
uppercl	endp

;UPPER (al uppercased, used by gtabopt)
;public upper
upper:	cmp	al,7A	;chr > "z" ?
	ja	upp99	;above z
	cmp	al,61	;chr < "a" ?
	jb	upp99	;below a
	and	al,5F	;bit 5 = 0
upp99:	ret

jspsubs endp
;subseg ends ;........end subroutines seg ..............

;=======INIT SEGMENT ==========================
;initseg segment para ;public 'code'
;initseg ends
;.............end init segment.......................
;end	testingentry	;sets start addr=begin (not needed)
if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif

;==========Begin SUB MODULES=================
assume cs:cseg,ds:cseg
;=============== CODE ======================
SETENDMOD proc near
;public setesbx
;public setendaddr
;public getvector
;public setvectorcs
;public xchgvector
;public xchgvectorcs
;public rhoff		;addr of req hdr ptr dword
;----ENDING (return) ADDRESS SUBS for device driver---
;--SET ES BX POINTER (called to set addr of BPB
rhoff	dw	0	;req hdr ptr set by strat entry
rhoffseg dw	0	;es:bx put here
setesbx:
	mov	cs:[rhoff],bx
	mov	cs:[rhoffseg],es
	ret

;--SET END ADDR (dx:ax=ret addr)
; es:bx ptr to req hdr obtained and updated
; dx:ax=addr to set
; sets cx:bx=req hdr ptr
setendaddr:
	push	ds
	lds	bx,[dword ptr rhoff]	;ds:bx=req hdr ptr
	mov	word ptr [bx+0Eh],ax ;endaddr
	mov	word ptr [bx+10h],dx  ;endaddrseg
	mov	cx,ds		;cx:bx=req hdr ptr
	pop	ds			;ds=cs
	ret

;----GET/SET INT VECTOR SUBS-------------------------
getvectorp proc near
;--GET VECTOR (al=vec #, gets dx:bx=addr)
getvector:
	push	es
	mov	ah,35		;get vector
	int	21		;es:bx=vec addr
	mov	dx,es		;dx:bx=vec
	pop	es
	ret
;--SET VECTOR (al=vec #, bx= offset to plug in (seg=cs)
setvectorcs:
	push	dx
	call	xchgvectorcs
	pop	dx
	ret
;--XCHGVECTORCS  (stuffs cs:bx, returns dx:bx=old vec)
xchgvectorcs:
	mov	dx,cs
;--XCHGVECTOR (al=vec #, dx:bx exchanged with vec)
; plugs in dx:bx, returns dx:bx=unplugged addr
xchgvector:
	push	es
	push	ds
	mov	ds,dx
	xchg	dx,bx		;ds:dx=new val
	mov	ah,35		;func 35, al=vect#
	int	21		;es:bx=old vec
	mov	ah,25		;set new vec=ds:dx
	int	21
	mov	dx,es		;now dx:bx=old vec
	pop	ds
	pop	es
	ret
getvectorp endp

SETENDMOD endp
;=============== CODE ======================
LOGIC24MOD proc near
;--TEST ZERO 24 bit (bl:ax=24bit number)
;public testz24
testz24	proc	near
	push ax
	or ah,bl
	or ax,ax	;bl:ax=0?
	pop ax		;recover orig val
	ret		;z set if zero
testz24 endp
;---SHIFT LEFT/RIGHT 24 bit (cl=+ or - #bits)
; bl:ax=orig number, cl=#bits, -=shift right
; bl:ax=result, cy correct on last loop only
;public shift24
;public shift24ax
shift24p proc near	;shift24p:
;--Shift left AX only, bl:ax=result
shift24ax:
	xor	bl,bl	;bl=top 8 bits
shift24:
	push	cx
	xor	ch,ch	;cx=#bits to shift
	test	cl,80h	;neg #bits to shift?
	jnz	shr24	;yes,shift right
shl24a:	shl	ax,1	;cy=bit7
	rcl	bl,1	;cy here=overflow,ignored
	loop	shl24a
	pop	cx
	ret
shr24:	neg	cl	;cl=#bits to shift
shr24a:	shr	bl,1	;cy=bit0
	rcr	ax,1
	loop	shr24a
	pop	cx
	ret
shift24p endp

LOGIC24MOD endp
;=============== CODE ======================
GTABOPTMOD proc near
;public GTABOPT
;extrn upper:near

;--TABLE APPROACH TO DELIM
;table= letter,flag code,if neg poss/invert, other codes
; (min 3 bytes each entry)
; si=ptr table
; get #bytes/entry, search letters till null,
; update flag in dh
;delimtable:	
;	db	4		;#items in each entry
;	db	'-',oneg,0,0ff
;	db	'D',delopt,0,0ff	;neg not poss
;	db	'P',oprint,81,0ff ;neg poss, P=-D
;	db	0		;end of table
;--GET TABLE OPTIONS (table version of option decode)
; al=chr, ah=flag, si=ptr table of opt letter,flags,etc.
; if neg-poss-byte gt 80 then meaning of bit code inverted,
;	i.e. if p=-w, both have oprint, but w has negposs=81
; mods si=ptr next byte of entry (typ=addr of code or FF is none.)
; sets cy=not found or illegal use of neg
oneg=1	;bit0
gtabopt:
	cld			;for lods
	push	bx
	push	cx
	call	upper		;al=upper
	mov	cx,ax		;cl=al=chr,ah=flag
	xor	bx,bx
	mov	bl,[si]		;get bx=#bytes/entry
	inc	si		;point to option letter
gtop10:	mov	al,[si]		;next option letter
	cmp	cl,al		;chr=option?
	jz	gtop20		;yes,got chr
	or	al,al		;end of list?
	jz	gtop98		;yes
	add	si,bx		;next entry
	jmp short gtop10
gtop20:	inc	si		;(+1)=bit code for this option
	lodsb			;al=[si],si+1
	test	ah,oneg		;neg?
	jz	gtop40		;no
	xor	ah,oneg		;reset neg
	test	byte ptr [si],1 ;(+2)=neg possible for this option?
	jz	gtop98		;no, error exit
	or	ah,al		;set flag
	xor	ah,al		;reset flag
	jmp short gtop95
gtop40:	or	ah,al		;set flag
gtop95:	test	byte ptr [si],80 ;(+2)=invert meaning of bit code?
	jz	gtop96		;no
	xor	ah,al		;invert flag
gtop96:	inc	si		;point next byte of entry
	clc
gtop97:	mov	al,cl		;recover chr
	pop	cx
	pop	bx		;al=chr,ah=flag
	ret			;si=ptr next byte in entry
gtop98: stc			;cy=wrong option or use of neg
	jmp short gtop97

GTABOPTMOD endp
;=============== CODE ======================
BANKTABMOD proc near
;public BANKTAB
;---END OF RESIDENT DRIVER (if JETDRIVE resident)----
;	If JETDRIVE is absent 16 bytes here will be used
;	for a local BANKS table.
;public banktab	;accessed by init module
;public drvend
if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif
drvend	equ	$;

banktab:
	;max 16 entries, one word per 64k block of RAM
	db	20 dup(0)

;---END OF RESIDENT DRIVER (if no JETDRIVE)----------

BANKTABMOD endp
;=============== CODE ======================
GETNEXTCMOD proc near
;public getnextchr
;public spcomequal
;public checkdelim
;--GETNEXTCHR get [bx+1], test for end
;0 or 0D set cy = end, "/" sets z,nc, other chrs=nc,nz
;0 or cr or "/" do not inc bx
getnextchr:
	mov	al,[bx+1]	;get chr
	cmp	al,0Dh		;cr? (end?)
	jz	gnext99		;yes
	cmp	al,";"		;semicoln=end of line
	jz	gnext99		;yes
	or	al,al		;0?  (end?)
	jz	gnext99		;yes
	cmp	al,"/"		;slash?
	jz	gnext98		;yes
	inc	bx		;point to this chr
	clc			;nc,nz
gnext98:ret			;nc, (z="/")
gnext99:push	ax		;(bx points to last valid chr)
	inc	ax		;set nz
	pop	ax
	stc			;cy,nz=end of str
	ret
;--SPACE COMMA EQUAL (nc, cr=nc,z, else=cy)
;--CHECKDELIM al=space or comma or control code are ok=nc
; z=cr,nz=space or comma or control code
; cy=invalid delim (not sp or ,)
spcomequal:
	cmp	al,"="		;equal?
	jz	chkd98		;yes (nc)
checkdelim:
	cmp	al,","		;comma?
	jz	chkd98		;ok (nc)
	cmp	al," "		;space? (or control code?)
	jbe	chkd98		;ok (nc)	
	stc			;cy=no valid delim
	ret
chkd98:	cmp	al,0Dh		;cr?
	clc
	ret			;nc=delim, z=cr
GETNEXTCMOD endp
;=============== CODE ======================
SETNZNCMOD proc near
;public SETNZNC
;--SET NZ,NC----------------------------------------
;mods flags only
setnznc:
	push	ax
	or	al,01h		;nz,nc
	pop	ax
	ret
SETNZNCMOD endp
;=============== CODE ======================
GETNUMMOD proc near
;public GETNUM
;public getnum1
;public getnum2
;extrn getnextchr:near
;extrn skipdelim:near
;extrn alphanum:near
;extrn upper:near
;extrn errormsg:near
;extrn badentrymsg:near
;extrn setnznc:near
;--GETNUM --get number (+ or - integer)----
;ax=default number,reads console, number put in ax
;cy=overflow or error or quit if al="Q"
;mods ax only
;--Local storage for getnum
number	dw	0	;temp use
negflag db	0	;bit0=1 if negative number
;GETNUM1  (decode decimal number from buffer)
; bx=ptr buffer (max byte) (buff= #max,#chrs, ascii,0d)
; decode number till first illegal chr
; returns dx:ax=number (32 bit), cl=#chrs left
; 	  bx=ptr last good chr
; z=no entry, cy=bad entry
getnum1:
	inc	bx		;point to #chrs
	jmp	getnum3	
;GETNUM2  (bx=buffer #chrs,ascii,0d), return dx:ax=number
; bx=ptr buffer (size byte)
; buffer org= #chrs, ascii chrs, 0d
getnum2:
getnum3:xor	ch,ch
	mov	cl,[bx]		;cx=#chrs
;GETNUM (cx=#chrs left, bx=first chr-1)
; as above, but bx=ptr buff first chr-1
getnum:	push	si
	push	di
	xor	si,si		;init number=0
	xor	di,di		;si:di=number
; Get Begin Number (non delim)
gnum10:	jcxz	gnum95		;no chrs
	call	skipdelim	;bx=ptr last delim
	jc	gnum95		;cy=end line (no number)
	call	getnextchr	;check if valid number begin
	call	alphanum	;z if number or "-"
	jnz	gnum95a		;not number
	cmp	al,"-"		;negative number?
	jnz	gnum21		;no, process digit
	or	[negflag],1	;yes,set flag
	jmp short gnum70	;continue scan	
; Decode into binary
gnum20:	call	getnextchr	;incs bx before get
	jbe	gnum97		;number done (cy=eol,z="/")
gnum21:	call	upper		;check for quit
	cmp	al,"Q"		;quit?
	jz	gnum89		;yes, exit
	cmp	al,","		;comma?
	jz	gnum70		;ignore
	cmp	al,"K"		;kilo?
	jz	gnum90		;yes,end number
	cmp	al,"9"		;above 9?
	ja	gnum96		;yes,end number
	cmp	al,"0"		;below 0?
	jb	gnum96		;yes,end number
; valid chr, convert to binary
	sub	al,30		;make 0-9
	xor	ah,ah		;ax=digit
	xor	dx,dx		;dx:ax=digit
	push	cx		;save count of chrs
	add	di,di		;si:di=total*2
	adc	si,si
	mov	cl,5		;loop chr+2+4+6+8+10
gnum33:	jc	gnum34		;overflow
	add	ax,di		;add 2*n each loop
	adc	dx,si		;top16
	loop	gnum33
	mov	di,ax		;32 bit total
	mov	si,dx		;new number
gnum34:	pop	cx		;ascii count
	jc	gnum81		;cy=overflow msg
gnum70:	loop	gnum20		;do next chr
	jmp	gnum97		;all done
gnum81:	mov	si,offset cseg:msgover; inform user
	call	errormsg
;illegal chrs, display message
gnum88:	mov	al,[bx]		;al=bad chr
	call	badentrymsg
gnum89:	dec	bx		;point last good chr
	xor	ax,ax
	xor	dx,dx		;dx:ax=0
	stc			;cy=bad number
	jmp	short gnum99	;exit	
;Kilo found, mult number by 1024
gnum90:	or	si,si		;msb must be 0
	jnz	gnum81		;no,too big
	mov	ax,400		;1024
	mul	di		;low16*1K
	dec	cx		;update count
	jmp short gnum97a	;set nc=ok
;no valid entry
gnum95a:dec	bx		;point last good chr
gnum95:	cmp	ax,ax		;set z=no entry
	jmp	short gnum98	;set nc also
;all chrs done, or terminated by delim (set nz,nc)
gnum96:	dec	bx		;point last good chr
gnum97:	mov	ax,di		;final value
	mov	dx,si		;bx:ax=32bit number
gnum97a:
	test	[negflag],1	;negative?
	jz	gnum97b		;no
	neg	ax		;yes
	sbb	dx,0		;32bit neg
gnum97b:
	call	setnznc		;set nz,nc=ok number
gnum98:	clc			;nc=ok number
gnum99:	pushf
	and	[negflag],0FEh	;reset neg
	popf
	pop	di		;dx=ptr delim
	pop	si		;cx=#chrs left
	ret			;bx:ax=number,cy=error
msgover:
	db	"Number too large:",24

GETNUMMOD endp
;=============== CODE ======================
BINASCMOD proc near
;public BINASC
;public babytes
;public binascax
;public ba8digit
;public ba512
;public binasc
;public msgbytes
;extrn tvprompt:near
;extrn tvbyte:near
;--BINARY to ASCII printout routine
;BABYTES (binary to ascii convert with "bytes" added)
babytes:
	call	ba8digit	;convert and show
	push	si
	mov	si,offset cseg:msgbytes
	call	tvprompt
	pop	si
	ret
msgbytes	db	" bytes.",24
;BINASC AX (ax=number, 6 digits max)
binascax:
	push	cx
	push	dx
	xor	dx,dx
	mov	cx,106h		;6 digits max
	call	binasc
	pop	dx
	pop	cx
	ret
;BA512 (dx=number, multiplied times 512)
; mods ax
ba512:	mov	ax,512d
	mul	dx
;BA8DIGIT (dx:ax=number, cx set for 1 zero,8 digits)
;mods no other regs
ba8digit:
	push	cx
	mov	cx,108h
	call	binasc
	pop	cx
	ret
;BINASC (dx:ax=number, ch=#leading zeros,cl=#digits max)
;mods cx
binasc:	push	ax
	push	dx		;save number
	push	di
	push	bp
	xchg	ax,bp		;bp=low16 of number
	mov	al,cl		;#digits max (#tens)
	cbw
	add	ax,ax		;get index to max tens
	add	ax,ax
	add	ax,offset cseg:tens-4
	xchg	ax,di
	xor	ah,ah		;flag for leading zero
ba10:	xor	al,al
ba15:	cmp	dx,cs:[di+2]	;dx=hi16 of number
	jb	ba30
	ja	ba20
	cmp	bp,cs:[di]	;bp=lo16 of number
	jb	ba30
ba20:	sub	bp,cs:[di]
	sbb	dx,cs:[di+2]
	inc	ax		;# subtractions (dividend)
	or	ah,al		;non-zero found
	jmp short ba15
ba30:	cmp	ch,cl		;show zeros in last ch digits
	jb	ba40
	or	ah,cl		;flag=show zeros
ba40:	or	al,'0'
	or	ah,ah		;z=leading zero?
	jne	ba50		;no
	mov	al,' '		;yes, print space
	;following line optional,gives no leading spaces
	jmp short ba51		;if no leading spaces
ba50:	call	tvbyte		;tv out
ba51:	sub	di,4		;next table entry
	dec	cl		;#tens left to do-1
	jnz	ba10
	pop	bp
	pop	di
	pop	dx
	pop	ax		;dx:ax=number
	ret
tens:	dw	1,0,0A,0,64,0,3E8,0,2710,0
	dw	86a0h,1		;100,000
	dw	4240h,0fh	;1,000,000
	dw	9680h,98h	;10,000,000
	dw	0e100h,5f5h	;100,000,000
	dw	0ffffh,7fffh	;max, too big
	dw	0ffffh,7fffh
	dw	0ffffh,7fffh
	dw	0ffffh,7fffh
BINASCMOD endp
;=============== CODE ======================
UPLOWMOD proc near
;public UPLOW
;extrn upper:near
;bit5=20h
;--UPLOW convert al into upper (ah),and lower (al) case
uplow	proc	near		;uplow:
	mov	ah,al
	call	upper		;convert if lower
	xchg	ah,al		;get ah=upper
	cmp	ah,al		;eq if orig=upper or other
	jne	uplo99		;ne, orig was lower case
	cmp	al,5a		;> Z?
	ja	uplo99		;yes,not up or low
	cmp	al,41		;< A?
	jb	uplo99		;yes,not up or low
	or	al,bit5		;make al low case
uplo99:	ret			;ah=upper,al=lower
uplow	endp
UPLOWMOD endp
;=============== CODE ======================
DELIMSMOD proc near
;public guptilldelim
;public skipdelim
;extrn getnextchr:near
;extrn checkdelim:near
;extrn upper:near
;--GET UPPER UNTIL DELIM (get next chr till delim or end line)
; gets al=[bx+1],bx=bx+1,al uppercase
; cy=delim found, bx=bx (delim=cr,0,/,space,comma)
guptilldelim:
	call	getnextchr
	jbe	gupt98		;cr,eol,"/"
	call	checkdelim	;space,comma,cntrl?
	jnc	gupt95		;yes, delimiter
	call	upper
	clc			;nc=not end
	ret
gupt95:	dec	bx		;point prev chr
gupt98:	stc			;cy=end
	ret

;--SKIPDELIM (skip space or delims till chr or end line)
; cy=eol reached, nc=non delim
; cx=#chrs left,bx=index into string (last chr used)
; returns cx=#left, bx=ptr last delim
;  cy=cr,0,or "/" stopped search
skipdelim:
	jcxz	skipd95		;no chrs left,eol
skipd5:	call	getnextchr	;incs bx before get,unless end
	jbe	skipd95		;end of search(cy=eol,z='/')
	call	checkdelim	;space or comma or ctrl?
	jc	skipd99		;got non delim
	loop	skipd5		;till done
skipd95:stc			;cy=end line
	ret
;non-delim found
skipd99:;check for alpha num here, set z=alpha-num
	clc
	dec	bx		;point to last delim
	ret			;nc=non-delim found

DELIMSMOD endp
;=============== CODE ======================
ALPHANUMMOD proc near
;public alphanum
;extrn upper:near
;--ALPHANUM (check if alpha num)
; al=chr, nc,z=number, nc,nz=alpha, cy=other
alphanum:
	push	ax
	call	upper
	cmp	al,5a		;gt Z?
	ja	alph80		;yes,err
	cmp	al,30		;lt 0?
	jb	alph80		;yes,err
	cmp	al,39		;le 9?
	jbe	alph96		;yes,a number
	cmp	al,41		;ae A?
	jae	alph97		;yes, a letter
;check legal "alpha-num equivs" here
	cmp	al,"-"		;neg sign?
	je	alph96		;yes
alph80:	stc
	jmp	short alph99	;pop and ret
;set z=number (nc also)
alph96:	cmp	al,al		;set z
	jmp	short alph98	;ret
;set nz=alpha (nc also)
alph97:	or	al,al		;set nz
alph98:	clc
alph99:	pop	ax
	ret

ALPHANUMMOD endp
;=============== CODE ======================
TVTILLCRMOD proc near
;public TVTILLCR
;extrn tvbyte:near
;;extrn tvbytechkend:near
;--TV TILL CR (si=ptr message, stops at cr)
;mods no regs, does not output cr
tvtillcr:
	cld
	push	ax
	push	si
tvtc10:	lodsb		;al=[si],si+1 get chr
	cmp	al,0dh		;cr?
	jz	tvtc20		;yes,exit
	call	tvbyte		;tv
;	call	tvbytechkend	;cy=0,cr, z=ill null or "$"
;	jnbe	tvtc10		;0,$,etc
;	jc	tvtc10		;cy=0,$
;	jnz	tvtc10		;z=cr (terminator)
	jmp short tvtc10	;till done
tvtc20:	pop	si
	pop	ax
	ret

TVTILLCRMOD endp
;=============== CODE ======================
STRINGSMOD proc near
;public sizestring
;public sizeandfindstring
;public fastfindstringu
;extrn getnextchr:near
;extrn uplow:near

;--SIZE and FIND STRING (size str, then search buf)
; approx 1.4 sec/64k search (more if upperlower)
; si=ptr string, es:di=ptr buffer to search
; ax=#bytes in buffer,cx=#bytes in str
; sets cx=#bytes in str, bx=ptr to string found
;	cy=not found
sizeandfindstring:
	call	sizestring	;si=ptr string
	stc
	jcxz	sfind99		;cy=no chrs
	call	fastfindstringu	;cx=#bytes in str
sfind99:
	ret			;cy=not found

;--SIZESTRING (gets size of string up to delim)
;	ds:si=ptr string
; sets cx=#bytes in str
sizestring:
	push	ax		;mod by routines below
	push	bx
	xor	cx,cx		;cx=#bytes in str
	mov	bx,si		;si=ptr str begin
	dec	bx
sstr10:	call	getnextchr
	jc	sstr90		;cy=cr or 0
	jnz	sstr12		;z=/ found
	inc	bx		;move past /
sstr12:	inc	cx
	stc
	jz	sstr99		;cy=str too big
	jmp short sstr10	;loop till delim found
sstr90:	clc
sstr99:	pop	bx		;cx=#chrs in str
	pop	ax
	ret

;--FAST UPLO STRING SEARCH (first get chr#1, then rest)
; non uplo times were (.92 sec/64k)(49 bytes)
; ds:si=str ptr, es:di=buff ptr, ax=size of buff,cx=size of str
;returns bx=loc of str in buff
; cy=not found, mods ax
fastfindstringup proc near
fastfindstringu:
	cld
	push	cx
	push	dx		;ax=buf size, cx=str size
	push	bp
	push	di
	dec	cx		;cx=#bytes-1 in str
	xchg	dx,cx		;get dx=#bytes in str
	xchg	cx,ax		;get cx=#bytes in buff
	mov	bp,si		;bp=si=str ptr
ffsu5:	dec	di		;adj for below
	mov	al,[si]		;get first chr
	call	uplow		;ah=upper, al=lower case
ffsu10:	inc	di
	mov	bl,es:[di]	;get buff chr
	cmp	al,bl		;str=buff?
	jz	ffsu15		;yes
	cmp	ah,bl		;lc str=buff?
	jz	ffsu15		;yes
ffsu12:	loop	ffsu10		;till buff done
	stc			;cy=not found
	jmp	short ffsu99	;done
; es:di=buffer, ds:si=string,cx=#bytes left in buff to search
ffsu15:	push	ax		;save uplow chr
	push	cx		;save #bytes left in buff
	mov	cx,dx		;bx=#bytes in str	
	mov	bx,di		;current loc in buff
ffsu17:	inc	si		;next in str
	inc	di		;next in buff
	mov	al,[si]		;next str chr
	call	uplow		;ah=upper,al=lower
	cmp	al,es:[di]		;same?(lower)
	jz	ffsu22		;yes
	cmp	ah,es:[di]		;same? (upper)
	jnz	ffsu25		;no
ffsu22:	loop	ffsu17		;till str done
ffsu25:	mov	si,bp		;str beg
	mov	di,bx		;last buff begin
	pop	cx		;string found, exit
	pop	ax		;nc set by compare
	jnz	ffsu12		;loop till found
ffsu99:	pop	di		;si,di same
	pop	bp		;bx=ptr str in buff
	pop	dx		;ax=#left in buff
	pop	cx		;cx=#bytes in str
	ret			;cy=not found
fastfindstringup endp

STRINGSMOD endp
;=============== CODE ======================
TVPRIMMOD proc near
;public crlftv		;crlf,msg,crlf
;public tv		;msg,crlf
;public crlf		;mods no regs
;public tvprompt		;msg (no crlf)
;public crlftvprompt	;crlf,msg
;public errortv		;beep, crlf,"error"
;public errormsg		; "  with msg
;--CRLFTV (crlf,msg,crlf)
crlftv:	call	crlf
;--TV (with  crlf)--
tv:	call	tvprompt	;si=message
;--CR Carriage return and lf--
crlf:	push	si
	mov	si,offset cseg:msgcrlf
	call	tvprompt
	pop	si
	ret
msgcrlf:
	db	0dh,0ah,24
;--CRLFTVPROMPT (crlf,message, no crlf)
crlftvprompt:
	call	crlf
;--TVPROMPT (no crlf, msg,no crlf)
;(tv out till null or "$")
; si=ptr message
;public tvprompt
tvprompt:
	cld
	push	ax
tvpr22:	lodsb		;al=(si),si+1
	call	tvbytechkend	;cy=0 or $
	jnc	tvpr22		;till done
tvpr99:	pop	ax
	ret

;--TV BYTE CHECK END (sends chr, tests for 0,$)
; al=chr, cy=0 or $, nc,z=cr, nc,nz=other
;public tvbytechkend
tvbytechkend:
	or	al,al		;null? (end?)
	jz	tvbt20		;yes
	cmp	al,"$"		;$?
	jz	tvbt20		;yes
	call	tvbyte		;send chr
	cmp	al,0Dh		;cr?
	clc
	ret			;nc, z=cr, nz=other
tvbt20: stc
	ret			;cy=0 or $ (end message)

;--ERROR message to TV (crlf,"ERROR",no crlf)
errortv:
	push	si
	mov	si,offset cseg:msgerror
	call	crlftvprompt
	pop	si
	ret
msgerror: db	07,"*ERROR*  ",24
;--ERRORMSG (si=message to follow "ERROR")
errormsg:
	call	errortv		;"error"
	jmp short tvprompt	; actual message

;--BADENTRY Message (al=bad chr)
;public badentrymsg
badentrymsg:
	call	errortv		;"Error"
	call	tvbyte		;show bad chr
	push	si
	mov	si,offset cseg:msgbadentry
	call	tvprompt
	pop	si
	ret
msgbadentry:
	db	" = bad entry",24

;--UPPER converts al into uppercase
;public upper
upper2	proc	near		;upper:
	cmp	al,7a		;chr > z?
	ja	upp299		;yes
	cmp	al,61		;chr < a?
	jb	upp299		;yes
	and	al,5Fh		;bit 5=0
upp299:	ret
upper2	endp

;--KEYBOARD INPUT (waits,gets al=chr,echos to tv)
;public inbyt
inbyt:	push	dx
	mov	ah,8		;inkeyx	;read keyboard
	int	21h
	jmp short tvb30
;--BEEP
;public beep
beep:	mov	al,07h		;bell
	jmp short tvbyte
;--BLANK
;public blank
blank:	mov	al,' '
;--TVBYTE (tvout)
; al=chr,   no mod all other regs
;public tvbyte
tvbyte:	push	dx
tvb30:	push	ax
	mov	dl,al
	mov	ah,2		;otcon
	int	21h		;tty output
	pop	ax
	pop	dx
	ret
TVPRIMMOD endp
;@#$t0 c m10 l0;marg=10,compress
;jsp1 (see part1=jspool (main) )
;title	Tall Tree Systems JSPOOLINIT
;page	60,128

;****************************************
;*           JSPOOLINIT 2.08		*
;*  Copyright(c)1983 Tall Tree Systems  *
;****************************************

; written by Hugh Macdonald
; August 20, 84

.radix 16
;--Externally defined references---
;public	init
;cseg group initseg,buffseg
;initseg segment para ;public 'code'
jspoolinit	proc far
assume cs:cseg,ds:cseg
;start=$
.xlist
;--------Transient Install Code follows------------------
;   DOS calls dstrat with a Req Header (incl a command code)
;	then calls dintr with no params.  However ES:BX still
;	points to the Req Header, so this is a waste of time.
;
;------INITIALIZE---called once when installed, then disposed of --
;  (pg 14-17 DOS) driver placed in order of CONFIG.SYS file

;==Transient DATA area========================================

bit0=1
bit1=2
bit2=4
bit3=8
bit4=10
bit5=20
bit6=40
bit7=80
.list
oneg=bit0
delopt=bit5
spoolopt=bit6
immedopt=bit4
spkill = bit4
opause = bit4
printerbase =	400h	;loc of printer ports 0-3,4-7
dossize	=	413h	;size of DOS in Kbytes

if	($-start) mod 10h
org	($-start)+10h-(($-start) mod 10h)
endif
dosfree16 dw	8000h	;low 16 of #bytes free in DOS
dosfreemsb db	0	;top 8 (default=32K=8000)
idrvend	dw	offset cseg:drvend ; (to set end addr)
idrvendseg dw 	0	;set by init=cs typ
buffptr	dw	offset cseg:buffer ;config.sys put here
buffcnt dw	0	;cx,bx used for scan
;Location of subroutine call table in JBOOT ??? new
accessbanktab	dd	000000	;ptr to jboot table

;--Transient MSG area ----
msgjbootname	db	'$JBOOT',0	;???? new
;msgjetdrive	db	'JETDRIVE',0 ;8 byte name of driver with banktable
msgjspoolbin	db	'JSPOOL  ',0 ;name to display at init
msgterminate	db	'No space for spooler',24
msgabsbuff	db	"Buff overwrites DOS",24
msgbadsizeloc	db	"Bad buffer size or location.",24
msgautosize	db	'AUTOSIZING: (25% of free) ',24
msgbuffsize	db	". Buffer size=",24

;==Transient CODE area=========================================
;public init
if ($-start) mod 10h
org ($-start)+10h-(($-start)mod 10h)
endif				;align on para
init:
;--Get Command Line, move to local buffer
	lds	si,cs:[dword ptr rhoff] ;es:bx in rhseg,rhoff
	mov	di,[si+12]
	mov	ds,[si+14]
	xchg	si,di		;ds:si=ptr to command str (source)
	push	cs
	pop	es		;es:di=local buff (dest)
	mov	di,offset cseg:buffer
	mov	cx,100		;256 bytes max
	rep	movsb
;--Setup Environment and Print Installing message
	push	cs		;ds=cs
	pop	ds
	mov	si,offset cseg:msgjspoolbin
	call	tvprompt
	mov	si,offset cseg:verno	;ver#
	call	tvprompt
	mov	si,offset cseg:serno	;ser#
	call	tvprompt
	call	blank			;1 space
	mov	si,offset cseg:serno+7	;Copyright
	call	tvprompt
	call	crlf
;--Get # 64K blocks used by DOS ---
;--default if no JBOOT found later with correct edbegin ????
getmax:				;get last RAM bank 0-29h
	xor	ax,ax		;set es=0
	mov	es,ax
	mov	ax,es:[dossize]	;413h=size in Kbytes
	mov	[dosk],ax	;save
	mov	cl,6		;convert to 64Kb blocks
	dec	ax		;round up to nearest blk#
	shr	ax,cl		;0=0-64K, 1=64-128K, etc.
	mov	[dosbank],al	;last bank# (0-41,0-29h)
;;--is dosbank ever used????
	inc	al
	mov	[edbegin],al	;first bank of elec disk

;--OPTIONS: Scan past name to get spool size and options   (ds=cs)
options:
	mov	si,offset cseg:buffer ;ptr command str
	cld
opts5:	lodsb			;al=[si],si+1
	cmp	al,20		;0,20, or 0Dh? (end of name?)
	ja	opts5		;no
	je	opts6		;space
	or	al,al		;0? (end of name?)
	je	opts6		;yes
	dec	si		;must be cr, point to it

opts6:	call	tvtillcr	;print options list (si not mod)
	call	sizestring	;set cx=size of str (si not mod)
	mov	bx,si		;bx=end of name+1=begin opts
	dec	bx		;getnum incs bx
	call	getnum		;bx=ptr chrs,cx=#left in line
	jb	opts22		;cy=bad entry
	jz	opts24		;z=no number
	or	dh,dh		;24 bits max?
	jz	opts23		;size ok
opts22:	mov	dl,0FFh		;force autosizing
opts23:	mov	[spbytes16],ax
	mov	[spbytesmsb],dl	;save #bytes in spool buff
;--Get second number (optional) (#bytes free in DOS)
opts24:	call	getnum		;sets z=no number,use default
	jbe	opts28		;   cy=bad entry, use default
	or	dh,dh		;over 24 bits max?
	jnz	opts28		;yes,too big,use default
	mov	[dosfree16],ax
	mov	[dosfreemsb],dl	;save #bytes free for dos
;--get 	OPTIONS (everyting after / is fed to spooler)
opts28:
;	call	getopt		;cx=#chrs left,bx=ptr
	mov	[buffptr],bx	;save for later
	mov	[buffcnt],cx	;count=#left

;--FIND Jetdrive (if present) to get banktable addr
;;;;

;contents of JBOOT BANKSINFO and MEMBANKS  (256+ words -- 16 Mb)
;banksinfo:		;(loc = membanks - 10h)
;rambanks dw	0000	;0 hi=#banks tot, lo=#contig banks
;jrambanks dw	0000	;2 #banks of JRAM avail
;userk	dw	0000	;4 #k reserved for user (default 0k)
;maxregmem db	0Dh	;6 limit of reg mem (9=640k)
;maxtonmem db	00	;7 last bank turned-on mem (0=autosize)
;swapbank db	0Dh	;8 JRAM swap area (0D typ)
;dosbank db	00	;9 last bank of dos
;jdriveptr dw	offset cseg:jdr1bank ; A loc of ram disks
;freebank dw	0000	;C first unused bank
;nbanks	dw	0000	;E #banks
;membanks:		;10+

;--Locate JBOOT and plug in call to accessbank (ds=cs)
	push	cs
	pop	ds		;ds:dx will be set
	mov	dx,offset msgjbootname ;open JBOOT for iocontrol
	mov 	ax,3D02h	;open (read/write)
	int	21h
	jnc	ini6		;found
	jmp	ini34		;no JBOOT found, use internal table
ini6:	mov	bx,ax		;bx="handle"
	mov	cx,0		;0=get address of JBOOT table
	mov	dx,offset accessbanktab ;put data here
	mov	ax,4402h	;iocontrol "in"
	int	21h		;get info
	pushf			;cy=error
	mov	ah,3Eh		;close bx=handle
	int	21h
	popf
	jc	ini34		;error

;check if space avail for RAM Disk (ds=cs)

	push	cs
	pop	es		;es=cs
	lds	si,[accessbanktab] ;ds:si=table inside JBOOT
	lodsw			;get membanks addr
	mov	si,ax		;ptr membanks
	sub	si,30h		;point to banksinfo
	mov	di,[si+0Ah]	;ptr jdr1bank#
	mov	bp,[si+0Ch]	;freebank (first poss jdr begin)
	mov	dx,[si+0Eh]	;#banks total (end of mem)
	mov	al,[si+08h]	;get swap page
	mov	cx,ds		;cx=seg of jboot
	cmp	cs:[swapbank],0	;auto set swap?
	jnz	ini33		;no, leave as user specd
	mov	cs:[swapbank],al ;auto set (DANGER same as jdrive)
ini33:	mov	ax,[di]		;bank# from jboot list
	push	cs
	pop	ds		;ds=cs (cx=jboot ds)
	inc	ax		;FFFF = end of list?
	jnz	ini35		;not end
ini33a:	mov	ax,bp		;use freebank instead
	cmp	ax,dx		;any banks free?
	jb	ini37		;yes
;no ram disk free or possible
ini34:	jmp	findj98		;make own banktables
ini35:	dec	ax		;recover orig bank#
	cmp	ah,2h		;FFF? = not assigned yet?
	ja	ini33a		;yes, use freebank
;--RAM Disk found or space available found
ini37:	mov	[edbegin],al	;first bank of elec disk
	mov	[tbankseg],cx	;seg
	add	si,30		;addr of banktable
	mov	[tbankoff],si	;ds:si=loc banktable
	inc	[firsttime]	;1=jdrive,(0=no jdr)
	mov	[maxbank],dl	;last bank# NOTE???LImit at 255 banks?????
	jmp	findj99		;got a ram disk
;;;;;;

;--MAKE BANKTABLE (if no Jetdrive or buff inside DOS)
;makebanks proc	near		;makebanks:
findj98:
	push	cs
	pop	ds		;ds=cs
	mov	al,[dosbank]	;last dos bank
	mov	[maxbank],al	;last bank# (0-29h)
;fill table with 0's
makeb0:	std			;reverse storing
	push	cs
	pop	es		;es=cs
	mov	di,offset cseg:banktab+1E ;end of banktable
	mov	cx,10		;max 16 entries RAM 640Kb
	xor	ax,ax
	rep	stosw		;fill es:di with 0's
	inc	di		;point to banktab
	inc	di
;put 0-29h entries, codes 0,10,20,etc.
makeb2:	cld	;forward storing, di=offset banktable already
	mov	[tbankoff],di
	mov	[tbankseg],cs	;new banktable loc
	mov	cl,[maxbank]	;ch=0, al=0  already
	inc	cx		;#of entries
makeb3:	stosw			;es:di=al
	add	ah,10		;ax=0,1000,2000,3000,4000,etc
	loop	makeb3
makeb99:
	mov	[idrvend],offset cseg:drvend+20 ;+16 words for bank tab
;get swapbank and calc corresponding segment
findj99:
	mov	[idrvendseg],cs	;driver end seg

;setup swap bank (MOD this according to JBOOT swap)
	mov	ah,[swapbank]	;use predefined or autoset value
	mov	cl,4
	shl	ah,cl		;*10h (cl=4 already)
	xor	al,al		; ax=segment
	mov	[swapseg],ax	;typ=A000 or D000h
;.......(end findjet)......................................


;--CHECK PARAMS ---(check limits of spoolbuffer)---------
;  user enters 24 bit begin and end of buffer at (43h+).
;  checks for illegal entries.
checkp:
	mov	bl,[spbegbank]  ;bl:ax=24bit value
	mov	ax,[spbegoff]
	call	testz24		;zero entry?
	jz	insidedos	;yes, put inside DOS
	mov	bl,[spendbank]
	mov	ax,[spendoff]	;bl:ax=24bits
	call	testz24		;zero entry?
	jz	insidedos	;yes, put inside DOS
	jmp	checkp50	;put at abs addr specd

;--INSIDE DOS, put spool buffer inside DOS
insidedos:
	or	[firsttime],80h	;80=inside DOS
	mov	ax,cs		;conv driver end seg to offset
	inc	ax		;+16 bytes for banktable
	mov	cl,4		;left shift
	call	shift24ax	;get bl:ax=offset
	add	ax,offset cseg:drvend ;put at end of driver+16
	adc	bl,0
	mov	[spbegoff],ax	;store begin buff
	mov	[spbegbank],bl
	mov	bh,bl
	xchg	dx,ax		;bh:dx=24bits begin
;get #bytes free in DOS, make buff fit
	mov	ax,[dosk]	;#K to end of DOS
	mov	cl,0Ah		;mult *1024
	call	shift24ax	;bl:ax=#bytes in DOS
	sub	ax,dx		;
	sbb	bl,bh		;#bytes avail for buffer+DOS
	sub	ax,[dosfree16]	;sub min #needed for DOS
	sbb	bl,[dosfreemsb] ;bl:ax=#bytes avail for buffer
	jc	term2		;nothing left
	mov	ch,bl
	mov	di,ax		;ch:di=#bytes avail (buff max)
	or	bl,bl		;over 64k free?
	jnz	idos10		;yes
	cmp	ax,0100		;req min 256 bytes
	jae	idos10		;ok
term2:	jmp	terminate	;no space, exit
;get size wanted, if 0 force resizing to 25% of free space
idos10:	mov	ax,[spbytes16]	;size requested
	mov	bl,[spbytesmsb]	;top 8 bits
; bl:ax=#bytes wanted, ch:di=#bytes avail, bh:dx=begin buff
; compute end, substitute default if necess
idos12:	sub	di,ax		;ch:di - bl:ax
	sbb	ch,bl		;ch:di=#bytes unused
	jc	resize		;buff wont fit
	call	testz24		;zero entry?
	jz	resiz0		;yes, autosize
	jmp short idos35	;buff size ok
;--RESIZE buff to 25% of free space avail,including dos free
;	bl:ax=#bytes wanted, ch:di=-#b unused
resize:	mov	si,offset cseg:msgbadsizeloc
	call	errormsg
resiz0:	mov	si,offset cseg:msgautosize
	call	crlftvprompt
	add	di,ax		;bl:ax + ch:di
	adc	ch,bl		;ch:di=#bytes avail for buff
	mov	ax,[dosfree16]	;include dosfree if poss
	mov	bl,[dosfreemsb]
	add	ax,di
	adc	bl,ch		;bl:ax=unused+dosfree	
;including dosfree allows some unused space to be used by dos
; spooler keeps lesser of 25% or max avail for buff
	mov	cl,-2
	call	shift24		;bl:ax=25% of free space
	push	ax		; must be less than #bytes avail
	push	bx
	sub	ax,di		;cmp 25% - max avail
	sbb	bl,ch
	pop	bx
	pop	ax
	jc	idos33		; 25% lt max avail
	xchg	ax,di		;bl:ax=ch:di=max avail
	mov	bl,ch
idos33:	mov	[spbytes16],ax	;new size
	mov	[spbytesmsb],bl
	jmp	insidedos	;try again, cant fail
;compute end of buffer given #bytes(bl:ax) and begin (bh:dx)
idos35:	add	ax,dx		;compute 24bit end+1
	adc	bl,bh		;+1 for good measure
	mov	[spendoff],ax	;update
	mov	[spendbank],bl	;bl:ax=end val
;convert 24bit end val to seg:offset for drvend val
; (bl:ax=end val)
	mov	[idrvend],ax	;new end of driver
	xchg	ax,bx		;get al=msb (#64k banks)
	mov	cl,0Ch		;convert to seg, 12bit shift
	call	shift24ax	;bl:ax=result,ignore bl
	mov	[idrvendseg],ax	;new segment
;--CHECK PARAMS, order, and limits
; spbeg,end and #bytes must be set
checkp50:
	mov	bl,[spendbank]	;trunc End to end of para (hex F)
	mov	ax,[spendoff]	;bl:ax=24bit End
	add	ax,01		;bl:ax+1
	adc	bl,00
	and	ax,0fff0h	;paragraph bound
	sub	ax,01		;bl:ax-1
	sbb	bl,00		;cy=underflow
	jc	resize1		;too small to get end of paragraph
	mov	[spendbank],bl
	mov	[spendoff],ax	;now at end of paragraph
;subtract end-beg = #bytes in buffer
; bl:ax=correct End val,ends in hex F.
; subtract bl:ax-bh:dx, End-Beg=#bytes-1
	mov	bh,[spbegbank]
	mov	dx,[spbegoff]	; bh:dx=24bit Beg val	
	sub	ax,dx
	sbb	bl,bh		;cy=neg # of bytes
	mov	[spbytesmsb],bl ;msb of #bytes-1
	mov	[spbytes16],ax	;#bytes-1
	jc	resize1		;neg # bytes, resize
	jnz	checkp55	;gt 64k buff=ok
	cmp	ax,1		;min=2 bytes
	jb	resize1		;too few bytes
;--Show size of buffer (bl:ax=#bytes-1)
checkp55:
	add	ax,1		;make #bytes
	adc	bl,0
	mov	si,offset cseg:msgbuffsize
	call	tvprompt
	push	dx
	xor	dx,dx
	mov	dl,bl		;dx:ax=#bytes in buff
	call	babytes		;tv output
	call	crlf
	pop	dx
;--Check Limits: dont clog or clobber DOS
; bh:dx= spbeg
	mov	al,[firsttime]	;=FF if buff is inside DOS
	test	al,80		;inside?
	jnz	checkp60	;yes, buff inside
; absolute addr buff, check if above DOS's end
	cmp	bh,[dosbank]	;Begin > Dos?
	ja	checkp60	;yes,ok
	mov	si,offset cseg:msgabsbuff
	call	errormsg
resize1:
	mov	[spbytesmsb],0FFh ; #bytes=too big
	jmp	insidedos	;force autosize,inside dos
terminate1:
	jmp	terminate
checkp60:
	mov	bl,[spendbank]
	cmp	bl,[maxbank]	;End > max mem?
	ja	resize1		;yes,outside mem,resize

;--SET MISC VALUES ------------------------------
setmisc:
;--SET ENDING ADDR (next valid addr after end)-----
	mov	ax,[idrvend]	;end of resident part
	mov	dx,[idrvendseg]	;segment of driver end
	call	setendaddr
;--Init Head,Tail,Scan,  Beg and End vals based on spbeg,etc.
	call	headtailinit	;setup head,tail,scan
	call	savestate	;init inside table
				; spbeg,end,bytes  head,tail saved
;--set default printer
defprinter:
	mov	cx,4		;printer#4(parallel)
	mov	ax,0		;ah=iflag,al=oflag
	mov	[printer],cx	;set printer#
; do baud and other table entries here
	mov	[iflag],ah	;set kill value
	mov	[oflag],al	;opause	;set output pause too

;--Plug into INTERRUPT CHAINS -----------------
;--vec 14 rs232 (get loc vec 14 and make vec 54)
;(ds=cs)
	mov	al,14		;get vec 14
	call	getvector
	mov	[word ptr jmp14+1],bx
	mov	[word ptr jmp14+3],dx
	mov	al,54		;set vec 54=14
	call	xchgvector	;v54 (at 150h)
;--Redirect int 17 to spooler int handler
	mov	bx,offset cseg:new17
	mov	al,17		;vector 17
	call	xchgvectorcs	;gets dx:bx=old vector
	mov	[word ptr jmp17+1],bx
	mov	[word ptr jmp17+3],dx
	mov	al,55
	call	xchgvector	;put in vec 55 also
;--TIMER chain (18.2/sec) (Vec 08 (or 1C)) 
;the following lines are reversed if new08 not used
	mov	bx,offset cseg:new08 ;quick-release time clock
	mov	bx,offset cseg:time10 ;cs:bx=new timer vector
	mov	al,08		;timer int
	cli			;allow no ints during change
	call	xchgvectorcs	;gets dx:bx=old vec
;change the following line to stuff 'EA' instead of 'C3'
;if quick-release of irq 8259 chip not wanted.
	mov	al,0C3h		;short return (quick-release)
	mov	al,0EAh		;long call (works with PRINT)
	mov	[byte ptr jmp1C],al
	mov	[word ptr jmp1C+1],bx
	mov	[word ptr jmp1C+3],dx ;fill timeloop jump
	sti			;int ok now
;--USER INIT user supplied initializion (str in dev= line)
; note: begins to write over subroutines (buffer now there)
;	do not use subroutines from now on.
userinit:
	mov	dx,0		;printer port #
	mov	bx,[buffptr]	;last pointer for buff
	mov	cx,[buffcnt]	;#left
	xor	ch,ch		;force less than 256 chrs
	cmp	cx,2		;ignore too few chrs
	jb	uopt99		;too few  ???
uopt10:	inc	bx
	mov	al,[bx]
	cmp	al,0Dh		;cr? (end?)
	jz	uopt90		;yes
	cmp	al,";"		;semicoln=end line
	jz	uopt90		;yes
	or	al,al		;0?  (end?)
	jz	uopt90		;yes
	cmp	al,"/"		;slash? (ignored)
	jz	uopt60		;yes
	mov	ah,0
	int	17		;print chr
uopt60:	loop	uopt10		;next chr
uopt90:	mov	ax,000Dh	;terminate line
	int	17
uopt99:
;--set firsttime flag, used later to ensure spooler controls
;	int14 and int17 and etc., not MODE or PRINT which also
;	plug in higher in the chain (since they are installed
;	later.)
;...not used yet
iexit:	mov [firsttime],1
	jmp	cmdexit
;---TERMINATE (init error or other)---------------------
terminate:
;deactivate spooler
	mov	[iflag],spkill	;normal int17 and 14
	mov	[oflag],opause	;deactivate
	mov	si,offset cseg:msgterminate
	call	errormsg
;set proper return code (into orig es:bx)
terminate2:
	mov	ax,offset cseg:drvend
	mov	dx,cs			;dx:ax=end of driver
	call	setendaddr
	jmp	cmdexit
;....end of install code.............................
jspoolinit	endp
;initseg ends

;buffseg segment para ;public 'data'
;------DISK BUFFER AREA (aligned on paragraph)-----
;public buffer
buffer: 	;256 bytes used for cmmd line decoding
;	db	"DEVICE=jspool.bin 12k/cmmds;",0Dh,0Ah,0,0,0,0
;buffseg ends
;end
mainseg ends
end begin	;starting location=begin
